#include <stdio.h>
#include <stdlib.h>

#include "../inc/NSyslib.i586.h"
#include "../inc/pci.h"

unsigned long PCIMakeAdd( PciSubDevice *PciDev )
{
  return( ((PciDev->bus & 0xff) << 16) | ((PciDev->device & 0x1f) << 11) | ((PciDev->funtion & 0x07) << 8) | (PciDev->reg & 0xfc) | 0x80000000 ) ; 

}

unsigned char PciConfigReadByte(PciSubDevice *PciDev )
{

  OutPL(PCI_CONFIGADD , PCIMakeAdd(PciDev)) ; 
  return(InPB(PCI_CONFIGDATA + (PciDev->reg & 0x03))) ;
}

unsigned short PciConfigReadWord(PciSubDevice *PciDev )
{

  OutPL(PCI_CONFIGADD , PCIMakeAdd(PciDev)) ; 
  return(InPW(PCI_CONFIGDATA + (PciDev->reg & 0x02))) ;
}

unsigned long PciConfigReadLong(PciSubDevice *PciDev )
{

  OutPL(PCI_CONFIGADD , PCIMakeAdd(PciDev)) ; 
  return(InPL(PCI_CONFIGDATA)) ;
}


void PciConfigWriteByte(PciSubDevice *PciDev , unsigned char  data)
{
    
   OutPL(PCI_CONFIGADD  , PCIMakeAdd(PciDev)) ; 
   OutPB(PCI_CONFIGDATA + ( PciDev->reg & 0x03 ) , data) ; 
  
}

void PciConfigWriteWord(PciSubDevice *PciDev , unsigned short data)
{
  
   OutPL(PCI_CONFIGADD  , PCIMakeAdd(PciDev)) ; 
   OutPW(PCI_CONFIGDATA + ( PciDev->reg & 0x02 ) , data) ; 
  
}

void PciConfigWriteLong(PciSubDevice *PciDev , unsigned long  data)
{
  
   OutPL(PCI_CONFIGADD  , PCIMakeAdd(PciDev)) ; 
   OutPL(PCI_CONFIGDATA + ( PciDev->reg & 0x00 ) , data) ; 
  
}


void * PciFindCards(_cardlist * Cards) 
{

  unsigned long i ;
  void *FristCard = 0 ;

  PciSubDevice PciDev, *PciDevs = 0x00 , *nd = 0x00 ;

  printf("list at %8.8lX\n",(unsigned long) Cards) ;

  printf("bus:dev.fun  Vendor Device cmd  bass adds\n") ;

  for ( PciDev.bus = 0 ; PciDev.bus <= PCI_BusMax ; PciDev.bus++) 
    {
      for (  PciDev.device = 0 ;  PciDev.device <= PCI_DeviceMax ;  PciDev.device++)
	{
	  for (  PciDev.funtion = 0 ;  PciDev.funtion <= PCI_FuntionMax ;  PciDev.funtion++ )
	    {
	       PciDev.reg = PCI_RegVendorId ; PciDev.VendorId   = PciConfigReadWord(&PciDev) ;
	       PciDev.reg = PCI_RegDeviceId ; PciDev.DeviceId   = PciConfigReadWord(&PciDev) ;

	       if (1)
		 {
		 if (0) { printf("%2.2lX  %2.2lX  %1.1lX %4.4lX %4.4lX %4.4lX\n ",PciDev.bus,PciDev.device,PciDev.funtion,PciDev.VendorId,PciDev.DeviceId,PciDev.CommandReg) ;}
		 }
	       
	       for ( i = 0 ; Cards[i].VendorId != 0x0000 ; i++)
		 {
		   if ((PciDev.VendorId == Cards[i].VendorId) & (PciDev.DeviceId == Cards[i].DeviceId))
		     {
		      

		       PciDev.reg = PCI_RegCommand  ; PciDev.CommandReg = PciConfigReadWord(&PciDev) | 0x0002 ; PciConfigWriteWord(&PciDev,PciDev.CommandReg) ;


		       nd = (void *) calloc( 1 , sizeof(PciSubDevice)) ;
		    
		       if (!PciDevs) { PciDevs = nd ; FristCard = nd ; }
		       else
			 {
			   PciDevs->next = nd      ;
			   nd->last      = PciDevs ;
			   PciDevs       = nd      ;
			 }
		       PciDevs->VendorId = PciDev.VendorId ;
		       PciDevs->DeviceId = PciDev.DeviceId ;

		       PciDevs->bus      = PciDev.bus     ;
		       PciDevs->device   = PciDev.device  ;
		       PciDevs->funtion  = PciDev.funtion ;

		       PciDevs->CommandReg  = PciDev.CommandReg ;
		       		     
		       PciDevs->reg = PCI_RegBase0 ; PciDevs->PhysAdds[0] = PciConfigReadLong(PciDevs) & ~0x0f ;
		       PciDevs->reg = PCI_RegBase1 ; PciDevs->PhysAdds[1] = PciConfigReadLong(PciDevs) & ~0x0f ;
		       PciDevs->reg = PCI_RegBase2 ; PciDevs->PhysAdds[2] = PciConfigReadLong(PciDevs) & ~0x0f ;
		       PciDevs->reg = PCI_RegBase3 ; PciDevs->PhysAdds[3] = PciConfigReadLong(PciDevs) & ~0x0f ;
		       PciDevs->reg = PCI_RegBase4 ; PciDevs->PhysAdds[4] = PciConfigReadLong(PciDevs) & ~0x0f ;
		       PciDevs->reg = PCI_RegBase5 ; PciDevs->PhysAdds[5] = PciConfigReadLong(PciDevs) & ~0x0f ;
		       
		       
		      
		       printf("%2.2lX  %2.2lX  %1.1lX    %4.4lX   %4.4lX   %4.4lX ",PciDevs->bus,PciDevs->device,PciDevs->funtion,PciDevs->VendorId,PciDevs->DeviceId,PciDevs->CommandReg) ;
		       
		       for (i = 0 ; i < 6 ; i++ ) if (PciDevs->PhysAdds[i]) printf("%1.1lX:%8.8lX ",i,PciDevs->PhysAdds[i]) ;
		       
		       printf("\n") ;
		      
		     }
		 }
	    }
	}
    }
  printf("exiting PciFindCards %8.8lX\n",(unsigned long ) FristCard) ;
  return(FristCard) ;
}
