#include <stdio.h>
#include <stdlib.h>
#include <string.h> 
#include <linux/pci.h>
#include <unistd.h>
#include <sys/io.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "./i586/NSyslib.i586.h"
#include "./inc/pci.h"

#include "./inc/lexos2.h"

typedef struct
{
  _ObjHeader obj ;
} _DefaultObj ;

#include "obj.c"

extern _DriverInfo Nv04_DriverInfo ;

int  memDevFh     = 0 ;
char memDevName[] = "/dev/mem" ;


void * LEXOS_calloc(size)
{

  return(calloc(1 , size)) ;
}


void * LEXOS_MapPhys( unsigned long PhysAddr , unsigned long size )
{

  printf("LEXOS: MapPhys\n" ) ;

  return(mmap( 0x00000000 , size , PROT_READ | PROT_WRITE , MAP_SHARED , memDevFh , PhysAddr )) ; 

}








_DefaultObj *RootObj ;

_DriverInfo * DriverList[] = 
{ 
  &Nv04_DriverInfo,
  NULL  ,
} ;

void KernelCommandChannel()
{
}

void LoadDrivers()
{
  _CommandChannelData *cmdch ;

  PciSubDevice  *devs ;
  
  DriverList[0]->cmdch.OsCall = LEXOS_calloc( sizeof(_OsCalls)) ;
  
  DriverList[0]->cmdch.DriverToKernelChannel = KernelCommandChannel ;
  DriverList[0]->cmdch.OsCall->MapPhys       = LEXOS_MapPhys ;
  DriverList[0]->cmdch.OsCall->calloc        = LEXOS_calloc  ;
  DriverList[0]->cmdch.OsCall->NewCildObj    = NewCildObj    ;
  DriverList[0]->cmdch.OsCall->NewCildObjn   = NewCildObjn   ;
  DriverList[0]->cmdch.OsCall->RemoveObj     = RemoveObj     ;
  DriverList[0]->cmdch.OsCall->dumpobjlist   = dumpobjlist   ;
  
  DriverList[0]->root = (void *) RootObj ;

  cmdch = (void *) calloc( 1 , sizeof(_CommandChannelData)) ;
  
  devs = PciFindCards((void *) DriverList[0]->devs) ;
  if (devs) {
    cmdch->Command   = LEXOS_COMMAND_DRIVER_INIT_PCI_DEVICES ;
    cmdch->Pir       = 0x00000000 ;
    cmdch->MaxTime   = 0x00000000 ;
    cmdch->initPrams = devs ;
    
    cmdch->BaseTime  = GetCpuTime() ;
    DriverList[0]->cmdch.KernelToDriverChannel(cmdch) ;
  }
  else
    printf("no card found!\n") ;

}
 


int main()
{

  memDevFh = open( memDevName , O_RDWR ) ;


  iopl(3) ;

  RootObj = calloc( 1 , sizeof(_DefaultObj) ) ;

  RootObj->obj.name = "root" ;

  LoadDrivers() ;


  dumpobjlist((void *) RootObj) ;

  close (memDevFh) ;

  return(0) ;
}



