#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

typedef struct 
{ 
  unsigned long type ;
  unsigned long vn   ;
  NvF32 sx; 
  NvF32 sy; 
  NvF32 sz; 
  NvF32 rhw; 
  NvV32 color; 
  NvV32 specular; 
  NvF32 tu; 
  NvF32 tv; 
}  vertex ;

int  Load3D(_Nv04Device * nv , unsigned long i )
{

  vertex          *v    ;
  int           BLF  ;
  unsigned long  BBuffer[16],w , c ,a  ;
  unsigned long debug = 0x0001 ;
  


  
	    
	    BLF = open("/rsys/amber/lsys/a3/3DBufferq3.bin" ,O_RDONLY) ;

	    printf("BLF = %8.8X\n",BLF) ;

	  
	    printf("sizeof = %8.8X\n",sizeof(vertex)) ;
 loop1:

	    if ( (16 *4) != read(BLF , &BBuffer , 16 * 4)) 
	      {
		printf("EOF!\n") ; return(0) ;
	      }
	    
	    v = (void *) &BBuffer ;
	    
	    switch ( BBuffer[0] ) {
	    case 0x80000001:
	      
	      printf("Tri05 --------------------------------------------------- Setup\n") ;

	      Nv04_TestFifoFree( nv , i , 0x07 ) ;
	
	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.ColorKeyValue         =  BBuffer[1];
	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.TextureOffset         =  BBuffer[2] + 0x02000000 ; 
	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.TextureFormat         =  BBuffer[3] ;		    
	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.TextureFilter         =  BBuffer[4] ;
	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.Blend                 =  (BBuffer[5] & 0xffffffff) | 0x00000000 ;
	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.Control               =  BBuffer[6] ;
	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.FogColor              =  BBuffer[7] ;
	      
	

	      if (debug & 0x01)
		{
		  for (w = 0 ; w < 7 ; w++ ) printf("Tri05 Setup [%ld] %8.8lX\n",w,BBuffer[w + 1]) ;
		}

	      if(0) PrintCtx(nv) ;
	      dumpdma( nv ) ;

	      for (c = 0 ; c < ( 4 << 2) ; c++ ) { a = (( 0 ? NV04_PRAMIN ) + nv->CrUser->DmaCmd.DmaInst->base + ( c << 2)) ; printf("DmaInst[0x%8.8lX] = 0x%8.8lX\n",a,getreg(a)) ; }

	      getchar() ;

	      
	      break ;
	    case 0x80000002:
	    
	      if ( debug & 0x02) 
		{

		  printf("Tri05 Vertex[%ld]  x = %.2f   y = %.2f   z = %.2f   rhw = %f \n",BBuffer[1],v->sx,v->sy,v->sz,v->rhw) ;
		  printf("Tri05 Vertex[%ld] tu = %.4f  tv = %.4f  c = %8.8lX  s = %8.8lX\n",BBuffer[1],v->tu,v->tv,(unsigned long) v->color,(unsigned long) v->specular) ;
		}

	      Nv04_TestFifoFree( nv , i , 0x20 ) ;

	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.Tlvertex[BBuffer[1]].specular = v->specular ; 
	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.Tlvertex[BBuffer[1]].color    = v->color ;
	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.Tlvertex[BBuffer[1]].sx       = v->sx ; 
	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.Tlvertex[BBuffer[1]].sy       = v->sy ;
	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.Tlvertex[BBuffer[1]].sz       = v->sz ; 
	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.Tlvertex[BBuffer[1]].rhw      = v->rhw ; 
	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.Tlvertex[BBuffer[1]].tu       = v->tu ; 
	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.Tlvertex[BBuffer[1]].tv       = v->tv ;
	  
	      break ;
	    case 0x80000003:
	      if ( debug & 0x04) 
		{
		  printf("Tri05 Draw  %2.2ld , %2.2ld , %2.2ld\n",BBuffer[1] & 0x0f ,( BBuffer[1] >> 4 ) & 0x0f,( BBuffer[1] >> 8) & 0x0f ) ;
		}

	      Nv04_TestFifoFree( nv , i , 0x20 ) ;

	      nv->ch->subchannel[i].u.nv04Dx5TexturedTriangle.DrawPrimitive[0] = BBuffer[1] ;

	      Nv04_TestFifoFree( nv , i , 0x20 ) ;
	    
	      break;
	    default:
	      printf("error\n") ;
	      break ;
	    }
	    goto loop1 ;
	    

	    close(BLF) ;
}
