#define NV04_DMA_METHOD_OFFSET  12:2
#define NV04_DMA_SUBCH          15:13
#define NV04_DMA_METHOD_COUNT   24:18

#define NV04_DMA_SET_OBJECT     0x00000000 

#define Nv04_DMA_MAKE( SubCh , Method , MethodCount ) ( ( (MethodCount) << (0 ?  NV04_DMA_METHOD_COUNT)) | ( (SubCh) << ( 0 ? NV04_DMA_SUBCH )) | (  ( (Method) >> 2) << ( 0 ? NV04_DMA_METHOD_OFFSET)))

void Nv04_DoDma(_Nv04Device *nv , _Nv04_VideoUser * user )
{
  unsigned long a ,d , i ,c , gi ,t ,in , cacheData ;

  printf("ready to set dma  Get = 0x%8.8lX Put = 0x%8.8lX\n",user->DmaCmd.Get,user->DmaCmd.Put) ;

  if(0) 
    {
      Nv04_DmaPio( nv , user) ;
      getchar() ;
      return ;
    }

 loop4:
  
  t = getreg(NV_PFIFO_CACHE1_DMA_PUSH) & 0x0110 ;
  if ( (!( t & 0x0100)) & (t & 0x0010))  
    {      
      printf("fault\n") ;
      getchar() ; 
      goto loop4 ;
    }
  
  Nv04_PrintReg( NV_PFIFO_INTR_0 , getreg( NV_PFIFO_INTR_0 ) , 1 , "Nv04: ") ; 

  printf("\n") ;



  printf("\n") ;

  in = getreg( NV_PFIFO_INTR_0) ; 
  if ( 0 )
    {
      printf("RUNOUT\n") ;
      setreg( NV_PFIFO_CACHES , modbits( 0x00 , NV_PFIFO_CACHES_REASSIGN , NV_PFIFO_CACHES_REASSIGN_DISABLED )) ;
      
      setreg( NV_PFIFO_INTR_0 , modbits( 0x00 , NV_PFIFO_INTR_0_RUNOUT   , NV_PFIFO_INTR_0_RUNOUT_RESET ) ) ; 
      
      if (0) 
	{
	  setreg( NV_PFIFO_CACHE1_PUSH0   , NV_PFIFO_CACHE1_PUSH0_ACCESS_DISABLED   << ( 0 ? NV_PFIFO_CACHE1_PUSH0_ACCESS ) ) ;
	  setreg( NV_PFIFO_CACHE1_PULL0   , NV_PFIFO_CACHE1_PULL0_ACCESS_DISABLED   << ( 0 ? NV_PFIFO_CACHE1_PULL0_ACCESS ) ) ;
	}
      dumpRegs(nv , fifo_runout ) ;
      
    loop2:
      gi = getreg( NV_PFIFO_RUNOUT_GET ) ; 
      i = nv->info.RunOutRamMem->base + gi ; 
      
      for( c = 0 ; c < 2 ; c++ ) printf("Nv04: Runout [0x%8.8lX] = 0x%8.8lX\n", i + (c << 2) , getreg( ( 0 ? NV04_PRAMIN ) + i + ( c << 2))) ; 
      
      setreg( NV_PFIFO_RUNOUT_GET , gi + (2 * 4)) ;

      if ( getreg( NV_PFIFO_RUNOUT_PUT) != getreg( NV_PFIFO_RUNOUT_GET )) goto loop2 ;
     

      if(0)
	{
	  setreg( NV_PFIFO_CACHE1_DMA_PUSH       , NV_PFIFO_CACHE1_DMA_PUSH_ACCESS_ENABLED << ( 0 ? NV_PFIFO_CACHE1_DMA_PUSH_ACCESS ) ) ;
	  setreg( NV_PFIFO_CACHE1_PULL0          , NV_PFIFO_CACHE1_PULL0_ACCESS_ENABLED    << ( 0 ? NV_PFIFO_CACHE1_PULL0_ACCESS ) ) ;
	  setreg( NV_PFIFO_CACHE1_PUSH0          , NV_PFIFO_CACHE1_PUSH0_ACCESS_ENABLED    << ( 0 ? NV_PFIFO_CACHE1_PUSH0_ACCESS ) ) ;
	}
      setreg( NV_PFIFO_CACHES , modbits( 0x00 , NV_PFIFO_CACHES_REASSIGN , NV_PFIFO_CACHES_REASSIGN_DISABLED )) ;
      
      getchar() ;
    }

  if(in & 0x1000)
    {
      printf("dma pusher error\n") ;
      dumpRegs(nv , dmastatus ) ; 

      if(1) for( i = (getreg( NV_PFIFO_CACHE1_DMA_GET) >> 2) - 0x10 ;  i < ((getreg( NV_PFIFO_CACHE1_DMA_GET) >> 2) + 0x10) ; i = (i + 1)  & user->DmaCmd.BufferMask ) printf("DmaBuffer[0x%8.8lX] =0x%8.8lX\n", (i << 2) , user->DmaCmd.Buffer[i] ) ;
      
      Nv04_PrintPGRAPH(nv) ;

    loop5:
      goto loop5 ;
    }
  

 
  if(0) for( i = user->DmaCmd.Get ; i < user->DmaCmd.Put ; i = (i + 1) ) printf("DmaBuffer[0x%8.8lX] =0x%8.8lX\n", (i << 2) , user->DmaCmd.Buffer[i] ) ;

 
  cacheData = getreg( NV_PFIFO_CACHES ) ;
  setreg( NV_PFIFO_CACHES , modbits( 0x00 , NV_PFIFO_CACHES_REASSIGN , NV_PFIFO_CACHES_REASSIGN_DISABLED )) ;

  
  setreg( NV_PFIFO_CACHE1_PUSH0      , NV_PFIFO_CACHE1_PUSH0_ACCESS_DISABLED       << ( 0 ? NV_PFIFO_CACHE1_PUSH0_ACCESS ) ) ;
  setreg( NV_PFIFO_CACHE1_DMA_PUSH   , NV_PFIFO_CACHE1_DMA_PUSH_ACCESS_DISABLED    << ( 0 ? NV_PFIFO_CACHE1_DMA_PUSH_ACCESS ) ) ;      
  setreg( NV_PFIFO_CACHE1_PULL0      , NV_PFIFO_CACHE1_PULL0_ACCESS_DISABLED       << ( 0 ? NV_PFIFO_CACHE1_PULL0_ACCESS ) ) ;
  

  setreg( NV_PFIFO_CACHE1_DMA_PUT        ,  user->DmaCmd.Put << 2) ;
  setreg( NV_PFIFO_CACHE1_DMA_GET        ,  user->DmaCmd.Get << 2) ;
  /* 
     setreg( NV_PFIFO_CACHE1_DMA_INSTANCE   ,  user->DmaCmd.DmaInst->base  >> 4  ) ; 
 
     setreg( NV_PFIFO_CACHE1_DMA_CTL        ,  0x00000000 ) ;
     setreg( NV_PFIFO_CACHE1_DMA_STATE      ,  0x00000000 ) ;
     setreg( NV_PFIFO_CACHE1_ENGINE         ,  0x00000000 ) ;
     setreg( NV_PFIFO_CACHE1_DMA_TLB_TAG    ,  0x00000000 ) ;
     setreg( NV_PFIFO_CACHE1_DMA_TLB_PTE    ,  0x00000000 ) ;
  
     setreg( NV_PFIFO_CACHE1_DMA_FETCH      , ( 0x0d << 3) | ( 0x03 << 13 ) | ( 0x04 << 16) ) ;
  */

  setreg( NV_PFIFO_CACHE1_DMA_LIMIT  , user->DmaCmd.mem.Limit + 1 ) ;
  
  if(1) 
    dumpRegs(nv , fifoDmaRegsTableA ) ;
  else
    getchar() ;

  if(0)
    for ( i = 0 ; i < 256 ; i++ ) 
      {
	a =  getreg( NV_PFIFO_CACHE1_METHOD(i)) ; d = getreg( NV_PFIFO_CACHE1_DATA(i)) ; 
		    printf("Nv04: PFIFO_CACHE1 [0x%4.4lX] = SubCh %1.1lX Method 0x%8.8lX Data 0x%8.8lX\n",i << 3 , ((a >> 13) & 0x07) , ( a & 0xffff1ffc ) , d) ;
      }
  


  setreg( NV_PFIFO_CACHE1_DMA_PUSH       , NV_PFIFO_CACHE1_DMA_PUSH_ACCESS_ENABLED << ( 0 ? NV_PFIFO_CACHE1_DMA_PUSH_ACCESS ) ) ;
  setreg( NV_PFIFO_CACHE1_PULL0          , NV_PFIFO_CACHE1_PULL0_ACCESS_ENABLED    << ( 0 ? NV_PFIFO_CACHE1_PULL0_ACCESS ) ) ;
  setreg( NV_PFIFO_CACHE1_PUSH0          , NV_PFIFO_CACHE1_PUSH0_ACCESS_ENABLED    << ( 0 ? NV_PFIFO_CACHE1_PUSH0_ACCESS ) ) ;
  
  setreg( NV_PFIFO_CACHES , cacheData ) ;

  if(1)
    {
      c=0 ;
    loop20:
      i = getreg( NV_PFIFO_CACHE1_DMA_PUSH) ;
      if ( ((i & 0x0100) == 0x0000) | ( i & 0x0010 ) ) 
	{ 
	  printf("c = %ld\n",c) ;
	  
	  printf("dma end\n") ;
	  if(!(i&1)) 
	    {
	      for (i = 0 ; i < (user->DmaCmd.PtCount + 4) ; i++ ) { a = (( 0 ? NV04_PRAMIN ) + user->DmaCmd.DmaInst->base + ( i << 2)) ; printf("DmaInst[0x%8.8lX] = 0x%8.8lX\n",a,getreg(a)) ; }
	      printf("DMA:FALUT!\n") ;
	      setreg( NV_PFIFO_CACHE1_PUSH0      , NV_PFIFO_CACHE1_PUSH0_ACCESS_DISABLED       << ( 0 ? NV_PFIFO_CACHE1_PUSH0_ACCESS ) ) ;
	      setreg( NV_PFIFO_CACHE1_DMA_PUSH   , NV_PFIFO_CACHE1_DMA_PUSH_ACCESS_DISABLED    << ( 0 ? NV_PFIFO_CACHE1_DMA_PUSH_ACCESS ) ) ;      
	      setreg( NV_PFIFO_CACHE1_PULL0      , NV_PFIFO_CACHE1_PULL0_ACCESS_DISABLED       << ( 0 ? NV_PFIFO_CACHE1_PULL0_ACCESS ) ) ;
	      
	      if(1) dumpRegs(nv , fifoDmaRegsTable ) ;
	      if(1) Nv04_PrintPGRAPH(nv) ;

	      if(1)
		for ( i = 0 ; i < 256 ; i++ ) 
		  {
		    a =  getreg( NV_PFIFO_CACHE1_METHOD(i)) ; d = getreg( NV_PFIFO_CACHE1_DATA(i)) ; 
		    printf("Nv04: PFIFO_CACHE1 [0x%4.4lX] = SubCh %1.1lX Method 0x%8.8lX Data 0x%8.8lX\n",i << 3 , ((a >> 13) & 0x07) , ( a & 0x1ffc ) , d) ;
		  }
	      
	    l10:
	      goto l10 ;
	      getchar() ;
	    } 
	  c++ ; goto loop20 ; 
	}
    }

  


  user->DmaCmd.Get = user->DmaCmd.Put ;
  
  if(getreg(( 0 ? NV04_PRAMIN ) + user->DmaCmd.DmaInst->base)  != 0x00031000 ) getchar() ;
  getchar() ;
}


void TestDma(_Nv04Device * nv , _Nv04_VideoUser * user)
{
  unsigned long i , Obj , sx,sy,dx,dy,x,y ;
  

  
  i = 3 ; Obj = Nv04_NV01_IMAGE_BLIT ;
  
  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = Nv04_DMA_MAKE( i , NV04_DMA_SET_OBJECT , 0x0001 ) ;
  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = Obj ;

  sx =  50 ; sy = 100 ;
  dx = 400 ; dy = 200 ;
  x  = 250 ; y  = 250 ;
  
  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = Nv04_DMA_MAKE( i , 0x300  , 0x0003 ) ;
  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = sx | ( sy << 16 ) ;
  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = dx | ( dy << 16 ) ;
  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] =  x | (  y << 16 ) ;

  if(1) Nv04_DoDma( nv , user ) ;

  sx =  50 ; sy = 100 ;
  dx = 600 ; dy = 400 ;
  x  = 250 ; y  = 250 ;
  
  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = Nv04_DMA_MAKE( i , 0x300  , 0x0003 ) ;
  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = sx | ( sy << 16 ) ;
  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = dx | ( dy << 16 ) ;
  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] =  x | (  y << 16 ) ;
  
  if(1) Nv04_DoDma( nv , user ) ;

    if(1)
    {
      i = 2 ; Obj = Nv04_NV01_RENEDR_SOLID_RECATANGLE ;
      
      user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = Nv04_DMA_MAKE( i , NV04_DMA_SET_OBJECT , 0x0001 ) ;
      user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = Obj ;
      
      sx = 100 ; sy = 100 ;
      x = 250 ;  y = 250 ;
  
      user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = Nv04_DMA_MAKE( i , 0x304 , 0x0001 ) ;
      user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = 0x000040a0 ;
      user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = Nv04_DMA_MAKE( i , 0x400 , 0x0002 ) ;  
      user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = sx | ( sy << 16 ) ;
      user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] =  x | (  y << 16 ) ;
      
      
      if(1) {  user->DmaCmd.Get = 0x00000000 ; Nv04_DoDma( nv , user ) ; user->DmaCmd.Put = 0x00000000 ; }
    }
    
}

void Nv04Test3dDma( _Nv04Device *nv , _Nv04_VideoUser *user )
{

  unsigned long i , Obj , status , demoBuffer[16] , c = 0 ;
  int   demoFile ;
  char *demoFileName = "/rsys/amber/lsys/a3/3DBufferq3.bin" ;


  demoFile = open( demoFileName , O_RDONLY ) ;
  if ( demoFile == -1 ) { printf("error open demofile  %s %d %s\n", demoFileName , errno , strerror(errno)) ; return ; }

  i = 7 ; Obj = 0x80000014 ;
  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = Nv04_DMA_MAKE( i , NV04_DMA_SET_OBJECT , 0x0001 ) ;
  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = Obj ;
  
  if(0) Nv04_DoDma( nv , user ) ;

 loop1:
  status = read( demoFile , &demoBuffer , sizeof(demoBuffer)) ; 
  if (status != sizeof(demoBuffer))
      {
	printf("EOF!\n") ;
	return ;
      }
      
  if((user->DmaCmd.Put + 8) >= (user->DmaCmd.BufferMask + 1)) { printf("OVERFLOW!\n") ; getchar() ; user->DmaCmd.Get = 0x00000000 ; Nv04_DoDma( nv , user ) ; user->DmaCmd.Put = 0x00000000 ; }
 
  if (status == sizeof(demoBuffer))
    {  
      switch (demoBuffer[0])
	{
	case 0x80000001:
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = Nv04_DMA_MAKE( i , 0x0300 , 0x0007 ) ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[1] ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[2] + 0x02000000 ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[3] ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[4] ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[5] ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[6] ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[7] ;

	  c++ ; if(1) {  user->DmaCmd.Get = 0x00000000 ; Nv04_DoDma( nv , user ) ; user->DmaCmd.Put = 0x00000000 ; c = 0 ; } 
	  break ;

	case 0x80000002:
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = Nv04_DMA_MAKE( i , 0x0400 + (demoBuffer[1] * 0x20) , 0x0008 ) ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[2] ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[3] ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[4] ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[5] ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[6] ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[7] ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[8] ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[9] ;
	
	  if(0) Nv04_DoDma( nv , user ) ;
       

	  break ;


	case 0x80000003:
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = Nv04_DMA_MAKE( i , 0x0600  , 0x0001 ) ;
	  user->DmaCmd.Buffer[user->DmaCmd.Put++ & user->DmaCmd.BufferMask] = demoBuffer[1] ;
	
	  if(0) Nv04_DoDma( nv , user ) ;
      

	  break ;
	}
      goto loop1 ;
    }

}
