
#define GrObj_Function_Alloc   0x00002000 
#define GrObj_Function_UnAlloc 0x00002001 
#define GrObj_Function_Service 0x00002002

#define MakeCtxDma_TypeNVM 0x00000000
#define MakeCtxDma_TypeDMA 0x00000001

typedef struct
{
  unsigned long  GrClass        ;
  unsigned long  ChromaKey      ;
  unsigned long  UserClip       ;
  unsigned long  Swizzle        ;
  unsigned long  PatchConfig    ;
  unsigned long  PatchStatus    ;
  unsigned long  ContextSurface ;
  unsigned long  VolatileRest   ;

  unsigned long  MonoFormat     ;
  unsigned long  ColorFormat    ;
  unsigned long  NotifyInst     ;

  unsigned long  DmaInst0       ;
  unsigned long  DmaInst1       ;

  unsigned long  UserInst       ;
} _Nv04_ctx ;
  

typedef struct 
{
  unsigned long  ObjId   ;
  unsigned long  GrClass ;
  void (* Service ) ( _Nv04Device      *nv    ,  
		      _Nv04_VideoUser  *user  , 
		      void             *obj   ,
		      void             *grObj ,  
		      unsigned long     Function 
		      ) ;
  unsigned char *Name ;
} _Nv04_GrObjects ;

typedef struct
{
  _ObjHeader        obj         ;
  unsigned long     ObjId       ;
  unsigned long     hashPointer ;
  _MemInstance     *InstMem         ;
  _Nv04_GrObjects  *ObjInfo     ;
} _Nv04_GrObj ;




_Nv04_GrObj * Nv04_Service_NV01_RENDER_SOLID_LINE( _Nv04Device      *nv    ,  
						   _Nv04_VideoUser  *user  , 
						   _Nv04_GrObjects  *obj   ,
						   _Nv04_GrObj      *grObj ,  
						   unsigned long     Function 
						   )
{ 
  _Nv04_GrObj * GrObj ;

  switch( Function )
    {
    case GrObj_Function_Alloc:      
      if ( Nv04_GetHashAddr(nv ,  obj->ObjId) ) return( NULL ) ;
      
      GrObj              = os->NewCildObjn( nv->EObj , sizeof (_Nv04_GrObj) , obj->Name ) ;
      GrObj->ObjInfo     = obj ;
      GrObj->InstMem     = Nv04_AllocLocalMem( nv->info.Pramin , 0x10  , 0x00 , 0xffffffff , GrObj->ObjInfo->Name ) ;
      
      GrObj->ObjId       = obj->ObjId ;
      GrObj->hashPointer = nv->info.HashMem->base + (HASH_CHID0(GrObj->ObjId) * 8 ) ;

      printf("obj id = 0x%8.8lX hash = 0x%8.8lX\n",GrObj->ObjId , GrObj->hashPointer) ;

      /* put into hase table */
      setreg((0 ? NV04_PRAMIN) + GrObj->hashPointer   + 0x00000000 , GrObj->ObjId              ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->hashPointer   + 0x00000004 , GrObj->InstMem->base >> 4 | 0x80010000 ) ;
      
      /* put obj into instance mem */
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x00000000 ,  GrObj->ObjInfo->GrClass | 0x01000000 | ( 0x00 << 15) ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x00000004 , 0x00000e02 ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x00000008 , 0x00000000 ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x0000000c , 0x00000000 ) ;
      
      return(GrObj) ;


    case GrObj_Function_UnAlloc:

    case GrObj_Function_Service:
    } ;
  return(NULL) ;
}
_Nv04_GrObj * Nv04_Service_NV01_RENDER_SOLID_RECATANGLE( _Nv04Device      *nv    ,  
							 _Nv04_VideoUser  *user  , 
							 _Nv04_GrObjects  *obj   ,
							 _Nv04_GrObj      *grObj ,  
							 unsigned long     Function 
							 )
{ 
  _Nv04_GrObj * GrObj ;

  switch( Function )
    {
    case GrObj_Function_Alloc:      
      if ( Nv04_GetHashAddr(nv ,  obj->ObjId) ) return( NULL ) ;
      
      GrObj              = os->NewCildObjn( nv->EObj , sizeof (_Nv04_GrObj) , obj->Name ) ;
      GrObj->ObjInfo     = obj ;
      GrObj->InstMem     = Nv04_AllocLocalMem( nv->info.Pramin , 0x10  , 0x00 , 0xffffffff , GrObj->ObjInfo->Name ) ;
      
      GrObj->ObjId       = obj->ObjId ;
      GrObj->hashPointer = nv->info.HashMem->base + (HASH_CHID0(GrObj->ObjId) * 8 ) ;

      printf("obj id = 0x%8.8lX hash = 0x%8.8lX\n",GrObj->ObjId , GrObj->hashPointer) ;

      /* put into hase table */
      setreg((0 ? NV04_PRAMIN) + GrObj->hashPointer   + 0x00000000 , GrObj->ObjId              ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->hashPointer   + 0x00000004 , GrObj->InstMem->base >> 4 | 0x80010000 ) ;
      
      /* put obj into instance mem */
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x00000000 ,  GrObj->ObjInfo->GrClass | 0x01000000 | ( 0x00 << 15) ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x00000004 , 0x00000e02 ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x00000008 , 0x00000000 ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x0000000c , 0x00000000 ) ;
      
      return(GrObj) ;


    case GrObj_Function_UnAlloc:

    case GrObj_Function_Service:
    } ;
  return(NULL) ;
}
_Nv04_GrObj * Nv04_Service_NV01_RENDER_SOLID_TRIANGLE( _Nv04Device      *nv    ,  
						       _Nv04_VideoUser  *user  , 
						       _Nv04_GrObjects  *obj   ,
						       _Nv04_GrObj      *grObj ,  
						       unsigned long     Function 
						       )
{ 
  _Nv04_GrObj * GrObj ;

  switch( Function )
    {
    case GrObj_Function_Alloc:      
      if ( Nv04_GetHashAddr(nv ,  obj->ObjId) ) return( NULL ) ;
      
      GrObj              = os->NewCildObjn( nv->EObj , sizeof (_Nv04_GrObj) , obj->Name ) ;
      GrObj->ObjInfo     = obj ;
      GrObj->InstMem     = Nv04_AllocLocalMem( nv->info.Pramin , 0x10  , 0x00 , 0xffffffff , GrObj->ObjInfo->Name ) ;
      
      GrObj->ObjId       = obj->ObjId ;
      GrObj->hashPointer = nv->info.HashMem->base + (HASH_CHID0(GrObj->ObjId) * 8 ) ;

      printf("obj id = 0x%8.8lX hash = 0x%8.8lX\n",GrObj->ObjId , GrObj->hashPointer) ;

      /* put into hase table */
      setreg((0 ? NV04_PRAMIN) + GrObj->hashPointer   + 0x00000000 , GrObj->ObjId              ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->hashPointer   + 0x00000004 , GrObj->InstMem->base >> 4 | 0x80010000 ) ;
      
      /* put obj into instance mem */
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x00000000 ,  GrObj->ObjInfo->GrClass | 0x01000000 | ( 0x00 << 15) ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x00000004 , 0x00000e02 ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x00000008 , 0x00000000 ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x0000000c , 0x00000000 ) ;
      
      return(GrObj) ;


    case GrObj_Function_UnAlloc:

    case GrObj_Function_Service:
    } ;
  return(NULL) ;
}

_Nv04_GrObj * Nv04_Service_NV01_IMAGE_BLIT( _Nv04Device     *nv    ,  
					    _Nv04_VideoUser  *user  , 
					    _Nv04_GrObjects  *obj   ,
					    _Nv04_GrObj      *grObj ,  
					    unsigned long     Function 
					    )
{ 
  _Nv04_GrObj * GrObj ;
  switch( Function )
    {
    case GrObj_Function_Alloc:      
      if ( Nv04_GetHashAddr(nv ,  obj->ObjId ) ) return( NULL ) ;
      
      GrObj              = os->NewCildObjn( nv->EObj , sizeof (_Nv04_GrObj) , obj->Name ) ;
      GrObj->ObjInfo     = obj ;
      GrObj->InstMem     = Nv04_AllocLocalMem( nv->info.Pramin , 0x10  , 0x00 , 0xffffffff , GrObj->ObjInfo->Name ) ;
      
      GrObj->ObjId       =  obj->ObjId ;
      GrObj->hashPointer = nv->info.HashMem->base + ( HASH_CHID0(GrObj->ObjId) * 8 ) ;

      /* put into hase table */
      setreg((0 ? NV04_PRAMIN) + GrObj->hashPointer   + 0x00000000 , GrObj->ObjId              ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->hashPointer   + 0x00000004 , ( GrObj->InstMem->base >> 4 ) | 0x80010000 ) ;
      
      /* put obj into instance mem */
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x00000000 , GrObj->ObjInfo->GrClass | 0x01000000 | ( 0x00 << 15)) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x00000004 , 0x00000e02 ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x00000008 , 0x00000000 ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x0000000c , 0x00000000 ) ;
      
      return(GrObj) ;


    case GrObj_Function_UnAlloc:

    case GrObj_Function_Service:
    } ;
  return(NULL) ;
}

_Nv04_GrObj * NV04_Service_NV04_DX5_TEXTURED_TRIANGLE( _Nv04Device     *nv    ,  
						       _Nv04_VideoUser  *user  , 
						       _Nv04_GrObjects  *obj   ,
						       _Nv04_GrObj      *grObj ,  
						       unsigned long     Function 
						       )
{ 
  _Nv04_GrObj * GrObj ;
  
  switch( Function )
    {
    case GrObj_Function_Alloc:      
      if ( Nv04_GetHashAddr(nv ,  obj->ObjId ) ) return( NULL ) ;
      
      GrObj              = os->NewCildObjn( nv->EObj , sizeof (_Nv04_GrObj) , obj->Name ) ;
      GrObj->ObjInfo     = obj ;
      GrObj->InstMem     = Nv04_AllocLocalMem( nv->info.Pramin , 0x10  , 0x00 , 0xffffffff , GrObj->ObjInfo->Name ) ;
      
      GrObj->ObjId       =  obj->ObjId ;
      GrObj->hashPointer = nv->info.HashMem->base + ( HASH_CHID0(GrObj->ObjId) * 8 ) ;

      /* put into hase table */
      setreg((0 ? NV04_PRAMIN) + GrObj->hashPointer   + 0x00000000 , GrObj->ObjId              ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->hashPointer   + 0x00000004 , ( GrObj->InstMem->base >> 4 ) | 0x80010000 ) ;
      
      /* put obj into instance mem */
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x00000000 , GrObj->ObjInfo->GrClass | 0x03000000 | ( 0x00 << 15)) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x00000004 , 0x00000e02 ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x00000008 , 0x00000000 ) ;
      setreg((0 ? NV04_PRAMIN) + GrObj->InstMem->base + 0x0000000c , 0x00000000 ) ;
      
      return(GrObj) ;


    case GrObj_Function_UnAlloc:

    case GrObj_Function_Service:
    } ;
  return(NULL) ;
}

#define Nv04_NV01_RENEDR_SOLID_LINE        0x80000000 
#define Nv04_NV01_RENEDR_SOLID_TRIANGLE    0x80000001
#define Nv04_NV01_RENEDR_SOLID_RECATANGLE  0x80000002
#define Nv04_NV01_IMAGE_BLIT               0x80000003
#define Nv04_NV01_IMAGE_FROM_CPU           0x80000004
#define Nv04_NV03_STRETCHED_IMAGE_FROM_CPU 0x80000005
#define Nv04_NV03_SCALED_IMAGE_FROM_MEMORY 0x80000006
#define Nv04_NV03_DX3_TEXTURED_TRIANGLE    0x80000007
#define Nv04_NV03_GDI_RECTANGLE_TEXT       0x80000009
#define Nv04_NV04_CONTEXT_SURFACES_3D      0x8000000a
#define Nv04_NV04_DX5_TEXTURED_TRIANGLE    0x8000000b
#define Nv04_NV03_CONTEXT_SURFACES_2D      0x8000000c
#define Nv04_NV03_CONTEXT_SURFACES_3D      0x8000000d
#define Nv04_NV04_IMAGE_BLIT               0x8000000c

_Nv04_GrObjects AlObjs[] =
{ 
  { Nv04_NV01_RENEDR_SOLID_LINE         , 0x0000001c , Nv04_Service_NV01_RENDER_SOLID_LINE        , "NV01_RENDER_SOLID_LINE"        }, 
  { Nv04_NV01_RENEDR_SOLID_TRIANGLE     , 0x0000001d , Nv04_Service_NV01_RENDER_SOLID_TRIANGLE    , "NV01_RENDER_SOLID_TRIANGLE"    },
  { Nv04_NV01_RENEDR_SOLID_RECATANGLE   , 0x0000001e , Nv04_Service_NV01_RENDER_SOLID_RECATANGLE  , "NV01_RENDER_SOLID_RECATANGLE"  },
  { Nv04_NV01_IMAGE_BLIT                , 0x0000001f , Nv04_Service_NV01_IMAGE_BLIT               , "NV01_IMAGE_BLIT"               },
  /*
  { Nv04_NV01_IMAGE_FROM_CPU            , 0x00000021 , Nv04_Service_NV01_IMAGE_FROM_CPU           , "NV01_IMAGE_FROM_CPU"           },
  { Nv04_NV03_STRETCHED_IMAGE_FROM_CPU  , 0x00000036 , Nv04_Service_NV03_STRETCHED_IMAGE_FROM_CPU , "NV03_STRETCHED_IMAGE_FROM_CPU" },
  { Nv04_NV03_SCALED_IMAGE_FROM_MEMORY  , 0x00000037 , Nv04_Service_NV03_SCALED_IMAGE_FROM_MEMORY , "NV03_SCALED_IMAGE_FROM_MEMORY" },
  { Nv04_NV03_DX3_TEXTURED_TRIANGLE     , 0x00000048 , Nv04_Service_NV03_DX3_TEXTURED_TRIANGLE    , "NV03_DX3_TEXTURED_TRIANGLE"    },
  { Nv04_NV03_GDI_RECTANGLE_TEXT        , 0x0000004b , Nv04_Service_NV03_GDI_RECTANGLE_TEXT       , "NV03_GDI_RECTANGLE_TEXT"       },
  { Nv04_NV04_CONTEXT_SURFACES_3D       , 0x00000053 , Nv04_Service_NV04_CONTEXT_SURFACES_3D      , "NV04_CONTEXT_SURFACES_3D"      },
  { Nv04_NV04_DX5_TEXTURED_TRIANGLE     , 0x00000054 , Nv04_Service_NV04_DX5_TEXTURED_TRIANGLE    , "NV04_DX5_TEXTURED_TRIANGLE"    },
  { Nv04_NV03_CONTEXT_SURFACES_2D       , 0x00000058 , Nv04_Service_NV03_CONTEXT_SURFACES_2D      , "NV03_CONTEXT_SURFACES_2D"      },
  { Nv04_NV03_CONTEXT_SURFACES_3D       , 0x0000005A , Nv04_Service_NV03_CONTEXT_SURFACES_3D      , "NV03_CONTEXT_SURFACES_3D"      },
  { Nv04_NV04_IMAGE_BLIT                , 0x0000005f , Nv04_Service_NV04_IMAGE_BLIT               , "NV04_IMAGE_BLIT"               } 
  */
} ;


void Nv04_SetGrObjects(_Nv04Device *nv , _Nv04_VideoUser *user )
{
  unsigned long i , n ;

  n = sizeof(AlObjs) / sizeof(_Nv04_GrObjects) ;

  for( i = 0 ; i < n ; i++ )
    AlObjs[i].Service(nv , user , &AlObjs[i] , 0x00 , GrObj_Function_Alloc ) ;


}
