#include "newregs.h"
#include "nv04func.h"


typedef struct
{
  unsigned long DisplayX ;
  unsigned long DisplayY ;
  unsigned long Flags    ;

  double PixelClock ;
  double HSync      ;
  double HSyncStart ;
  double HSyncTime  ;

  double VSync      ;
  double VSyncStart ;
  double VSyncTime  ;
} _TimingData ;


typedef struct
{
  double PixelClock ;

  double HSync      ;
  double HSyncStart ;
  double HSyncTime   ;

  double VSync      ;
  double VSyncStart ;
  double VSyncTime   ;
} _VideoTimeing ;



typedef struct
{
  _MemInstance  *DmaInst     ;
  unsigned long  PtCount     ;
  _MemObj        mem         ;
  unsigned long  BufferMask  ;
  unsigned long *Buffer      ;
  unsigned long  Put         ;
  unsigned long  Get         ;


} _Nv04DmaCmdRingBuffer ;


 typedef struct
{
  _ObjHeader    obj ;
  unsigned long X ;
  unsigned long Y ;
 
  unsigned long ViewX ;
  unsigned long ViewY ;

  unsigned long ColourDepth ;

  unsigned long BytesPerPixel ;
  unsigned long BytesPerLine  ;

  unsigned long LocalRamTotal ;
  unsigned long LocalRamFree  ;

  _MemInstance  *Screen       ;
  _MemInstance  *BackBuffer   ;
  _MemInstance  *ZBuffer      ;
  _MemInstance  *TexturCache  ;
  _MemInstance  *FontCache    ;

  _MemObj        TexturBuffer ;

  _MemInstance  *CtxDmaTexturCache  ;
  _MemInstance  *CtxDmaTexturBuffer ;


  _VideoTimeing Timing    ;
  
  unsigned long Palette[0x100] ;
  

  void                  *Funtions ;
  _Nv04DmaCmdRingBuffer  DmaCmd   ;

} _Nv04_VideoUser ;

typedef struct
{
  unsigned long Mode ;
  unsigned long Size ;
  unsigned long AllocateCount ;
  
} _Fifo ;

typedef struct
{
  _ObjHeader     obj     ;
  _MemInstance  *InstMem ;
  unsigned char *name    ;
  
} _EngObj ;




typedef struct
{
  _MemHeader  *Fb     ;
  _MemObj      Regs   ;
  _MemHeader  *Pramin ;

  _Fifo        Fifo ;
 

  unsigned long  HashTableSize ;
  _MemInstance  *HashMem       ;

  unsigned long  FifoContextRamSize ;
  _MemInstance  *FifoContextMem      ;

  unsigned long  RunOutRamSize ;
  unsigned long  RunOutRamMask ;
  _MemInstance  *RunOutRamMem  ;

  unsigned long InstanceRamBase ;
  unsigned long InstanceRamSize ;


} _Nv04Info ;

#define Nv04_DMA_BUS_NONE 0x00000000 
#define Nv04_DMA_BUS_PCI  0x00000001 
#define Nv04_DMA_BUS_AGP  0x00000002 



typedef struct
{
  _ObjHeader       obj ;
  unsigned long    DmaMode ;
  unsigned long   *Fb      ;
  unsigned long   *Regs    ;
  unsigned long   *PRamIn  ;
  _MemHeader       CachedFbObj     ;
  _MemHeader       CachedPraminObj ;
  _Nv04Info        info ;
  _Nv04_VideoUser *CrUser   ;   
  _Nv04_VideoUser *Users ;
  _EngObj          *EObj ;
  Nv006aChannel    *ch  ;
  int               memFile ;
} _Nv04Device ;
