
_MemInstance * Nv04_AllocLocalMem( _MemHeader *mem , unsigned long size , unsigned long aline , unsigned long limit , unsigned char * name )
{
  unsigned long rsize ;
  _MemInstance *MInst ,* NewMInst ;
   

  LEXOS_ENABLE_SMP_LOCK( mem.obj->smp_lock ) ;
  

  if ( mem->Free < size) 
    {
      printf("NV04: out of local mem reqSize = 0x%8.8lX  Free = 0x%8.8lX  %s\n",size ,mem->Free,name) ;
      return(0) ;
    }
 
  MInst = (void *) mem->obj.childlist ;


 loop1:
  if (MInst) 
    {
      rsize = MInst->size ;
      if ( (rsize >= size) & ( MInst->flags == LEXOS_MEM_INSTANCE_FREE ))
	{
     
	  MInst->size  = size ; rsize = rsize - size ;
	  MInst->flags = LEXOS_MEM_INSTANCE_INUSE    ;
	  
	  if ( rsize )
	       {	    
		 NewMInst        = os->NewCildObjn( mem , sizeof(_MemInstance) , "free" ) ;
		 NewMInst->base  = MInst->base + MInst->size ;
		 NewMInst->size  = rsize ;
		 NewMInst->flags = LEXOS_MEM_INSTANCE_FREE ;
	       }
	  
	  mem->Free = mem->Free - size ;
	  MInst->obj.name = name ;
	  LEXOS_FREE_SMP_LOCK( mem.obj->smp_lock ) ;

	  printf("Nv04: AllocLocal mem = 0x%8.8lX 0x%8.8lX  0x%8.8lX  %s\n",MInst->base , MInst->size ,MInst->flags,name) ;
	  return(MInst) ;
	}
      MInst = MInst->obj.next ; goto loop1 ;
    }
  LEXOS_FREE_SMP_LOCK( mem.obj->smp_lock ) ;   
  return(0) ;
}
 
void Nv04_FreeLocalMem( _MemHeader *mem , _MemInstance * fmem)
{
  

  LEXOS_ENABLE_SMP_LOCK( mem.obj->smp_lock ) ;

  mem->Free   = mem->Free + fmem->size ;
  fmem->flags = LEXOS_MEM_INSTANCE_FREE ;   

  LEXOS_FREE_SMP_LOCK( mem->obj->smp_lock ) ;
}  
