
typedef struct 
{
  unsigned long ObjId   ;
  unsigned long Context ;
} HashEntry ;

#define Error_Nv04_InitEndObj_HashEntryInUse 0x00000001

#define HASH_CHID0(h) ((((unsigned)(h))^(((unsigned)(h))>>9)^(((unsigned)(h))>>18)^(((unsigned)(h))>>27))&0x1FF)

int Nv04_GetHashAddr(_Nv04Device * nv  , unsigned long ObjId )
{
  unsigned long hash ;
     
  hash = ( 0 ? NV04_PRAMIN ) + nv->info.HashMem->base + (HASH_CHID0(ObjId) * 8 ) ;

  if ( getreg( hash ))
    {
      printf("error hash in uses at [%8.8lX] = %8.8lX\n",hash,getreg(hash) ) ; return(0) ;
    }
 
  return 0 ;
}

_MemInstance * Nv04_AddToInstMem(_Nv04Device * nv , unsigned long *buff , unsigned long size , unsigned char *name )
{
  unsigned long i ;
  _MemInstance *instm ;
  instm = Nv04_AllocLocalMem( nv->info.Pramin , size , 0x00 , 0x00 , name) ;
  if (!instm) return(0) ;
  if (buff) for (i = 0 ; i < size ; i +=4 ) setreg( ( 0 ? NV04_PRAMIN ) + instm->base + i , buff[i]) ;
  return(instm) ;
}
/*
int Nv04_InitEngObj( _Nv04Device * nv , unsigned long ObjId , _IEngObj *EngObj , unsigned long Channel )
{
  _EngObj  *newEObj ;
  unsigned long context ;

  if ( Nv04_GetHashAddr(nv , ObjId) ) return( Error_Nv04_InitEndObj_HashEntryInUse ) ;

  newEObj = os->NewCildObjn( nv->EObj , sizeof (_EngObj) , EngObj->name ) ;

  newEObj->InstMem = Nv04_AllocLocalMem( nv->info.Pramin , 0x10  , 0x00 , 0xffffffff , EngObj->name ) ;
  newEObj->name    = EngObj->name ;

  setreg ( ( 0 ? NV04_PRAMIN ) + newEObj->InstMem->base + 0x00 , EngObj->inst.ctx1 ) ;
  setreg ( ( 0 ? NV04_PRAMIN ) + newEObj->InstMem->base + 0x04 , EngObj->inst.ctx2 ) ;
  setreg ( ( 0 ? NV04_PRAMIN ) + newEObj->InstMem->base + 0x08 , EngObj->inst.ctx3 ) ;
  setreg ( ( 0 ? NV04_PRAMIN ) + newEObj->InstMem->base + 0x0c , EngObj->inst.ctx4 ) ;

  context = 0x80010000 | ( Channel << 24 ) | ( newEObj->InstMem->base >> 4 ) ;

  setreg( ( 0 ? NV04_PRAMIN ) + nv->info.HashMem->base + (HASH_CHID0(ObjId) * 8 ) + 0x00 , ObjId   )  ;
  setreg( ( 0 ? NV04_PRAMIN ) + nv->info.HashMem->base + (HASH_CHID0(ObjId) * 8 ) + 0x04 , context )  ;

  return(0) ;
}
*/





void Nv04_fifoSetupNv03ChannelPio(_Nv04Device * nv , unsigned long ChannelId , unsigned long Size)
{

  unsigned long initCtxtPtr , cacheData ;
  unsigned long i ;
  
  cacheData = getreg( NV_PFIFO_CACHES ) ;

  setreg( NV_PFIFO_CACHES , modbits( 0x00 , NV_PFIFO_CACHES_REASSIGN , NV_PFIFO_CACHES_REASSIGN_DISABLED )) ;

  initCtxtPtr = ( 0 ? NV04_PRAMIN ) + nv->info.FifoContextMem->base + ( ChannelId * 32 ) ;

  for ( i = 0 ; i < 8 ; i++ ) { setreg( initCtxtPtr + (i * 4) , 0x00000000 ) ; }
 
  nv->info.Fifo.Mode &= ~( 1 << ChannelId ) ; setreg ( NV_PFIFO_MODE , nv->info.Fifo.Mode ) ; /* set channel mode to pio */

  if ( Size == 0x0200) nv->info.Fifo.Size |= ( 1 << ChannelId ) ; 
  else 
    nv->info.Fifo.Size &= ~( 1 << ChannelId ) ; 
  setreg( NV_PFIFO_SIZE , nv->info.Fifo.Size ) ;  /* set channel size */


  if ( (nv->info.Fifo.AllocateCount++ == 0) | ( getfld( NV_PFIFO_CACHE1_PUSH1 , NV_PFIFO_CACHE1_PUSH1_CHID) == ChannelId  ) )
    {
      
      setreg( NV_PFIFO_CACHE1_PUSH0   , NV_PFIFO_CACHE1_PUSH0_ACCESS_DISABLED   << ( 0 ? NV_PFIFO_CACHE1_PUSH0_ACCESS ) ) ;
      setreg( NV_PFIFO_CACHE1_PULL0   , NV_PFIFO_CACHE1_PULL0_ACCESS_DISABLED   << ( 0 ? NV_PFIFO_CACHE1_PULL0_ACCESS ) ) ;

      setreg( NV_PFIFO_CACHE1_PUSH1   , ( ( ChannelId                           << ( 0 ? NV_PFIFO_CACHE1_PUSH1_CHID   )) |
					  ( NV_PFIFO_CACHE1_PUSH1_MODE_PIO      << ( 0 ? NV_PFIFO_CACHE1_PUSH1_MODE   ))
					  )) ;
      setreg( NV_PFIFO_CACHE1_PUT     , 0x00000000                              << ( 0 ? NV_PFIFO_CACHE1_PUT_ADDRESS  )) ;
      setreg( NV_PFIFO_CACHE1_GET     , 0x00000000                              << ( 0 ? NV_PFIFO_CACHE1_GET_ADDRESS  )) ;
      setreg( NV_PFIFO_CACHE1_ENGINE  , 0x00000000 ) ;
      
      setreg( NV_PFIFO_CACHE1_PULL0   , NV_PFIFO_CACHE1_PULL0_ACCESS_ENABLED    << ( 0 ? NV_PFIFO_CACHE1_PULL0_ACCESS ) ) ;
      setreg( NV_PFIFO_CACHE1_PUSH0   , NV_PFIFO_CACHE1_PUSH0_ACCESS_ENABLED    << ( 0 ? NV_PFIFO_CACHE1_PUSH0_ACCESS ) ) ;
     
      cacheData = ( NV_PFIFO_CACHES_REASSIGN_ENABLED  << ( 0 ? NV_PFIFO_CACHES_REASSIGN )) ;
    }
  setreg( NV_PFIFO_INTR_0 , 0x00000001 ) ; 
  
  setreg( NV_PFIFO_CACHES , cacheData | 0x00000001 ) ;

}

void Nv04_fifoSetupNv04ChannelDma(_Nv04Device     *nv         ,
				  _Nv04_VideoUser *user       ,
				  unsigned long ChannelId    
				  )
{
  unsigned long initCtxtPtr , i , w , cacheData ;

  cacheData = getreg( NV_PFIFO_CACHES ) ;
  setreg( NV_PFIFO_CACHES , modbits( 0x00 , NV_PFIFO_CACHES_REASSIGN , NV_PFIFO_CACHES_REASSIGN_DISABLED )) ;

  initCtxtPtr = ( 0 ? NV04_PRAMIN ) + nv->info.FifoContextMem->base + ( ChannelId * 32 ) ;
  for ( i = 0 ; i < 8 ; i++ ) { setreg( initCtxtPtr + (i * 4) , 0x00000000 ) ; }

  setreg( ( 0 ? NV04_PRAMIN ) + nv->info.FifoContextMem->base + initCtxtPtr + ( 2 * 4) , user->DmaCmd.DmaInst->base ) ;
  setreg( ( 0 ? NV04_PRAMIN ) + nv->info.FifoContextMem->base + initCtxtPtr + ( 4 * 4) , ( 0x0d << 3) | ( 0x03 << 13 ) | ( 0x04 << 16) ) ;


  nv->info.Fifo.Mode |= ( 1 << ChannelId ) ; setreg ( NV_PFIFO_MODE , nv->info.Fifo.Mode ) ; /* set channel mode to dma */
  
  if ( (nv->info.Fifo.AllocateCount++ == 0) | ( getfld( NV_PFIFO_CACHE1_PUSH1 , NV_PFIFO_CACHE1_PUSH1_CHID) == ChannelId  ) )
    {
      
      setreg( NV_PFIFO_CACHE1_PUSH0      , NV_PFIFO_CACHE1_PUSH0_ACCESS_DISABLED    << ( 0 ? NV_PFIFO_CACHE1_PUSH0_ACCESS ) ) ;
      setreg( NV_PFIFO_CACHE1_DMA_PUSH   , NV_PFIFO_CACHE1_DMA_PUSH_ACCESS_DISABLED << ( 0 ? NV_PFIFO_CACHE1_DMA_PUSH_ACCESS ) ) ;
      
      setreg( NV_PFIFO_CACHE1_PULL0      , NV_PFIFO_CACHE1_PULL0_ACCESS_DISABLED   << ( 0 ? NV_PFIFO_CACHE1_PULL0_ACCESS ) ) ;
      
      setreg( NV_PFIFO_CACHE1_PUSH1      , ( ( ChannelId                           << ( 0 ? NV_PFIFO_CACHE1_PUSH1_CHID   )) |
					     ( NV_PFIFO_CACHE1_PUSH1_MODE_DMA      << ( 0 ? NV_PFIFO_CACHE1_PUSH1_MODE   ))
					     )) ;

      setreg( NV_PFIFO_CACHE1_DMA_PUT        ,  user->DmaCmd.Put << 2) ; 
      setreg( NV_PFIFO_CACHE1_DMA_GET        ,  user->DmaCmd.Get << 2) ; 
      setreg( NV_PFIFO_CACHE1_DMA_INSTANCE   ,  user->DmaCmd.DmaInst->base  >> 4 ) ; 
      setreg( NV_PFIFO_CACHE1_DMA_CTL        ,  0x00000000 ) ;
      setreg( NV_PFIFO_CACHE1_DMA_STATE      ,  0x00000000 ) ;
      setreg( NV_PFIFO_CACHE1_ENGINE         ,  0x00000000 ) ;
      setreg( NV_PFIFO_CACHE1_DMA_TLB_TAG    ,  0x00000000 ) ;
      setreg( NV_PFIFO_CACHE1_DMA_TLB_PTE    ,  0x00000000 ) ;
      setreg( NV_PFIFO_CACHE1_DMA_FETCH      , ( 0x0d << 3) | ( 0x03 << 13 ) | ( 0x04 << 16) ) ;
       
      setreg( NV_PFIFO_CACHE1_DMA_LIMIT      ,  user->DmaCmd.BufferMask << 2 ) ;
      
      dumpRegs(nv , fifoDmaRegsTable ) ;

      printf("ready to start dma\n") ;
      getchar() ;

      setreg( NV_PFIFO_CACHE1_DMA_PUSH       , NV_PFIFO_CACHE1_DMA_PUSH_ACCESS_ENABLED << ( 0 ? NV_PFIFO_CACHE1_DMA_PUSH_ACCESS ) ) ;
      setreg( NV_PFIFO_CACHE1_PULL0          , NV_PFIFO_CACHE1_PULL0_ACCESS_ENABLED    << ( 0 ? NV_PFIFO_CACHE1_PULL0_ACCESS ) ) ;
      setreg( NV_PFIFO_CACHE1_PUSH0          , NV_PFIFO_CACHE1_PUSH0_ACCESS_ENABLED    << ( 0 ? NV_PFIFO_CACHE1_PUSH0_ACCESS ) ) ;
     
      cacheData = ( NV_PFIFO_CACHES_REASSIGN_ENABLED  << ( 0 ? NV_PFIFO_CACHES_REASSIGN )) ;
      
      w = 0 ; 
    loop1:
      if ( getfld( NV_PFIFO_CACHE1_DMA_PUSH , NV_PFIFO_CACHE1_DMA_PUSH_STATE) == NV_PFIFO_CACHE1_DMA_PUSH_STATE_BUSY ) { w++ ; goto loop1 ; }
      printf("dma w = %ld\n",w) ; 


      printf("ready to read dma stat\n") ;
      getchar() ;

      dumpRegs(nv , fifoDmaRegsTable ) ;
      getchar() ;
      
    }

  setreg( NV_PFIFO_CACHES , cacheData ) ;
  
  PrintCtx( nv ) ;      
  getchar() ;
  

}





void Nv04_FifoInit(_Nv04Device * nv )
{
  unsigned long i ;

  nv->EObj = os->NewCildObjn( nv , sizeof(_EngObj) , "EngObjects" ) ;

  
  /* this will be replaced by AllocLocalMemA  it just marks out the first 64k of PRAMIN */
  Nv04_AllocLocalMem( nv->info.Pramin , 0x00010000 , 0x00000000 , 0xffffffff , "space"  /* not yet working */ ) ; 
   

  nv->info.HashTableSize      = 0x1000 ; 
  nv->info.HashMem            = Nv04_AllocLocalMem( nv->info.Pramin , nv->info.HashTableSize      , 0x00 , 0xffffffff , "nv04_HashTable" );/* 512 slots */
  nv->info.RunOutRamSize      = 0x0200 ; 
  nv->info.RunOutRamMem       = Nv04_AllocLocalMem( nv->info.Pramin , nv->info.RunOutRamSize      , 0x00 , 0xffffffff , "nv04_RunOutMem" ); 
  nv->info.FifoContextRamSize = 0x0200 ; 
  nv->info.FifoContextMem     = Nv04_AllocLocalMem( nv->info.Pramin , nv->info.FifoContextRamSize , 0x00 , 0xffffffff , "nv04_FifoContextMem") ;

  setreg( NV_PFIFO_CACHES               , 0x00000000 ) ;
  setreg( NV_PFIFO_CACHE1_PUSH0         , 0x00000000 ) ;
  setreg( NV_PFIFO_CACHE1_PULL0         , 0x00000000 ) ;
  setreg( NV_PFIFO_CACHE1_PUSH1         , 0x00000000 ) ;
  setreg( NV_PFIFO_CACHE1_DMA_INSTANCE  , 0x00000000 ) ;
  setreg( NV_PFIFO_CACHE0_PUSH0         , 0x00000000 ) ;
  setreg( NV_PFIFO_CACHE0_PULL0         , 0x00000000 ) ;  /* Disable Fifo */


  setreg( NV_PFIFO_RAMHT ,(
			   modbits( 0x00 , NV_PFIFO_RAMHT_SIZE          , NV_PFIFO_RAMHT_SIZE_4K                   ) |
			   modbits( 0x00 , NV_PFIFO_RAMHT_SEARCH        , NV_PFIFO_RAMHT_SEARCH_128                ) |
			   modbits( 0x00 , NV_PFIFO_RAMHT_BASE_ADDRESS  , (nv->info.HashMem->base       ) / 0x1000 ) 
			   )) ;
  setreg( NV_PFIFO_RAMFC , modbits( 0x00 , NV_PFIFO_RAMFC_BASE_ADDRESS  , (nv->info.FifoContextMem->base) / 0x0200 )) ;
  setreg( NV_PFIFO_RAMRO ,( 
			   modbits( 0x00 , NV_PFIFO_RAMRO_SIZE          , NV_PFIFO_RAMRO_SIZE_512                  ) |
			   modbits( 0x00 , NV_PFIFO_RAMRO_BASE_ADDRESS  , (nv->info.RunOutRamMem->base  ) / 0x0200 )
			   )) ;

  /* clear cache 1 */
  if(1)
    {
      for ( i = 0 ; i < 256 ; i++ ) 
	{
	  setreg( NV_PFIFO_CACHE1_METHOD(i) , 0x00 ) ; setreg( NV_PFIFO_CACHE1_DATA(i) , 0x00 ) ; 
	}
      setreg( NV_PFIFO_CACHE1_PUT , 0x00000000 ) ;
      setreg( NV_PFIFO_CACHE1_GET , 0x00000000 ) ; /* PUT = GET = CACHE1 EMPTY */
    }

  if(1)
    {
      setreg( NV_PFIFO_CACHE1_DMA_PUT , 0x00000000 ) ;
      setreg( NV_PFIFO_CACHE1_DMA_GET , 0x00000000 ) ; /* PUT = GET = DMA COMMAND RING EMPTY */
    }
  
  
  
  if(1)
    {
      modreg( NV_PFB_CONFIG_0 , NV_PFB_CONFIG_0_PRAMIN_WR      , NV_PFB_CONFIG_0_PRAMIN_WR_DISABLED ) ; 
      modreg( NV_PFB_CONFIG_0 , NV_PFB_CONFIG_0_PRAMIN_WR_MASK , NV_PFB_CONFIG_0_PRAMIN_WR_MASK_CLEAR ) ; 
          
      setreg( NV_PFB_CONFIG_0 , 0x00001114 ) ;
    }

}

typedef struct
{
  unsigned long  bitn ;
  char          *name ;
} _Nv04_ints ; 


_Nv04_ints nv04_intrs[] = 
{
  {  0 , "NV_PGRAPH_INTR_NOTIFY"         } ,
  {  4 , "NV_PGRAPH_INTR_MISSING_HW"     } ,
  {  8 , "NV_PGRAPH_INTR_TLB_PRESENT_A"  } ,
  {  9 , "NV_PGRAPH_INTR_TLB_PRESENT_B"  } ,
  { 12 , "NV_PGRAPH_INTR_CONTEXT_SWITCH" } ,
  { 16 , "NV_PGRAPH_INTR_BUFFER_NOTIFY"  } ,
  { ~0 , NULL }
} ;

_Nv04_ints nv04_nstatus[] =
{
  { 11 , "NV_PGRAPH_NSTATUS_STATE_IN_USE"     } ,
  { 12 , "NV_PGRAPH_NSTATUS_INVALID_STATE"    } ,
  { 13 , "NV_PGRAPH_NSTATUS_BAD_ARGUMENT"     } ,
  { 14 , "NV_PGRAPH_NSTATUS_PROTECTION_FAULT" } , 
  { 0xffffffff , NULL }
} ;

_Nv04_ints nv04_nsource[] = 
{
  {  0 , "NV_PGRAPH_NSOURCE_NOTIFICATION"     } ,
  {  1 , "NV_PGRAPH_NSOURCE_DATA_ERROR"       } ,
  {  2 , "NV_PGRAPH_NSOURCE_PROTECTION_ERROR" } ,
  {  3 , "NV_PGRAPH_NSOURCE_RANGE_EXCEPTION"  } ,
  {  4 , "NV_PGRAPH_NSOURCE_LIMIT_COLOR"      } ,
  {  5 , "NV_PGRAPH_NSOURCE_LIMIT_ZETA"       } ,
  {  6 , "NV_PGRAPH_NSOURCE_ILLEGAL_MTHD"     } ,
  {  7 , "NV_PGRAPH_NSOURCE_DMA_R_PROTECTION" } ,
  {  8 , "NV_PGRAPH_NSOURCE_DMA_W_PROTECTION" } ,
  {  9 , "NV_PGRAPH_NSOURCE_FORMAT_EXCEPTION" } ,
  { 10 , "NV_PGRAPH_NSOURCE_PATCH_EXCEPTION"  } ,
  { 11 , "NV_PGRAPH_NSOURCE_STATE_INVALID"    } ,
  { 12 , "NV_PGRAPH_NSOURCE_DOUBLE_NOTIFY"    } ,
  { 13 , "NV_PGRAPH_NSOURCE_NOTIFY_IN_USE"    } ,
  { 14 , "NV_PGRAPH_NSOURCE_METHOD_CNT"       } ,
  { 15 , "NV_PGRAPH_NSOURCE_BFR_NOTIFICATION" } ,
  { 0xffffffff , NULL }
} ;


void PrintReg(_Nv04_ints * table , unsigned long data , char * text ) 
{
  unsigned long i ;

  for (i = 0 ; table[i].bitn != 0xffffffff ; i++ ) 
    {
      if ( data & ( 1 << table[i].bitn)) printf("%s %s\n",text,table[i].name) ;
    }
}



void Nv04_PrintPGRAPH( _Nv04Device *nv )
{
  unsigned long data , sdata , ndata ,d ,c ;
 
  c = 0 ;


  data = getreg( NV_PGRAPH_INTR) ; sdata = getreg( NV_PGRAPH_NSTATUS ) ; ndata = getreg( NV_PGRAPH_NSOURCE ) ;
  if (data) 
    {
      printf("Nv04: intr    = 0x%8.8lX NStatus = 0x%8.8lX  n source = %8.8lX\n\n" , data , sdata , ndata ) ;

      PrintReg( nv04_intrs   ,  data , "Nv04: ") ;
      PrintReg( nv04_nstatus , sdata , "Nv04: ") ;
      PrintReg( nv04_nsource , ndata , "Nv04: ") ;

      c = getreg(NV_PGRAPH_TRAPPED_ADDR) ; d = getreg(NV_PGRAPH_TRAPPED_DATA ) ;

      printf("Nv04: TRAPPED  MTHD = 0x%8.8lX\n",(rdbits( c , NV_PGRAPH_TRAPPED_ADDR_MTHD ) << 2)) ; 
      printf("Nv04: TRAPPED SUBCH = 0x%8.8lX\n",rdbits( c , NV_PGRAPH_TRAPPED_ADDR_SUBCH )) ; 
      printf("Nv04: TRAPPED  CHID = 0x%8.8lX\n",rdbits( c , NV_PGRAPH_TRAPPED_ADDR_CHID )) ; 
      printf("Nv04: TRAPPED  DATA = 0x%8.8lX\n", d ) ; 
      printf("\n") ;

      printf("testing new reg debug \n") ;
      Nv04_PrintReg( NV_PGRAPH_INTR         ,  data , 2 , "Nv04: ") ;
      Nv04_PrintReg( NV_PGRAPH_NSTATUS      , sdata , 2 , "Nv04: ") ;
      Nv04_PrintReg( NV_PGRAPH_NSOURCE      , ndata , 2 , "Nv04: ") ;
      Nv04_PrintReg( NV_PGRAPH_TRAPPED_ADDR ,     c , 1 , "Nv04: ") ;
      Nv04_PrintReg( NV_PGRAPH_TRAPPED_DATA ,     d , 1 , "Nv04: ") ;



    }
}

void Nv04_TestFifoFree( _Nv04Device *nv , unsigned long subch , unsigned long cnt  )
{
  unsigned long state , c , data , sdata , ndata ,d ;
 
  c = 0 ;
 l1:
  state = nv->ch->subchannel[subch].Free ; if ((state < cnt) & (getreg(NV_PGRAPH_INTR) == 0x00) & ( c < 800000 )) { c++ ; goto l1 ; }

  if( state != 0x0200 ) printf("state   = 0x%8.8lX count = %ld\n",state ,c ) ;

  data = getreg( NV_PGRAPH_INTR) ; sdata = getreg( NV_PGRAPH_NSTATUS ) ; ndata = getreg( NV_PGRAPH_NSOURCE ) ;
  if (data) 
    {
      printf("Nv04: intr    = 0x%8.8lX NStatus = 0x%8.8lX  n source = %8.8lX\n\n" , data , sdata , ndata ) ;




      PrintReg( nv04_intrs   ,  data , "Nv04: ") ;
      PrintReg( nv04_nstatus , sdata , "Nv04: ") ;
      PrintReg( nv04_nsource , ndata , "Nv04: ") ;

      c = getreg(NV_PGRAPH_TRAPPED_ADDR) ; d = getreg(NV_PGRAPH_TRAPPED_DATA ) ;

      printf("Nv04: TRAPPED  MTHD = 0x%8.8lX\n",(rdbits( c , NV_PGRAPH_TRAPPED_ADDR_MTHD ) << 2)) ; 
      printf("Nv04: TRAPPED SUBCH = 0x%8.8lX\n",rdbits( c , NV_PGRAPH_TRAPPED_ADDR_SUBCH )) ; 
      printf("Nv04: TRAPPED  CHID = 0x%8.8lX\n",rdbits( c , NV_PGRAPH_TRAPPED_ADDR_CHID )) ; 
      printf("Nv04: TRAPPED  DATA = 0x%8.8lX\n", d ) ; 
      printf("\n") ;

      printf("testing new reg debug \n") ;
      Nv04_PrintReg( NV_PGRAPH_INTR         ,  data , 2 , "Nv04: ") ;
      Nv04_PrintReg( NV_PGRAPH_NSTATUS      , sdata , 2 , "Nv04: ") ;
      Nv04_PrintReg( NV_PGRAPH_NSOURCE      , ndata , 2 , "Nv04: ") ;
      Nv04_PrintReg( NV_PGRAPH_TRAPPED_ADDR ,     c , 1 , "Nv04: ") ;
      Nv04_PrintReg( NV_PGRAPH_TRAPPED_DATA ,     d , 1 , "Nv04: ") ;



    }
}
