



void Nv04_fbLatchMemConfig(_Nv04Device * nv)
{

  unsigned long latency ;

  latency = getreg( NV04_PFB_CONFIG_1 ) ;
  modreg( NV04_PFB_CONFIG_1 , NV04_PFB_CONFIG_1_CAS_LATENCY , NV04_PFB_CONFIG_1_CAS_LATENCY_3 ) ;
  modreg( NV04_PFB_CONFIG_1 , NV04_PFB_CONFIG_1_CAS_LATENCY , NV04_PFB_CONFIG_1_CAS_LATENCY_2 ) ;
  modreg( NV04_PFB_CONFIG_1 , NV04_PFB_CONFIG_1_CAS_LATENCY , NV04_PFB_CONFIG_1_CAS_LATENCY_3 ) ;
  setreg( NV04_PFB_CONFIG_1 , latency ) ;
}

void Nv04_nv04FbCalcSgramSize(_Nv04Device * nv)
{
  NvU8 *fbAddr = (void *) nv->Fb ;
  int i, memsize;
  
  modreg( NV04_PFB_DEBUG_0 , 4:4 , 0x00000001 ) ;


  setreg ( NV04_PFB_BOOT_0 , (
			      (modbits( 0x00000000 , NV04_PFB_BOOT_0_RAM_AMOUNT      ,  NV04_PFB_BOOT_0_RAM_AMOUNT_16MB        )) |
			      (modbits( 0x00000000 , NV04_PFB_BOOT_0_RAM_WIDTH_128   ,  NV04_PFB_BOOT_0_RAM_WIDTH_128_ON       )) |
			      (modbits( 0x00000000 , NV04_PFB_BOOT_0_RAM_TYPE        ,  NV04_PFB_BOOT_0_RAM_TYPE_SDRAM_16MBIT  )) 
			      )) ;

  Nv04_fbLatchMemConfig(nv);
  
  for (i = 0; i < 4; i++) (*((NvU32 *)& fbAddr [ i*4 ]) = (NvU32) (NvU32) (( "NV4A" )[0] | ( "NV4A" )[1] << 8  | ( "NV4A" )[2] << 16 |( "NV4A" )[3] << 24) ) ;
  
  memsize = (((NvU32)*((NvU32 *)& fbAddr [ 0x0 ])) == (NvU32) (( "NV4A" )[0]       | ( "NV4A" )[1] << 8  | ( "NV4A" )[2] << 16 | ( "NV4A" )[3] << 24) ) ? 16 : 8;
  
  if (((NvU16)*((NvU16 *)& fbAddr [ 0x0000000c ])) == (NvU16) (( "NV" )[0] | ( "NV" )[1] << 8) ) 
    {
      if (memsize == 16) 
	{
	  (*((NvU32 *)& fbAddr [ 0x00800000 ]) = (NvU32) (NvU32) ( ( "A4VN" )[0] | ( "A4VN" )[1] << 8 | ( "A4VN" )[2] << 16 | ( "A4VN" )[3] << 24) ) ;
	  if (((NvU32)*((NvU32 *)& fbAddr [ 0x00800000 ])) != (NvU32)(( "A4VN" )[0] | ( "A4VN" )[1] << 8 | ( "A4VN" )[2] << 16 | ( "A4VN" )[3] << 24) ) 
	    {
	      modreg( NV04_PFB_BOOT_0 , NV04_PFB_BOOT_0_RAM_AMOUNT , NV04_PFB_BOOT_0_RAM_AMOUNT_8MB ) ;	     
	    }
	} 
      else 
	{
	  (*((NvU32 *)& fbAddr [ 0x00800000 ]) = (NvU32) (NvU32) (( "A4VN" )[0] | ( "A4VN" )[1] << 8 | ( "A4VN" )[2] << 16 | ( "A4VN" )[3] << 24)  ) ;
	  if (((NvU32)*((NvU32 *)& fbAddr [ 0x00800000 ])) != (NvU32)
	      (
	       ( "A4VN" )[0] | 
	       ( "A4VN" )[1] << 8 | 
	       ( "A4VN" )[2] << 16 | 
	       ( "A4VN" )[3] << 24) ) 
	    {
	      modreg( NV04_PFB_BOOT_0 , NV04_PFB_BOOT_0_RAM_AMOUNT , NV04_PFB_BOOT_0_RAM_AMOUNT_8MB ) ;	     
	    } 
	  else 
	    {
	      modreg( NV04_PFB_BOOT_0 , NV04_PFB_BOOT_0_RAM_AMOUNT , NV04_PFB_BOOT_0_RAM_AMOUNT_8MB ) ;	     
	    }
	}
    } 
  else 
    {
      modreg( NV04_PFB_BOOT_0 , NV04_PFB_BOOT_0_RAM_AMOUNT , NV04_PFB_BOOT_0_RAM_AMOUNT_4MB ) ;	     
      modreg( NV04_PFB_BOOT_0 , NV04_PFB_BOOT_0_RAM_AMOUNT , NV04_PFB_BOOT_0_RAM_AMOUNT_32MB ) ;	     
    }
  
  Nv04_fbLatchMemConfig(nv);

  modreg( NV04_PFB_DEBUG_0 , 4:4 , 0x00000000 ) ;

}



typedef struct _nv5MemInit {
  NvU32 pfbBoot0   ;
  NvU32 pfbConfig1  ;
} nv5MemInit;

nv5MemInit nv5MemInitTbl[] = {
 { 0x24, 0x00 },
 { 0x28, 0x00 },
 { 0x24, 0x01 },
 { 0x1f, 0x00 },
 { 0x0f, 0x00 },
 { 0x17, 0x00 },
 { 0x06, 0x00 },
 { 0x00, 0x00 },
};

void NV04_nv05FbCalcRamSize(_Nv04Device *nv)
{
  unsigned long i , value ;
  NvU8 * fbAddr = (void *) nv->Fb ;

  modreg( NV04_PFB_DEBUG_0 , 4:4 , 0x00000000 ) ;
  
  i = getfld( NV04_PEXTDEV_BOOT_0 , NV04_PEXTDEV_BOOT_0_STRAP_RAMCFG ) ;

  value = (getreg( NV04_PFB_BOOT_0   ) & 0xfffffc0) | nv5MemInitTbl[i].pfbBoot0   ; setreg( NV04_PFB_BOOT_0   , value ) ;
  value = (getreg( NV04_PFB_CONFIG_1 ) & 0xff8fffe) | nv5MemInitTbl[i].pfbConfig1 ; setreg( NV04_PFB_CONFIG_1 , value ) ;

  Nv04_fbLatchMemConfig(nv) ;

  for (i = 0; i < 4; i++) (*((NvU32 *)& fbAddr [ i*4 ]) = (NvU32) (NvU32) (( "NV5A" )[0]       |  ( "NV5A" )[1] << 8  |  ( "NV5A" )[2] << 16 | ( "NV5A" )[3] << 24 ) ) ;
  
  if (((NvU16)*((NvU16 *)& fbAddr [ 0x0000000c ])) != (NvU16) ( ( "NV" )[0] | ( "NV" )[1] << 8) ) 
    {
      modreg( NV04_PFB_BOOT_0 , NV04_PFB_BOOT_0_RAM_WIDTH_128 , NV04_PFB_BOOT_0_RAM_WIDTH_128_OFF ) ;
      Nv04_fbLatchMemConfig(nv);
    }
  
  if ( getfld( NV04_PFB_BOOT_0 , NV04_PFB_BOOT_0_RAM_AMOUNT ) == NV04_PFB_BOOT_0_RAM_AMOUNT_32MB ) 
    {
      (*((NvU32 *)& fbAddr [ 0x01000000 ]) = (NvU32) (NvU32) (( "NV5B" )[0] | ( "NV5B" )[1] << 8 | ( "NV5B" )[2] << 16 | ( "NV5B" )[3] << 24) ) ;
      
      if (((NvU32)*((NvU32 *)& fbAddr [ 0x01000000 ])) == (NvU32) (( "NV5B" )[0] | ( "NV5B" )[1] << 8 | ( "NV5B" )[2] << 16 | ( "NV5B" )[3] << 24) )
	{
	  (*((NvU32 *)& fbAddr [ 0x00000000 ]) =      (NvU32) (NvU32) (( "A5VN" )[0] | ( "A5VN" )[1] << 8 | ( "A5VN" )[2] << 16 | ( "A5VN" )[3] << 24) ) ;
	  
	  if (((NvU32)*((NvU32 *)& fbAddr [ 0x00000000 ])) != (NvU32) (( "A5VN" )[0] | ( "A5VN" )[1] << 8 | ( "A5VN" )[2] << 16 | ( "A5VN" )[3] << 24) )
	    
	    modreg( NV04_PFB_BOOT_0 , NV04_PFB_BOOT_0_RAM_AMOUNT , NV04_PFB_BOOT_0_RAM_AMOUNT_16MB ) ;
	}	  
      else 
	{
	modreg( NV04_PFB_BOOT_0 , NV04_PFB_BOOT_0_RAM_AMOUNT , NV04_PFB_BOOT_0_RAM_AMOUNT_16MB ) ;
	}
    }
  else 
   {
     if ( getfld( NV04_PFB_BOOT_0 , NV04_PFB_BOOT_0_RAM_AMOUNT ) == NV04_PFB_BOOT_0_RAM_AMOUNT_16MB ) 
       {
	 (*((NvU32 *)& fbAddr [ 0x00800000 ]) = (NvU32)      (NvU32) (( "NV5C" )[0] | ( "NV5C" )[1] << 8 | ( "NV5C" )[2] << 16 | ( "NV5C" )[3] << 24) ) ;
	 if (((NvU32)*((NvU32 *)& fbAddr [ 0x00800000 ])) != (NvU32) (( "NV5C" )[0] | ( "NV5C" )[1] << 8 | ( "NV5C" )[2] << 16 | ( "NV5C" )[3] << 24) ) 
	   {
	     (*((NvU32 *)& fbAddr [ 0x00400000 ]) = (NvU32)      (NvU32) (( "NV5D" )[0] | ( "NV5D" )[1] << 8 | ( "NV5D" )[2] << 16 | ( "NV5D" )[3] << 24) ) ;
	     if (((NvU32)*((NvU32 *)& fbAddr [ 0x00400000 ])) == (NvU32) (( "NV5D" )[0] | ( "NV5D" )[1] << 8 | ( "NV5D" )[2] << 16 | ( "NV5D" )[3] << 24) )
	       modreg( NV04_PFB_BOOT_0 , NV04_PFB_BOOT_0_RAM_AMOUNT , NV04_PFB_BOOT_0_RAM_AMOUNT_8MB ) ;	     
	     else
	       modreg( NV04_PFB_BOOT_0 , NV04_PFB_BOOT_0_RAM_AMOUNT , NV04_PFB_BOOT_0_RAM_AMOUNT_4MB ) ;	     
	   } 
	 else 
	   {
	     (*((NvU32 *)& fbAddr [ 0x00400000 ]) = (NvU32)      (NvU32) (( "NV5D" )[0] | ( "NV5D" )[1] << 8  | ( "NV5D" )[2] << 16 | ( "NV5D" )[3] << 24 ) ) ;
	     if (((NvU32)*((NvU32 *)& fbAddr [ 0x00400000 ])) != (NvU32) (( "NV5D" )[0] | ( "NV5D" )[1] << 8  | ( "NV5D" )[2] << 16 | ( "NV5D" )[3] << 24 ) )
	       modreg( NV04_PFB_BOOT_0 , NV04_PFB_BOOT_0_RAM_AMOUNT , NV04_PFB_BOOT_0_RAM_AMOUNT_8MB ) ;	     
	     else
	       modreg( NV04_PFB_BOOT_0 , NV04_PFB_BOOT_0_RAM_AMOUNT , NV04_PFB_BOOT_0_RAM_AMOUNT_4MB ) ;	     
	     
	   }
       }
     Nv04_fbLatchMemConfig(nv);
   }
  
}





int Nv04_Nv04HwInit( _Nv04Device    *nv  )
{
  unsigned long value , clock ;

  modreg ( NV04_PEXTDEV_BOOT_0 ,  NV04_PEXTDEV_BOOT_0_STRAP_AGP_SBA , NV04_PEXTDEV_BOOT_0_STRAP_AGP_SBA_DISABLED ) ;
  setreg ( NV04_PBUS_DEBUG_0   , 0x020f0000 ) ;

  clock =  90000000 ; value = Nv04_CalcPLL(nv ,clock) ; setreg ( NV04_PRAMDAC_NVPLL_COEFF , value ) ; /* set nv      clock to  90 Mhz */
  clock = 110000000 ; value = Nv04_CalcPLL(nv ,clock) ; setreg ( NV04_PRAMDAC_MPLL_COEFF  , value ) ; /* set memory  clock to 110 Mhz */
  
    setreg ( NV04_PFB_CONFIG_0         , (
					modbits( 0 ,  5:0  , 0x00000014 ) |
					modbits( 0 ,  9:8  , 0x00000001 ) |
					modbits( 0 , 12:12 , 0x00000001 ) |
					modbits( 0 , 23:13 , 0x00000000 ) 
					)                                                       
	   ) ;                                                                                   /* ???? */

  if(0) clock =  36000000 ; value = Nv04_CalcPLL(nv ,clock) ; setreg ( NV04_PRAMDAC_VPLL_COEFF , value ) ; /* set video   clock to  36 Mhz */
 
  setreg ( NV04_PFB_DEBUG_0          , 0x20001d00 ) ;
  setreg ( NV04_PFB_CONFIG_1         , (
					modbits( 0 , NV04_PFB_CONFIG_1_CAS_LATENCY      ,   NV04_PFB_CONFIG_1_CAS_LATENCY_3          ) |
					modbits( 0 , NV04_PFB_CONFIG_1_RAS_RAS          ,   NV04_PFB_CONFIG_1_RAS_RAS_DEFAULT        ) |
					modbits( 0 , NV04_PFB_CONFIG_1_RAS_PCHG         ,   NV04_PFB_CONFIG_1_RAS_PCHG_DEFAULT       ) |
					modbits( 0 , NV04_PFB_CONFIG_1_RAS_LOW          ,   NV04_PFB_CONFIG_1_RAS_LOW_DEFAULT        ) |
					modbits( 0 , NV04_PFB_CONFIG_1_MRS_TO_RAS       ,   NV04_PFB_CONFIG_1_MRS_TO_RAS_DEFAULT     ) |
					modbits( 0 , NV04_PFB_CONFIG_1_WRITE_TO_READ    ,   NV04_PFB_CONFIG_1_WRITE_TO_READ_DEFAULT  ) |
					modbits( 0 , NV04_PFB_CONFIG_1_RAS_TO_CAS_M1    ,   NV04_PFB_CONFIG_1_RAS_TO_CAS_M1_DEFAULT  ) 
					)) ;
  setreg ( NV04_PFB_RTL              , 0x00000000 ) ;
  setreg ( NV04_PBUS_DEBUG_1         , (
					modbits( 0 ,  0:0  , 0x00000000 ) |
					modbits( 0 ,  1:1  , 0x00000000 ) |
					modbits( 0 ,  4:3  , 0x00000001 ) |
					modbits( 0 ,  5:5  , 0x00000000 ) |
					modbits( 0 ,  6:6  , 0x00000001 ) |
					modbits( 0 ,  8:8  , 0x00000001 ) |
					modbits( 0 ,  9:9  , 0x00000001 ) |
					modbits( 0 , 10:10 , 0x00000001 ) |
					modbits( 0 , 12:12 , 0x00000001 ) |
					modbits( 0 , 14:14 , 0x00000001 ) |
 					modbits( 0 , 15:15 , 0x00000000 ) 
					)) ;
  Nv04_nv04FbCalcSgramSize( nv ) ;

  value = getreg( NV04_PFB_BOOT_0 ) ;

  if ( (rdbits( value , NV04_PFB_BOOT_0_RAM_TYPE ) == NV04_PFB_BOOT_0_RAM_TYPE_SDRAM_16MBIT        ) |
       (rdbits( value , NV04_PFB_BOOT_0_RAM_TYPE ) == NV04_PFB_BOOT_0_RAM_TYPE_SGRAM_16MBIT_4BANK  )
       )
    setreg ( NV04_PFB_CONFIG_1 , 0x31012132 ) ;
  
  setreg( NV04_PRAMDAC_PLL_COEFF_SELECT , (
					   modbits( 0 , NV04_PRAMDAC_PLL_COEFF_SELECT_VPLL_SOURCE  ,  NV04_PRAMDAC_PLL_COEFF_SELECT_VPLL_SOURCE_XTAL ) |
					   modbits( 0 , NV04_PRAMDAC_PLL_COEFF_SELECT_SOURCE       ,  0x00000005                                     ) |
					   modbits( 0 , NV04_PRAMDAC_PLL_COEFF_SELECT_VS_PCLK_TV   ,  NV04_PRAMDAC_PLL_COEFF_SELECT_VS_PCLK_TV_NONE  ) |
					   modbits( 0 , NV04_PRAMDAC_PLL_COEFF_SELECT_TVCLK_SOURCE ,  NV04_PRAMDAC_PLL_COEFF_SELECT_TVCLK_SOURCE_EXT ) |
					   modbits( 0 , NV04_PRAMDAC_PLL_COEFF_SELECT_TVCLK_RATIO  ,  NV04_PRAMDAC_PLL_COEFF_SELECT_TVCLK_RATIO_DB1  ) |
					   modbits( 0 , NV04_PRAMDAC_PLL_COEFF_SELECT_VCLK_RATIO   ,  NV04_PRAMDAC_PLL_COEFF_SELECT_VCLK_RATIO_DB1   ) 
					   )) ;
  setreg( NV04_PBUS_DEBUG_2             , 0x000011f0 ) ;
  setreg( NV04_PBUS_DEBUG_3             , (
					   modbits( 0 ,  1:0  ,  0x00000001 ) 
					   )) ;

  return(0) ;
}


int Nv04_Nv05HwInit( _Nv04Device     *nv )
{
  
  unsigned long value ;
  unsigned long clock ; 


  value = getreg( NV04_PEXTDEV_BOOT_0 ) ;

  value |= modbits( (value | 0x0800) , NV04_PEXTDEV_BOOT_0_STRAP_OVERWRITE , NV04_PEXTDEV_BOOT_0_STRAP_OVERWRITE_ENABLED ) ;
    
  setreg ( NV04_PEXTDEV_BOOT_0       , value      ) ;
  
  setreg ( NV04_PBUS_DEBUG_PRIV_ASRC , 0x00000000 ) ;
  
  setreg ( NV04_PBUS_DEBUG_0         , 0x01020101 ) ;
  setreg ( NV04_PBUS_DEBUG_CTRIM_0   , 0x0800bba7 ) ;
  setreg ( NV04_PBUS_DEBUG_CTRIM_1   , 0xefe00000 ) ;
  setreg ( NV04_PBUS_DEBUG_CTRIM_2   , 0x88c98200 ) ;
  setreg ( NV04_PBUS_DEBUG_CTRIM_3   , 0xff988aa9 ) ;

  clock = 125000000 ; value = Nv04_CalcPLL(nv , clock) ; setreg ( NV04_PRAMDAC_NVPLL_COEFF , value ) ; /* set nv      clock to 125 Mhz */
  clock = 150000000 ; value = Nv04_CalcPLL(nv , clock) ; setreg ( NV04_PRAMDAC_MPLL_COEFF  , value ) ; /* set memory  clock to 150 Mhz */
  
  setreg ( NV04_PFB_CONFIG_0         , (
					modbits( 0 ,  5:0  , 0x00000014 ) |
					modbits( 0 ,  9:8  , 0x00000001 ) |
					modbits( 0 , 12:12 , 0x00000001 ) |
					modbits( 0 , 23:13 , 0x00000000 ) 
					)                                                       
	   ) ;                                                                                   /* ???? */

  clock =  36000000 ; value = Nv04_CalcPLL(nv ,clock) ; setreg ( NV04_PRAMDAC_VPLL_COEFF , value ) ; /* set video   clock to  36 Mhz */

  setreg ( NV04_PFB_DEBUG_0          , 0x20002500 ) ;
  setreg ( NV04_PFB_CONFIG_1         , (
					modbits( 0 , NV04_PFB_CONFIG_1_CAS_LATENCY      ,   NV04_PFB_CONFIG_1_CAS_LATENCY_3          ) |
					modbits( 0 , NV04_PFB_CONFIG_1_RAS_RAS          ,   NV04_PFB_CONFIG_1_RAS_RAS_DEFAULT        ) |
					modbits( 0 , NV04_PFB_CONFIG_1_RAS_PCHG         ,   NV04_PFB_CONFIG_1_RAS_PCHG_DEFAULT       ) |
					modbits( 0 , NV04_PFB_CONFIG_1_RAS_LOW          ,   NV04_PFB_CONFIG_1_RAS_LOW_DEFAULT        ) |
					modbits( 0 , NV04_PFB_CONFIG_1_MRS_TO_RAS       ,   NV04_PFB_CONFIG_1_MRS_TO_RAS_DEFAULT     ) |
					modbits( 0 , NV04_PFB_CONFIG_1_WRITE_TO_READ    ,   NV04_PFB_CONFIG_1_WRITE_TO_READ_DEFAULT  ) |
					modbits( 0 , NV04_PFB_CONFIG_1_RAS_TO_CAS_M1    ,   NV04_PFB_CONFIG_1_RAS_TO_CAS_M1_DEFAULT  ) |
					modbits( 0 , NV04_PFB_CONFIG_1_READ_TO_WRITE    ,   NV04_PFB_CONFIG_1_READ_TO_WRITE_DEFAULT  ) 
					)) ;
  setreg ( NV04_PFB_RTL              , 0x00000000 ) ;
  setreg ( NV04_PBUS_DEBUG_1         , (
					modbits( 0 ,  0:0  , 0x00000000 ) |
					modbits( 0 ,  1:1  , 0x00000000 ) |
					modbits( 0 ,  4:3  , 0x00000001 ) |
					modbits( 0 ,  5:5  , 0x00000000 ) |
					modbits( 0 ,  6:6  , 0x00000001 ) |
					modbits( 0 ,  8:8  , 0x00000001 ) |
					modbits( 0 ,  9:9  , 0x00000001 ) |
					modbits( 0 , 10:10 , 0x00000001 ) |
					modbits( 0 , 12:12 , 0x00000001 ) |
					modbits( 0 , 14:14 , 0x00000001 ) |
 					modbits( 0 , 15:15 , 0x00000000 ) 
					)) ;
  NV04_nv05FbCalcRamSize(nv) ;
  
  value = getreg( NV04_PFB_BOOT_0 ) ; setreg( NV04_PFB_BOOT_0 , value ) ;

  setreg( NV04_PFB_CONFIG_1             , (
					   modbits( 0 , NV04_PFB_CONFIG_1_CAS_LATENCY      ,   NV04_PFB_CONFIG_1_CAS_LATENCY_3          ) |
					   modbits( 0 , NV04_PFB_CONFIG_1_RAS_RAS          ,   NV04_PFB_CONFIG_1_RAS_RAS_DEFAULT        ) |
					   modbits( 0 , NV04_PFB_CONFIG_1_RAS_PCHG         ,   NV04_PFB_CONFIG_1_RAS_PCHG_DEFAULT       ) |
					   modbits( 0 , NV04_PFB_CONFIG_1_RAS_LOW          ,   NV04_PFB_CONFIG_1_RAS_LOW_DEFAULT        ) |
					   modbits( 0 , NV04_PFB_CONFIG_1_MRS_TO_RAS       ,   NV04_PFB_CONFIG_1_MRS_TO_RAS_DEFAULT     ) |
					   modbits( 0 , NV04_PFB_CONFIG_1_WRITE_TO_READ    ,   NV04_PFB_CONFIG_1_WRITE_TO_READ_DEFAULT  ) |
					   modbits( 0 , NV04_PFB_CONFIG_1_RAS_TO_CAS_M1    ,   NV04_PFB_CONFIG_1_RAS_TO_CAS_M1_DEFAULT  ) |
					   modbits( 0 , NV04_PFB_CONFIG_1_READ_TO_WRITE    ,   NV04_PFB_CONFIG_1_READ_TO_WRITE_DEFAULT  ) 
					   )) ;
  setreg( NV04_PRAMDAC_PLL_COEFF_SELECT , (
					   modbits( 0 , NV04_PRAMDAC_PLL_COEFF_SELECT_VPLL_SOURCE  ,  NV04_PRAMDAC_PLL_COEFF_SELECT_VPLL_SOURCE_XTAL ) |
					   modbits( 0 , NV04_PRAMDAC_PLL_COEFF_SELECT_SOURCE       ,  0x00000005                                     ) |
					   modbits( 0 , NV04_PRAMDAC_PLL_COEFF_SELECT_VS_PCLK_TV   ,  NV04_PRAMDAC_PLL_COEFF_SELECT_VS_PCLK_TV_NONE  ) |
					   modbits( 0 , NV04_PRAMDAC_PLL_COEFF_SELECT_TVCLK_SOURCE ,  NV04_PRAMDAC_PLL_COEFF_SELECT_TVCLK_SOURCE_EXT ) |
					   modbits( 0 , NV04_PRAMDAC_PLL_COEFF_SELECT_TVCLK_RATIO  ,  NV04_PRAMDAC_PLL_COEFF_SELECT_TVCLK_RATIO_DB1  ) |
					   modbits( 0 , NV04_PRAMDAC_PLL_COEFF_SELECT_VCLK_RATIO   ,  NV04_PRAMDAC_PLL_COEFF_SELECT_VCLK_RATIO_DB1   ) 
					   )) ;
  setreg( NV04_PBUS_DEBUG_2             , 0x000001f0 ) ;
  setreg( NV04_PBUS_DEBUG_3             , (
					   modbits( 0 ,  1:0  ,  0x00000001 ) |
					   modbits( 0 ,  7:4  ,  0x0000000d ) 
					   )) ;
  return(0) ;
}

int Nv04_DeviceInit( _Nv04Device     *nv )
{
  unsigned long data , value ;
  int status ;


  modreg( NV04_PBUS_PCI_NV_21 , NV04_PBUS_PCI_NV_21_VGA , NV04_PBUS_PCI_NV_21_VGA_ENABLED ) ;
 
  value = getreg( NV04_PBUS_PCI_NV_19 ) ; setreg( NV04_PBUS_PCI_NV_19 , 0x00000000 ) ;

  setreg( NV_PMC_ENABLE  , (
			    modbits( 0 , NV_PMC_ENABLE_PCRTC , NV_PMC_ENABLE_PCRTC_ENABLED ) |
			    modbits( 0 , NV_PMC_ENABLE_PPMI  , NV_PMC_ENABLE_PPMI_ENABLED  ) |
			    modbits( 0 , NV_PMC_ENABLE_PFIFO , NV_PMC_ENABLE_PFIFO_ENABLED )
			    )) ;
	  
  setreg( NV_PMC_ENABLE  , (
			    modbits( 0 , NV_PMC_ENABLE_PFB   , NV_PMC_ENABLE_PFB_ENABLED   ) |
			    modbits( 0 , NV_PMC_ENABLE_PCRTC , NV_PMC_ENABLE_PCRTC_ENABLED ) |
			    modbits( 0 , NV_PMC_ENABLE_PPMI  , NV_PMC_ENABLE_PPMI_ENABLED  ) |
			    modbits( 0 , NV_PMC_ENABLE_PFIFO , NV_PMC_ENABLE_PFIFO_ENABLED )
			    )) ;

  setreg( NV04_PBUS_PCI_NV_19 , value ) ;
  modreg( NV04_PBUS_PCI_NV_20 , NV04_PBUS_PCI_NV_20_ROM_SHADOW , NV04_PBUS_PCI_NV_20_ROM_SHADOW_DISABLED ) ;

  data = getreg( NV04_PMC_BOOT_0 ) ;

  if ( ( rdbits( data , NV04_PMC_BOOT_0_ARCHITECTURE   )  > NV04_PMC_BOOT_0_ARCHITECTURE_NV4 ) |
       ((rdbits( data , NV04_PMC_BOOT_0_ARCHITECTURE   ) == NV04_PMC_BOOT_0_ARCHITECTURE_NV4 ) & 
	(rdbits( data , NV04_PMC_BOOT_0_MASK_REVISION  ) >= NV04_PMC_BOOT_0_MASK_REVISION_B  ))
       )
    status = Nv04_Nv05HwInit(nv) ;
  else
    status = Nv04_Nv04HwInit(nv) ;
  modreg( NV04_PBUS_PCI_NV_20  , NV04_PBUS_PCI_NV_20_ROM_SHADOW  ,  NV04_PBUS_PCI_NV_20_ROM_SHADOW_ENABLED ) ;
  return(status) ;
}

