 /***************************************************************************\
|*                                                                           *|
|*       Copyright 1993-2000 NVIDIA, Corporation.  All rights reserved.      *|
|*                                                                           *|
|*     NOTICE TO USER:   The source code  is copyrighted under  U.S. and     *|
|*     international laws.  Users and possessors of this source code are     *|
|*     hereby granted a nonexclusive,  royalty-free copyright license to     *|
|*     use this code in individual and commercial software.                  *|
|*                                                                           *|
|*     Any use of this source code must include,  in the user documenta-     *|
|*     tion and  internal comments to the code,  notices to the end user     *|
|*     as follows:                                                           *|
|*                                                                           *|
|*       Copyright 1993-2000 NVIDIA, Corporation.  All rights reserved.      *|
|*                                                                           *|
|*     NVIDIA, CORPORATION MAKES NO REPRESENTATION ABOUT THE SUITABILITY     *|
|*     OF  THIS SOURCE  CODE  FOR ANY PURPOSE.  IT IS  PROVIDED  "AS IS"     *|
|*     WITHOUT EXPRESS OR IMPLIED WARRANTY OF ANY KIND.  NVIDIA, CORPOR-     *|
|*     ATION DISCLAIMS ALL WARRANTIES  WITH REGARD  TO THIS SOURCE CODE,     *|
|*     INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, NONINFRINGE-     *|
|*     MENT,  AND FITNESS  FOR A PARTICULAR PURPOSE.   IN NO EVENT SHALL     *|
|*     NVIDIA, CORPORATION  BE LIABLE FOR ANY SPECIAL,  INDIRECT,  INCI-     *|
|*     DENTAL, OR CONSEQUENTIAL DAMAGES,  OR ANY DAMAGES  WHATSOEVER RE-     *|
|*     SULTING FROM LOSS OF USE,  DATA OR PROFITS,  WHETHER IN AN ACTION     *|
|*     OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,  ARISING OUT OF     *|
|*     OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOURCE CODE.     *|
|*                                                                           *|
|*     U.S. Government  End  Users.   This source code  is a "commercial     *|
|*     item,"  as that  term is  defined at  48 C.F.R. 2.101 (OCT 1995),     *|
|*     consisting  of "commercial  computer  software"  and  "commercial     *|
|*     computer  software  documentation,"  as such  terms  are  used in     *|
|*     48 C.F.R. 12.212 (SEPT 1995)  and is provided to the U.S. Govern-     *|
|*     ment only as  a commercial end item.   Consistent with  48 C.F.R.     *|
|*     12.212 and  48 C.F.R. 227.7202-1 through  227.7202-4 (JUNE 1995),     *|
|*     all U.S. Government End Users  acquire the source code  with only     *|
|*     those rights set forth herein.                                        *|
|*                                                                           *|
 \***************************************************************************/

#include "nvhw32.h"

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0000AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0000FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0000ControlParameters;

typedef struct {
  NvU64 timeStamp; 
  NvV32 object; 
  NvV32 data; 
  NvV32 address; 
  NvV32 info[2]; 
  NvV32 status; 
} Nv0001Error;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 flags; 
  NvP64 errorBase; 
  NvU64 errorLimit; 
  NvV32 ignored01[0x008];
} Nv0001AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0001FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 flags; 
  NvU32 errorsReturned; 
  NvV32 ignored00[0x00c];
} Nv0001ControlParameters;

typedef volatile struct {
  NvV32 Reserved00[0x7c0];
} Nv0001Typedef, Nv01Root;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 objectMemory; 
  NvV32 flags; 
  NvU64 offset; 
  NvU64 limit; 
  NvV32 ignored00[0x008];
} Nv0002AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0002FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0002ControlParameters;

typedef volatile struct {
  NvV32 Reserved00[0x7c0];
} Nv0002Typedef, Nv01ContextDma;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvU32 portId; 
  NvV32 ignored00[0x00b];
} Nv0003AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0003FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0003ControlParameters;

typedef volatile struct {
  NvV32 Reserved00[0x7c0];
} Nv0003Typedef, Nv01Device;

typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv0004Notification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 flags; 
  NvV32 ignored00[0x00b];
} Nv0004AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0004FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0004ControlParameters;

typedef volatile struct {
  NvV32 Synchronize; 
  NvV32 StopAlarm; 
  NvV32 Reserved00[0x01e];
  NvV32 SetContextDmaNotifies; 
  NvV32 Reserved01[0x05f];
  NvU32 SetTime0; 
  NvU32 SetTime1; 
  NvV32 SetAlarmNotify; 
  NvV32 Reserved02[0x73d];
} Nv0004Typedef, Nv01Timer;

typedef NvV32 Nv0005Typedef;
typedef NvV32 Nv0006Typedef;
typedef NvV32 Nv0007Typedef;
typedef NvV32 Nv0008Typedef;
typedef NvV32 Nv0009Typedef;
typedef NvV32 Nv000aTypedef;
typedef NvV32 Nv000bTypedef;
typedef NvV32 Nv000cTypedef;
typedef NvV32 Nv000dTypedef;
typedef NvV32 Nv000eTypedef;
typedef NvV32 Nv000fTypedef;
typedef NvV32 Nv0010Typedef;
typedef NvV32 Nv0011Typedef;

typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv0012Notification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv0012AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0012FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0012ControlParameters;

typedef volatile struct {
  NvV32 NoOperation; 
  NvV32 Notify; 
  NvV32 Reserved00[0x01e];
  NvV32 SetContextDmaNotifies; 
  NvV32 Reserved01[0x05f];
  NvV32 SetBeta1d31; 
  NvV32 Reserved02[0x73f];
} Nv0012Typedef, Nv01ContextBeta1;

typedef NvV32 Nv0013Typedef;
typedef NvV32 Nv0014Typedef;
typedef NvV32 Nv0015Typedef;
typedef NvV32 Nv0016Typedef;

typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv0017Notification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv0017AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0017FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0017ControlParameters;

typedef volatile struct {
  NvV32 NoOperation; 
  NvV32 Notify; 
  NvV32 Reserved00[0x01e];
  NvV32 SetContextDmaNotifies; 
  NvV32 Reserved01[0x05f];
  NvV32 SetColorFormat; 
  NvV32 SetColor; 
  NvV32 Reserved02[0x73e];
} Nv0017Typedef, Nv01ContextColorKey;

typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv0018Notification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv0018AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0018FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0018ControlParameters;

typedef volatile struct {
  NvV32 NoOperation; 
  NvV32 Notify; 
  NvV32 Reserved00[0x01e];
  NvV32 SetContextDmaNotifies; 
  NvV32 Reserved01[0x05f];
  NvV32 SetColorFormat; 
  NvV32 SetMonochromeFormat; 
  NvV32 SetMonochromeShape; 
  NvV32 Reserved02[0x001];
  NvV32 SetMonochromeColor0; 
  NvV32 SetMonochromeColor1; 
  NvV32 SetMonochromePattern0; 
  NvV32 SetMonochromePattern1; 
  NvV32 Reserved03[0x738];
} Nv0018Typedef, Nv01ContextPattern;

typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv0019Notification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv0019AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0019FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0019ControlParameters;

typedef volatile struct {
  NvV32 NoOperation; 
  NvV32 Notify; 
  NvV32 Reserved00[0x01e];
  NvV32 SetContextDmaNotifies; 
  NvV32 Reserved01[0x05f];
  NvV32 SetPoint; 
  NvV32 SetSize; 
  NvV32 Reserved02[0x73e];
} Nv0019Typedef, Nv01ContextClipRectangle;

typedef NvV32 Nv001aTypedef;
typedef NvV32 Nv001bTypedef;

typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv001cNotification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv001cAllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv001cFreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv001cControlParameters;

typedef volatile struct {
  NvV32 NoOperation; 
  NvV32 Notify; 
  NvV32 Reserved00[0x01e];
  NvV32 SetContextDmaNotifies; 
  NvV32 SetContextClipRectangle; 
  NvV32 SetContextPattern; 
  NvV32 SetContextRop; 
  NvV32 SetContextBeta1; 
  NvV32 SetContextSurface; 
  NvV32 Reserved01[0x059];
  NvV32 SetOperation; 
  NvV32 SetColorFormat; 
  NvV32 Color; 
  NvV32 Reserved02[0x03e];
  struct { 
    NvV32 point0; 
    NvV32 point1; 
  } Lin[16]; 
  struct { 
    NvS32 point0X; 
    NvS32 point0Y; 
    NvS32 point1X; 
    NvS32 point1Y; 
  } Lin32[8]; 
  NvV32 PolyLin[32]; 
  struct { 
    NvS32 x; 
    NvS32 y; 
  } PolyLin32[16]; 
  struct { 
    NvV32 color; 
    NvV32 point; 
  } ColorPolyLin[16]; 
  NvV32 Reserved03[0x660];
} Nv001cTypedef, Nv01RenderSolidLin;

typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv001dNotification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv001dAllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv001dFreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv001dControlParameters;

typedef volatile struct {
  NvV32 NoOperation; 
  NvV32 Notify; 
  NvV32 Reserved00[0x01e];
  NvV32 SetContextDmaNotifies; 
  NvV32 SetContextClipRectangle; 
  NvV32 SetContextPattern; 
  NvV32 SetContextRop; 
  NvV32 SetContextBeta1; 
  NvV32 SetContextSurface; 
  NvV32 Reserved01[0x059];
  NvV32 SetOperation; 
  NvV32 SetColorFormat; 
  NvV32 Color; 
  NvV32 Reserved02[0x002];
  NvV32 TrianglePoint0; 
  NvV32 TrianglePoint1; 
  NvV32 TrianglePoint2; 
  NvV32 Reserved03[0x001];
  NvS32 Triangle32Point0X; 
  NvS32 Triangle32Point0Y; 
  NvS32 Triangle32Point1X; 
  NvS32 Triangle32Point1Y; 
  NvS32 Triangle32Point2X; 
  NvS32 Triangle32Point2Y; 
  NvV32 Reserved04[0x032];
  NvV32 Trimesh[32]; 
  struct { 
    NvS32 x; 
    NvS32 y; 
  } Trimesh32[16]; 
  struct { 
    NvV32 color; 
    NvV32 point0; 
    NvV32 point1; 
    NvV32 point2; 
  } ColorTriangle[8]; 
  struct { 
    NvV32 color; 
    NvV32 point; 
  } ColorTrimesh[16]; 
  NvV32 Reserved05[0x680];
} Nv001dTypedef, Nv01RenderSolidTriangle;


typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv001eNotification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv001eAllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv001eFreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv001eControlParameters;

typedef volatile struct {
  NvV32 NoOperation; 
 NvV32 Notify; 
  NvV32 Reserved00[0x01e];
  NvV32 SetContextDmaNotifies; 
  NvV32 SetContextClipRectangle; 
  NvV32 SetContextPattern; 
  NvV32 SetContextRop; 
  NvV32 SetContextBeta1; 
  NvV32 SetContextSurface; 
  NvV32 Reserved01[0x059];
  NvV32 SetOperation; 
  NvV32 SetColorFormat; 
  NvV32 Color; 
  NvV32 Reserved02[0x03e];
  struct { 
    NvV32 point; 
    NvV32 size; 
  } Rectangle[16]; 
  NvV32 Reserved03[0x6e0];
} Nv001eTypedef, Nv01RenderSolidRectangle;

typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv001fNotification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv001fAllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv001fFreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv001fControlParameters;

typedef volatile struct {
  NvV32 NoOperation; 
  NvV32 Notify; 
  NvV32 Reserved00[0x01e];
  NvV32 SetContextDmaNotifies; 
  NvV32 SetContextColorKey; 
  NvV32 SetContextClipRectangle; 
  NvV32 SetContextPattern; 
  NvV32 SetContextRop; 
  NvV32 SetContextBeta1; 
  NvV32 Reserved01[0x001];
  NvV32 SetContextSurfaces; 
  NvV32 Reserved02[0x057];
  NvV32 SetOperation; 
  NvV32 ControlPointIn; 
  NvV32 ControlPointOut; 
  NvV32 Size; 
  NvV32 Reserved03[0x73d];
} Nv001fTypedef, Nv01ImageBlit;

typedef NvV32 Nv0020Typedef;

typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv0021Notification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv0021AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0021FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
 NvV32 ignored00[0x00e];
} Nv0021ControlParameters;

typedef volatile struct {
 NvV32 NoOperation; 
 NvV32 Notify; 
 NvV32 Reserved00[0x01e];
 NvV32 SetContextDmaNotifies; 
 NvV32 SetContextColorKey; 
 NvV32 SetContextClipRectangle; 
 NvV32 SetContextPattern; 
 NvV32 SetContextRop; 
 NvV32 SetContextBeta1; 
 NvV32 SetContextSurface; 
 NvV32 Reserved01[0x058];
 NvV32 SetOperation; 
 NvV32 SetColorFormat; 
 NvV32 Point; 
 NvV32 SizeOut; 
 NvV32 SizeIn; 
 NvV32 Reserved02[0x03c];
 NvV32 Color[32]; 
 NvV32 Reserved03[0x6e0];
} Nv0021Typedef, Nv01ImageFromCpu;

typedef NvV32 Nv0022Typedef;
typedef NvV32 Nv0023Typedef;
typedef NvV32 Nv0024Typedef;
typedef NvV32 Nv0025Typedef;
typedef NvV32 Nv0026Typedef;
typedef NvV32 Nv0027Typedef;
typedef NvV32 Nv0028Typedef;
typedef NvV32 Nv0029Typedef;
typedef NvV32 Nv002aTypedef;
typedef NvV32 Nv002bTypedef;
typedef NvV32 Nv002cTypedef;
typedef NvV32 Nv002dTypedef;
typedef NvV32 Nv002eTypedef;
typedef NvV32 Nv002fTypedef;

typedef struct {
 NvV32 classNumber; 
 NvV32 status; 
 NvV32 ignored00[0x00e];
} Nv0030AllocParameters;

typedef struct {
 NvV32 object; 
 NvV32 status; 
 NvV32 ignored00[0x00e];
} Nv0030FreeParameters;

typedef struct {
 NvV32 object; 
 NvV32 status; 
 NvV32 ignored00[0x00e];
} Nv0030ControlParameters;

typedef volatile struct {
 NvV32 Reserved00[0x7c0];
} Nv0030Typedef, Nv01Null;

typedef NvV32 Nv0031Typedef;
typedef NvV32 Nv0032Typedef;
typedef NvV32 Nv0033Typedef;
typedef NvV32 Nv0034Typedef;
typedef NvV32 Nv0035Typedef;

typedef volatile struct {
 NvU64 timeStamp; 
 NvV8 zero[0x007]; 
 NvV8 status; 
} Nv0036Notification;

typedef struct {
 NvV32 classNumber; 
 NvV32 status; 
 NvV32 objectNew; 
 NvV32 objectParent; 
 NvV32 ignored00[0x00c];
} Nv0036AllocParameters;

typedef struct {
 NvV32 object; 
 NvV32 status; 
 NvV32 ignored00[0x00e];
} Nv0036FreeParameters;

typedef struct {
 NvV32 object; 
 NvV32 status; 
 NvV32 ignored00[0x00e];
} Nv0036ControlParameters;

typedef volatile struct {
 NvV32 NoOperation; 
 NvV32 Notify; 
 NvV32 Reserved00[0x01e];
 NvV32 SetContextDmaNotifies; 
 NvV32 SetContextColorKey; 
 NvV32 SetContextPattern; 
 NvV32 SetContextRop; 
 NvV32 SetContextBeta1; 
 NvV32 SetContextSurface; 
 NvV32 Reserved01[0x059];
 NvV32 SetOperation; 
 NvV32 SetColorFormat; 
 NvV32 SizeIn; 
 NvV32 DxDu; 
 NvV32 DyDv; 
 NvV32 ClipPoint; 
 NvV32 ClipSize; 
 NvV32 Point12d4; 
 NvV32 Reserved02[0x039];
 NvV32 Color[1792]; 
} Nv0036Typedef, Nv03StretchedImageFromCpu;

typedef volatile struct {
 NvU64 timeStamp; 
 NvV8 zero[0x007]; 
 NvV8 status; 
} Nv0037Notification;

typedef struct {
 NvV32 classNumber; 
 NvV32 status; 
 NvV32 objectNew; 
 NvV32 objectParent; 
 NvV32 ignored00[0x00c];
} Nv0037AllocParameters;

typedef struct {
 NvV32 object; 
 NvV32 status; 
 NvV32 ignored00[0x00e];
} Nv0037FreeParameters;

typedef struct {
 NvV32 object; 
 NvV32 status; 
 NvV32 ignored00[0x00e];
} Nv0037ControlParameters;

typedef volatile struct {
 NvV32 NoOperation; 
 NvV32 Notify; 
 NvV32 Reserved00[0x01e];
 NvV32 SetContextDmaNotifies; 
 NvV32 SetContextDmaImage; 
 NvV32 SetContextPattern; 
 NvV32 SetContextRop; 
 NvV32 SetContextBeta1; 
 NvV32 SetContextSurface; 
 NvV32 Reserved01[0x05a];
 NvV32 SetColorFormat; 
 NvV32 SetOperation; 
 NvV32 ClipPoint; 
 NvV32 ClipSize; 
 NvV32 ImageOutPoint; 
 NvV32 ImageOutSize; 
 NvV32 DuDx; 
 NvV32 DvDy; 
 NvV32 Reserved02[0x038];
 NvV32 ImageInSize; 
 NvV32 ImageInFormat; 
 NvU32 ImageInOffset; 
 NvV32 ImageInPoint; 
 NvV32 Reserved03[0x6fc];
} Nv0037Typedef, Nv03ScaledImageFromMemory;

typedef NvV32 Nv0038Typedef;
typedef NvV32 Nv0039Typedef;
typedef NvV32 Nv003aTypedef;
typedef NvV32 Nv003bTypedef;
typedef NvV32 Nv003cTypedef;

typedef struct {
 NvV32 classNumber; 
 NvV32 status; 
 NvV32 objectNew; 
 NvV32 objectParent; 
 NvP64 base; 
 NvU64 limit; 
 NvV32 flags; 
 NvU32 portId; 
 NvV32 ignored00[0x006];
} Nv003dAllocParameters;

typedef struct {
 NvV32 object; 
 NvV32 status; 
 NvV32 ignored00[0x00e];
} Nv003dFreeParameters;

typedef struct {
 NvV32 object; 
 NvV32 status; 
 NvV32 ignored00[0x00e];
} Nv003dControlParameters;

typedef volatile struct {
 NvV32 Reserved00[0x7c0];
} Nv003dTypedef, Nv01MemoryLocalBanked;

typedef struct {
 NvV32 classNumber; 
 NvV32 status; 
 NvV32 objectNew; 
 NvV32 objectParent; 
 NvP64 base; 
 NvU64 limit; 
 NvV32 ignored00[0x008];
} Nv003eAllocParameters;

typedef struct {
 NvV32 object; 
 NvV32 status; 
 NvV32 ignored00[0x00e];
} Nv003eFreeParameters;

typedef struct {
 NvV32 object; 
 NvV32 status; 
 NvV32 ignored00[0x00e];
} Nv003eControlParameters;

typedef volatile struct {
 NvV32 Reserved00[0x7c0];
} Nv003eTypedef, Nv01MemorySystem;

typedef struct {
 NvV32 classNumber; 
 NvV32 status; 
 NvV32 objectNew; 
 NvV32 objectParent; 
 NvP64 base; 
 NvU64 limit; 
 NvV32 flags; 
 NvV32 ignored00[0x007];
} Nv003fAllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv003fFreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv003fControlParameters;

typedef volatile struct {
  NvV32 Reserved00[0x7c0];
} Nv003fTypedef, Nv03MemoryLocalCursor;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvP64 base; 
  NvU64 limit; 
  NvV32 flags; 
  NvV32 ignored00[0x007];
} Nv0040AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0040FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0040ControlParameters;

typedef volatile struct {
  NvV32 Reserved00[0x7c0];
} Nv0040Typedef, Nv01MemoryLocalLinear;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvP64 base; 
  NvU64 limit; 
  NvV32 classMemory; 
  NvV32 ignored00[0x007];
} Nv0041AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0041FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0041ControlParameters;

typedef volatile struct {
  NvV32 Reserved00[0x7c0];
} Nv0041Typedef, Nv01MappingLocal;

typedef NvV32 Nv0042Typedef;

typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv0043Notification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv0043AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0043FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0043ControlParameters;

typedef volatile struct {
  NvV32 NoOperation; 
  NvV32 Notify; 
  NvV32 Reserved00[0x01e];
  NvV32 SetContextDmaNotifies; 
  NvV32 Reserved01[0x05f];
  NvV32 SetRop; 
  NvV32 Reserved02[0x73f];
} Nv0043Typedef, Nv03ContextRop;

typedef NvV32 Nv0044Typedef;
typedef NvV32 Nv0045Typedef;

typedef volatile struct {
  NvU64 timeStamp; 
  NvU32 offset; 
  NvV8 zero[0x003]; 
  NvV8 status; 
} Nv0046Notification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvU32 portId; 
  NvU32 limitBandwidth; 
  NvU32 limitPixelClock; 
  NvV32 overheadImage; 
  NvV32 overheadCursor; 
  NvV32 ignored00[0x007];
} Nv0046AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0046FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0046ControlParameters;

typedef volatile struct {
  NvV32 Synchronize; 
  NvV32 StopImage; 
  NvV32 StopCursor; 
  NvV32 StopDac; 
  NvV32 Reserved00[0x01c];
  NvV32 SetContextDmaNotifies; 
  NvV32 SetContextDmaImage[2]; 
  NvV32 SetContextDmaLut[2]; 
  NvV32 SetContextDmaCursor[2]; 
  NvV32 Reserved01[0x058];
  NvV32 Get; 
  struct { 
    NvU32 offset; 
    NvV32 format; 
  } SetImage[2]; 
  NvV32 Reserved02[0x00c];
  struct { 
    NvU32 offset; 
    NvV32 pointOut; 
    NvV32 format; 
  } SetCursor[2]; 
  NvV32 SetCursorPointOutA; 
  NvV32 Reserved03[0x009];
  struct { 
    NvV32 imageSize; 
    NvV32 horizontalSync; 
    NvV32 verticalSync; 
    NvV32 totalSize; 
  } SetDac[2]; 
  NvU32 SetPixelClock; 
  NvV32 Reserved04[0x717];
} Nv0046Typedef, nv03VideoLutCursorDac;

typedef NvV32 Nv0047Typedef;
typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv0048Notification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv0048AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0048FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0048ControlParameters;

typedef volatile struct {
  NvV32 NoOperation; 
  NvV32 Notify; 
  NvV32 Reserved00[0x01e];
  NvV32 SetContextDmaNotifies; 
  NvV32 SetContextDmaTexture; 
  NvV32 SetContextClipRectangle; 
  NvV32 SetContextSurfaces; 
  NvV32 Reserved01[0x05d];
  NvU32 TextureOffset; 
  NvV32 TextureFormat; 
  NvV32 TextureFilter; 
  NvV32 FogColor; 
  NvV32 Control0; 
  NvV32 Control1; 
  NvV32 Reserved02[0x339];
  struct { 
    NvV32 specular; 
    NvV32 color; 
    NvF32 sx; 
    NvF32 sy; 
    NvF32 sz; 
    NvF32 rhw; 
    NvF32 tu; 
    NvF32 tv; 
  } Tlvertex[128]; 
} Nv0048Typedef, Nv03Dx3TexturedTriangle;

typedef NvV32 Nv0049Typedef;
typedef NvV32 Nv004aTypedef;

typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv004bNotification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv004bAllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv004bFreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv004bControlParameters;

typedef volatile struct {
  NvV32 NoOperation; 
  NvV32 Notify; 
  NvV32 Reserved00[0x01e];
  NvV32 SetContextDmaNotifies; 
  NvV32 SetContextPattern; 
  NvV32 SetContextRop; 
  NvV32 SetContextBeta1; 
  NvV32 SetContextSurface; 
  NvV32 Reserved01[0x05a];
  NvV32 SetOperation; 
  NvV32 SetColorFormat; 
  NvV32 SetMonochromeFormat; 
  NvV32 Reserved02[0x03d];
  NvV32 Color1A; 
  struct { 
    NvV32 point; 
    NvV32 size; 
  } UnclippedRectangle[64]; 
  NvV32 Reserved03[0x07D];
  NvV32 ClipPoint0B; 
  NvV32 ClipPoint1B; 
  NvV32 Color1B; 
  struct { 
    NvV32 point0; 
    NvV32 point1; 
  } ClippedRectangle[64]; 
  NvV32 Reserved04[0x07B];
  NvV32 ClipPoint0C; 
  NvV32 ClipPoint1C; 
  NvV32 Color1C; 
  NvV32 SizeC; 
  NvV32 PointC; 
  NvV32 MonochromeColor1C[128]; 
  NvV32 Reserved05[0x07A];
  NvV32 ClipPoint0D; 
  NvV32 ClipPoint1D; 
  NvV32 Color1D; 
  NvV32 SizeInD; 
  NvV32 SizeOutD; 
  NvV32 PointD; 
  NvV32 MonochromeColor1D[128]; 
  NvV32 Reserved06[0x079];
  NvV32 ClipPoint0E; 
  NvV32 ClipPoint1E; 
  NvV32 Color0E; 
  NvV32 Color1E; 
  NvV32 SizeInE; 
  NvV32 SizeOutE; 
  NvV32 PointE; 
  NvV32 MonochromeColor01E[128]; 
  NvV32 Reserved07[0x280];
} Nv004bTypedef, Nv03GdiRectangleText;

typedef NvV32 Nv004cTypedef;
typedef NvV32 Nv004dTypedef;
typedef NvV32 Nv004eTypedef;
typedef NvV32 Nv004fTypedef;
typedef NvV32 Nv0050Typedef;
typedef NvV32 Nv0051Typedef;
typedef NvV32 Nv0052Typedef;

typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv0053Notification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv0053AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0053FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0053ControlParameters;

typedef volatile struct {
  NvV32 NoOperation; 
  NvV32 Notify; 
  NvV32 Reserved00[0x01e];
  NvV32 SetContextDmaNotifies; 
  NvV32 SetContextDmaColor; 
  NvV32 SetContextDmaZeta; 
  NvV32 Reserved01[0x05b];
  NvV32 SetClipHorizontal; 
  NvV32 SetClipVertical; 
  NvV32 SetFormat; 
  NvV32 SetClipSize; 
  NvV32 SetPitch; 
  NvU32 SetOffsetColor; 
  NvU32 SetOffsetZeta; 
  NvV32 Reserved02[0x73b];
} Nv0053Typedef, Nv04ContextSurfaces3d;

typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv0054Notification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv0054AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0054FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0054ControlParameters;

typedef volatile struct {
  NvV32 NoOperation; 
  NvV32 Notify; 
  NvV32 Reserved00[0x01e];
  NvV32 SetContextDmaNotifies; 
  NvV32 SetContextDmaA; 
  NvV32 SetContextDmaB; 
  NvV32 SetContextSurfaces; 
  NvV32 Reserved01[0x05c];
  NvV32 ColorKeyValue; 
  NvU32 TextureOffset; 
  NvV32 TextureFormat; 
  NvV32 TextureFilter; 
  NvV32 Blend; 
  NvV32 Control; 
  NvV32 FogColor; 
  NvV32 Reserved02[0x039];
  struct { 
    NvF32 sx; 
    NvF32 sy; 
    NvF32 sz; 
    NvF32 rhw; 
    NvV32 color; 
    NvV32 specular; 
    NvF32 tu; 
    NvF32 tv; 
  } Tlvertex[16]; 
  NvV32 DrawPrimitive[64]; 
  NvV32 Reserved03[0x640];
} Nv0054Typedef, Nv04Dx5TexturedTriangle;

typedef NvV32 Nv0055Typedef;
typedef NvV32 Nv0056Typedef;
typedef NvV32 Nv0057Typedef;

typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv0058Notification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv0058AllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0058FreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv0058ControlParameters;

typedef volatile struct {
  NvV32 Synchronize; 
  NvV32 Reserved00[0x01f];
  NvV32 SetContextDmaNotifies; 
  NvV32 SetContextDmaSource; 
  NvV32 SetContextDmaDestin; 
  NvV32 Reserved01[0x05d];
  NvV32 SetFormat; 
  NvU32 SetPitch; 
  NvU32 SetOffsetSource; 
  NvU32 SetOffsetDestin; 
  NvV32 Reserved02[0x73c];
} Nv0058Typedef, Nv03ContextSurfaces2d;

typedef volatile struct {
  NvU64 timeStamp; 
  NvV8 zero[0x007]; 
  NvV8 status; 
} Nv005aNotification;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 ignored00[0x00c];
} Nv005aAllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv005aFreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv005aControlParameters;

typedef volatile struct {
  NvV32 Synchronize; 
  NvV32 Reserved00[0x01f];
  NvV32 SetContextDmaNotifies; 
  NvV32 SetContextDmaSurfaces; 
  NvV32 Reserved01[0x05e];
  NvU32 SetPitch; 
  NvU32 SetOffsetColor; 
  NvU32 SetOffsetZeta; 
  NvV32 Reserved02[0x73d];
} Nv005aTypedef, Nv03ContextSurfaces3d;

typedef NvV32 Nv005cTypedef;
typedef NvV32 Nv005dTypedef;
typedef NvV32 Nv005eTypedef;
typedef NvV32 Nv005fTypedef;
typedef NvV32 Nv0060Typedef;
typedef NvV32 Nv0061Typedef;
typedef NvV32 Nv0062Typedef;
typedef NvV32 Nv0063Typedef;
typedef NvV32 Nv0064Typedef;
typedef NvV32 Nv0065Typedef;
typedef NvV32 Nv0066Typedef;
typedef NvV32 Nv0067Typedef;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvV32 objectBuffer; 
  NvU32 offset; 
  NvV32 ignored00[0x00a];
} Nv006bAllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv006bFreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 info; 
  NvV32 flags; 
  NvV32 get; 
  NvV32 put; 
  NvV32 jump; 
  NvV32 ignored00[0x009];
} Nv006bControlParameters;

typedef volatile struct {
  NvV32 Reserved00[0x7c0];
} Nv006bTypedef, Nv03ChannelDma;

typedef NvV32 Nv006cTypedef;
typedef NvV32 Nv006dTypedef;
typedef NvV32 Nv006eTypedef;
typedef NvV32 Nv0072Typedef;
typedef NvV32 Nv0076Typedef;
typedef NvV32 Nv0077Typedef;
typedef NvV32 Nv0079Typedef;
typedef NvV32 Nv007aTypedef;
typedef NvV32 Nv007bTypedef;
typedef NvV32 Nv007cTypedef;
typedef NvV32 Nv007dTypedef;
typedef NvV32 Nv007eTypedef;
typedef NvV32 Nv007fTypedef;
typedef NvV32 Nv0082Typedef;
typedef NvV32 Nv0084Typedef;
typedef NvV32 Nv0085Typedef;
typedef NvV32 Nv0087Typedef;
typedef NvV32 Nv0088Typedef;
typedef NvV32 Nv0093Typedef;
typedef NvV32 Nv0094Typedef;
typedef NvV32 Nv0095Typedef;
typedef NvV32 Nv0068Typedef;
typedef NvV32 Nv0069Typedef;

typedef struct {
  NvV32 classNumber; 
  NvV32 status; 
  NvV32 objectNew; 
  NvV32 objectParent; 
  NvP64 base; 
  NvU64 limit; 
  NvV32 ignored00[0x008];
} Nv006aAllocParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 ignored00[0x00e];
} Nv006aFreeParameters;

typedef struct {
  NvV32 object; 
  NvV32 status; 
  NvV32 info; 
  NvV32 ignored00[0x00d];
} Nv006aControlParameters;

typedef volatile struct {
  NvV32 Reserved00[0x7c0];
} Nv006aTypedef, Nv03ChannelPio;

typedef volatile struct {
  NvV32 SetObject; 
  NvV32 Reserved00[0x003];
  NvU16 Free; 
  NvU16 Zero[7]; 
  NvV32 Reserved01[0x038];
  union { 
    Nv0001Typedef nv01Root ;
    Nv0002Typedef nv01ContextDma ;
    Nv0003Typedef nv01Device ;
    Nv0004Typedef nv01Timer ;
    Nv0005Typedef NV0005_TYPEDEF;
    Nv0006Typedef NV0006_TYPEDEF;
    Nv0007Typedef NV0007_TYPEDEF;
    Nv0008Typedef NV0008_TYPEDEF;
    Nv0009Typedef NV0009_TYPEDEF;
    Nv000aTypedef NV000A_TYPEDEF;
    Nv000bTypedef NV000B_TYPEDEF;
    Nv000cTypedef NV000C_TYPEDEF;
    Nv000dTypedef NV000D_TYPEDEF;
    Nv000eTypedef NV000E_TYPEDEF;
    Nv000fTypedef NV000F_TYPEDEF;
    Nv0010Typedef NV0010_TYPEDEF;
    Nv0011Typedef NV0011_TYPEDEF;
    Nv0012Typedef nv01ContextBeta1 ;
    Nv0013Typedef NV0013_TYPEDEF;
    Nv0014Typedef NV0014_TYPEDEF;
    Nv0015Typedef NV0015_TYPEDEF;
    Nv0016Typedef NV0016_TYPEDEF;
    Nv0017Typedef nv01ContextColorKey ;
    Nv0018Typedef nv01ContextPattern ;
    Nv0019Typedef nv01ContextClipRectangle ;
    Nv001aTypedef NV001A_TYPEDEF;
    Nv001bTypedef NV001B_TYPEDEF;
    Nv001cTypedef nv01RenderSolidLin ;
    Nv001dTypedef nv01RenderSolidTriangle ;
    Nv001eTypedef nv01RenderSolidRectangle ;
    Nv001fTypedef nv01ImageBlit ;
    Nv0020Typedef NV0020_TYPEDEF;
    Nv0021Typedef nv01ImageFromCpu ;
    Nv0022Typedef NV0022_TYPEDEF;
    Nv0023Typedef NV0023_TYPEDEF;
    Nv0024Typedef NV0024_TYPEDEF;
    Nv0025Typedef NV0025_TYPEDEF;
    Nv0026Typedef NV0026_TYPEDEF;
    Nv0027Typedef NV0027_TYPEDEF;
    Nv0028Typedef NV0028_TYPEDEF;
    Nv0029Typedef NV0029_TYPEDEF;
    Nv002aTypedef NV002A_TYPEDEF;
    Nv002bTypedef NV002B_TYPEDEF;
    Nv002cTypedef NV002C_TYPEDEF;
    Nv002dTypedef NV002D_TYPEDEF;
    Nv002eTypedef NV002E_TYPEDEF;
    Nv002fTypedef NV002F_TYPEDEF;
    Nv0030Typedef nv01Null ;
    Nv0031Typedef NV0031_TYPEDEF;
    Nv0032Typedef NV0032_TYPEDEF;
    Nv0033Typedef NV0033_TYPEDEF;
    Nv0034Typedef NV0034_TYPEDEF;
    Nv0035Typedef NV0035_TYPEDEF;
    Nv0036Typedef nv03StretchedImageFromCpu ;
    Nv0037Typedef nv03ScaledImageFromMemory ;
    Nv0038Typedef NV0038_TYPEDEF;
    Nv0039Typedef NV0039_TYPEDEF;
    Nv003aTypedef NV003A_TYPEDEF;
    Nv003bTypedef NV003B_TYPEDEF;
    Nv003cTypedef NV003C_TYPEDEF;
    Nv003dTypedef nv01MemoryLocalBanked ;
    Nv003eTypedef nv01MemorySystem ;
    Nv003fTypedef nv03MemoryLocalCursor ;
    Nv0040Typedef nv01MemoryLocalLinear ;
    Nv0042Typedef NV0042_TYPEDEF;
    Nv0043Typedef nv03ContextRop ;
    Nv0044Typedef NV0044_TYPEDEF;
    Nv0045Typedef NV0045_TYPEDEF;
    Nv0046Typedef nv03VideoLutCursorDac ;
    Nv0047Typedef NV0047_TYPEDEF;
    Nv0048Typedef nv03Dx3TexturedTriangle ;
    Nv0049Typedef NV0049_TYPEDEF;
    Nv004aTypedef NV004A_TYPEDEF;
    Nv004bTypedef nv03GdiRectangleText ;
    Nv004cTypedef NV004C_TYPEDEF;
    Nv004dTypedef NV004D_TYPEDEF;
    Nv004eTypedef NV004E_TYPEDEF;
    Nv004fTypedef NV004F_TYPEDEF;
    Nv0050Typedef NV0050_TYPEDEF;
    Nv0051Typedef NV0051_TYPEDEF;
    Nv0052Typedef NV0052_TYPEDEF;
    Nv0053Typedef nv04ContextSurfaces3d ;
    Nv0054Typedef nv04Dx5TexturedTriangle ;
    Nv0055Typedef NV0055_TYPEDEF;
    Nv0056Typedef NV0056_TYPEDEF;
    Nv0057Typedef NV0057_TYPEDEF;
    Nv0058Typedef nv03ContextSurfaces2d ;
    Nv005aTypedef nv03ContextSurfaces3d ;
    Nv005cTypedef NV005C_TYPEDEF;
    Nv005dTypedef NV005D_TYPEDEF;
    Nv005eTypedef NV005E_TYPEDEF;
    Nv005fTypedef NV005F_TYPEDEF;
    Nv0060Typedef NV0060_TYPEDEF;
    Nv0061Typedef NV0061_TYPEDEF;
    Nv0062Typedef NV0062_TYPEDEF;
    Nv0063Typedef NV0063_TYPEDEF;
    Nv0064Typedef NV0064_TYPEDEF;
    Nv0065Typedef NV0065_TYPEDEF;
    Nv0066Typedef NV0066_TYPEDEF;
    Nv0067Typedef NV0067_TYPEDEF;
    Nv0068Typedef NV0068_TYPEDEF;
    Nv0069Typedef NV0069_TYPEDEF;
    Nv006aTypedef nv03ChannelPio ;
    Nv006bTypedef nv03ChannelDma ;
    Nv006cTypedef NV006C_TYPEDEF;
    Nv006dTypedef NV006D_TYPEDEF;
    Nv006eTypedef NV006E_TYPEDEF;
    Nv0072Typedef NV0072_TYPEDEF;
    Nv0076Typedef NV0076_TYPEDEF;
    Nv0077Typedef NV0077_TYPEDEF;
    Nv0079Typedef NV0079_TYPEDEF;
    Nv007aTypedef NV007A_TYPEDEF;
    Nv007bTypedef NV007B_TYPEDEF;
    Nv007cTypedef NV007C_TYPEDEF;
    Nv007dTypedef NV007D_TYPEDEF;
    Nv007eTypedef NV007E_TYPEDEF;
    Nv007fTypedef NV007F_TYPEDEF;
    Nv0082Typedef NV0082_TYPEDEF;
    Nv0084Typedef NV0084_TYPEDEF;
    Nv0085Typedef NV0085_TYPEDEF;
    Nv0087Typedef NV0087_TYPEDEF;
    Nv0088Typedef NV0088_TYPEDEF;
    Nv0093Typedef NV0093_TYPEDEF;
    Nv0094Typedef NV0094_TYPEDEF;
    Nv0095Typedef NV0095_TYPEDEF;
  } u; 
} Nv006aSubchannel;

typedef volatile struct { 
  Nv006aSubchannel subchannel[(8) ]; 
} Nv006aChannel; 
