/* * AGP/PCI Bus */ 


#define NV04_MEMORY  0xFFFFFFFF:0x00000000 /* RW */ 
#define NV04_IO      0xFFFFFFFF:0x00000000 /* RW */ 
#define NV04_CONFIG  0x000000FF:0x00000000 /* RW */ 
#define NV04_EXPROM  0x0000FFFF:0x00000000 /* R- */ 
#define NV04_SPACE   0x01FFFFFF:0x00000000 /* RW */
#define NV04_RSPACE  0x00FFFFFF:0x00000000 /* RW */ 
#define NV04_MSPACE  0x01FFFFFF:0x00000000 /* RW */ 

#define NV04_PBUS    0x00001FFF:0x00001000 /* RW */
 

#define NV04_PBUS_DEBUG_0          0x00001080 /* RWR */ 
#define NV04_PBUS_DEBUG_1          0x00001084 /* RWR */ 
#define NV04_PBUS_DEBUG_2          0x00001088 /* RWR */ 
#define NV04_PBUS_DEBUG_3          0x0000108C /* RWR */ 
#define NV04_PBUS_DEBUG_CTL        0x00001090 /* RWR */ 
#define NV04_PBUS_DEBUG_READ       0x00001094 /* R-R */ 
#define NV04_PBUS_DEBUG_HOST       0x0000109C /* RWR */ 
#define NV04_PBUS_DEBUG_SEL_0      0x000010A0 /* RWR */ 
#define NV04_PBUS_DEBUG_SEL_1      0x000010A4 /* RWR */ 
#define NV04_PBUS_DEBUG_SEL_2      0x000010A8 /* RWR */ 
#define NV04_PBUS_DEBUG_SEL_3      0x000010AC /* RWR */ 
#define NV04_PBUS_DEBUG_CTRIM_0    0x000010B0 /* RWR */ 
#define NV04_PBUS_DEBUG_CTRIM_1    0x000010B4 /* RWR */
#define NV04_PBUS_DEBUG_CTRIM_2    0x000010B8 /* RWR */ 
#define NV04_PBUS_DEBUG_CTRIM_3    0x000010BC /* RWR */ 
#define NV04_PBUS_DEBUG_AGPPLL     0x000010C0 /* RWR */ 
#define NV04_PBUS_DEBUG_PORT       0x000010D0 /* RWR */ 
#define NV04_PBUS_DEBUG_PRIV_ASRC  0x000010E0 /* RWR */ 


#define NV04_PBUS_INTR_0                            0x00001100 /* RWR */ 
#define NV04_PBUS_INTR_0_PCI_BUS_ERROR          0:0            /* RWF */ 
#define NV04_PBUS_INTR_0_PCI_BUS_ERROR_NOT_PENDING  0x00000000 /* R-V */ 
#define NV04_PBUS_INTR_0_PCI_BUS_ERROR_PENDING      0x00000001 /* R-V */ 
#define NV04_PBUS_INTR_0_PCI_BUS_ERROR_RESET        0x00000001 /* -WV */

#define NV04_PBUS_INTR_EN_0                         0x00001140 /* RWR */ 
#define NV04_PBUS_INTR_EN_0_PCI_BUS_ERROR       0:0            /* RWF */ 
#define NV04_PBUS_INTR_EN_0_PCI_BUS_ERROR_DISABLED  0x00000000 /* RWV */ 
#define NV04_PBUS_INTR_EN_0_PCI_BUS_ERROR_ENABLED   0x00000001 /* RWV */ 

#define NV04_PBUS_ROM_CONFIG                        0x00001200 /* RWR */ 
#define NV04_PBUS_ROM_CONFIG_TW1                3:0            /* RWF */ 
#define NV04_PBUS_ROM_CONFIG_TW1_DEFAULT            0x0000000F /* RWV */ 
#define NV04_PBUS_ROM_CONFIG_TW0                5:4            /* RWF */ 
#define NV04_PBUS_ROM_CONFIG_TW0_DEFAULT            0x00000003 /* RWV */ 

#define NV04_EXPROM_BIOS_ROM008(i) (0x00000000+(i))     /* RW */ 
#define NV04_EXPROM_BIOS_ROM008__SIZE_1 65536           /* */ 
#define NV04_EXPROM_BIOS_ROM008_VALUE 7:0               /* RW */ 
#define NV04_EXPROM_BIOS_ROM016(i) (0x00000000+(i)*2)   /* RW */ 
#define NV04_EXPROM_BIOS_ROM016__SIZE_1 32768           /* */ 
#define NV04_EXPROM_BIOS_ROM016_VALUE 15:0              /* RW */ 
#define NV04_EXPROM_BIOS_ROM032(i) (0x00000000+(i)*4)   /* RW */
#define NV04_EXPROM_BIOS_ROM032__SIZE_1 16384           /* */ 
#define NV04_EXPROM_BIOS_ROM032_VALUE 31:0              /* RW */ 




#define NV04_PRMIO_RMA_ID                           0x00007100 /* R-R */ 
#define NV04_PRMIO_RMA_ID_CODE                31:0             /* C-F */
#define NV04_PRMIO_RMA_ID_CODE_VALID                0x2B16D065 /* C-V */ 

#define NV04_PRMIO_RMA_PTR                          0x00007104 /* RWR */ 
#define NV04_PRMIO_RMA_PTR_SPACE              31:31            /* RWF */ 
#define NV04_PRMIO_RMA_PTR_SPACE_REGISTER           0x00000000 /* RWV */ 
#define NV04_PRMIO_RMA_PTR_SPACE_MEMORY             0x00000001 /* RWV */ 
#define NV04_PRMIO_RMA_PTR_ADDRESS            24:2             /* RWF */ 
#define NV04_PRMIO_RMA_PTR_ADDRESS_0                0x00000000 /* RWV */ 

#define NV04_PRMIO_RMA_DATA                         0x00007108 /* RWR */ 
#define NV04_PRMIO_RMA_DATA_PORT              31:0             /* RWF */ 

#define NV04_PRMIO_RMA_DATA32                       0x0000710C /* RWR */ 
#define NV04_PRMIO_RMA_DATA32_BYTE2           23:16            /* RWF */

#define NV04_PRMIO_RMA_DATA32_BYTE1           15:8             /* RWF */ 
#define NV04_PRMIO_RMA_DATA32_BYTE0            7:0             /* RWF */ 


#define NV04_PBUS_PCI_NV_0                          0x00001800 /* R-R */ 
#define NV04_PBUS_PCI_NV_0__ALIAS_1        NV_CONFIG_PCI_NV_0         /* */ 

#define NV04_CONFIG_PCI_NV_0                        0x00000000 /* R- */ 
#define NV04_CONFIG_PCI_NV_0__ALIAS_1 NV_PBUS_PCI_NV_0         /* */ 

#define NV04_PBUS_PCI_NV_0_VENDOR_ID                      15:0 /* C-F */ 
#define NV04_PBUS_PCI_NV_0_VENDOR_ID_NVIDIA_SGS     0x000012D2 /* --V */ 
#define NV04_PBUS_PCI_NV_0_VENDOR_ID_NVIDIA         0x000010DE /* C-V */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_FUNC                18:16 /* C-F */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_FUNC_VGA       0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_FUNC_ALT1      0x00000001 /* C-V */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_FUNC_ALT2      0x00000002 /* C-V */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_FUNC_ALT3      0x00000003 /* C-V */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_FUNC_LC0       0x00000004 /* C-V */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_FUNC_LC1       0x00000005 /* C-V */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_FUNC_LC2       0x00000006 /* C-V */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_FUNC_LC3       0x00000007 /* C-V */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_CHIP                31:19 /* C-F */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_CHIP_NV0       0x00000000 /* --V */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_CHIP_NV1       0x00000001 /* --V */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_CHIP_NV2       0x00000002 /* --V */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_CHIP_NV3       0x00000003 /* --V */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_CHIP_NV4       0x00000004 /* --V */ 
#define NV04_PBUS_PCI_NV_0_DEVICE_ID_CHIP_NV5       0x00000005 /* C-V */

 
#define NV04_PBUS_PCI_NV_1                          0x00001804 /* RWR */ 
#define NV04_PBUS_PCI_NV_1__ALIAS_1         NV_CONFIG_PCI_NV_1 /* */
 
#define NV04_CONFIG_PCI_NV_1                        0x00000004 /* RW */ 
#define NV04_CONFIG_PCI_NV_1__ALIAS_1         NV_PBUS_PCI_NV_1 /* */ 

#define NV04_PBUS_PCI_NV_1_IO_SPACE                        0:0 /* RWF */ 
#define NV04_PBUS_PCI_NV_1_IO_SPACE_DISABLED        0x00000000 /* RWV */ 
#define NV04_PBUS_PCI_NV_1_IO_SPACE_ENABLED         0x00000001 /* RWV */
#define NV04_PBUS_PCI_NV_1_MEMORY_SPACE                    1:1 /* RWF */ 
#define NV04_PBUS_PCI_NV_1_MEMORY_SPACE_DISABLED    0x00000000 /* RWV */ 
#define NV04_PBUS_PCI_NV_1_MEMORY_SPACE_ENABLED     0x00000001 /* RWV */
#define NV04_PBUS_PCI_NV_1_BUS_MASTER                      2:2 /* RWF */ 
#define NV04_PBUS_PCI_NV_1_BUS_MASTER_DISABLED      0x00000000 /* RWV */ 
#define NV04_PBUS_PCI_NV_1_BUS_MASTER_ENABLED       0x00000001 /* RWV */ 
#define NV04_PBUS_PCI_NV_1_WRITE_AND_INVAL                 4:4 /* C-F */ 
#define NV04_PBUS_PCI_NV_1_WRITE_AND_INVAL_DISABLED 0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_1_WRITE_AND_INVAL_ENABLED  0x00000001 /* --V */ 
#define NV04_PBUS_PCI_NV_1_PALETTE_SNOOP                   5:5 /* RWF */ 
#define NV04_PBUS_PCI_NV_1_PALETTE_SNOOP_DISABLED   0x00000000 /* RWV */ 
#define NV04_PBUS_PCI_NV_1_PALETTE_SNOOP_ENABLED    0x00000001 /* RWV */ 
#define NV04_PBUS_PCI_NV_1_CAPLIST                       20:20 /* C-F */ 
#define NV04_PBUS_PCI_NV_1_CAPLIST_NOT_PRESENT      0x00000000 /* --V */ 
#define NV04_PBUS_PCI_NV_1_CAPLIST_PRESENT          0x00000001 /* C-V */ 
#define NV04_PBUS_PCI_NV_1_66MHZ                         21:21 /* C-F */ 
#define NV04_PBUS_PCI_NV_1_66MHZ_INCAPABLE          0x00000000 /* --V */ 
#define NV04_PBUS_PCI_NV_1_66MHZ_CAPABLE            0x00000001 /* C-V */ 
#define NV04_PBUS_PCI_NV_1_FAST_BACK2BACK                23:23 /* C-F */ 
#define NV04_PBUS_PCI_NV_1_FAST_BACK2BACK_INCAPABLE 0x00000000 /* --V */ 
#define NV04_PBUS_PCI_NV_1_FAST_BACK2BACK_CAPABLE   0x00000001 /* C-V */ 
#define NV04_PBUS_PCI_NV_1_DEVSEL_TIMING                 26:25 /* C-F */ 
#define NV04_PBUS_PCI_NV_1_DEVSEL_TIMING_FAST       0x00000000 /* --V */ 
#define NV04_PBUS_PCI_NV_1_DEVSEL_TIMING_MEDIUM     0x00000001 /* C-V */ 
#define NV04_PBUS_PCI_NV_1_DEVSEL_TIMING_SLOW       0x00000002 /* --V */ 
#define NV04_PBUS_PCI_NV_1_SIGNALED_TARGET               27:27 /* RWF */ 
#define NV04_PBUS_PCI_NV_1_SIGNALED_TARGET_NO_ABORT 0x00000000 /* R-V */ 
#define NV04_PBUS_PCI_NV_1_SIGNALED_TARGET_ABORT    0x00000001 /* R-V */ 
#define NV04_PBUS_PCI_NV_1_SIGNALED_TARGET_CLEAR    0x00000001 /* -WV */ 
#define NV04_PBUS_PCI_NV_1_RECEIVED_TARGET               28:28 /* RWF */ 
#define NV04_PBUS_PCI_NV_1_RECEIVED_TARGET_NO_ABORT 0x00000000 /* R-V */ 
#define NV04_PBUS_PCI_NV_1_RECEIVED_TARGET_ABORT    0x00000001 /* R-V */ 
#define NV04_PBUS_PCI_NV_1_RECEIVED_TARGET_CLEAR    0x00000001 /* -WV */ 
#define NV04_PBUS_PCI_NV_1_RECEIVED_MASTER               29:29 /* RWF */ 
#define NV04_PBUS_PCI_NV_1_RECEIVED_MASTER_NO_ABORT 0x00000000 /* R-V */ 
#define NV04_PBUS_PCI_NV_1_RECEIVED_MASTER_ABORT    0x00000001 /* R-V */ 
#define NV04_PBUS_PCI_NV_1_RECEIVED_MASTER_CLEAR    0x00000001 /* -WV */
 
#define NV04_PBUS_PCI_NV_2                          0x00001808 /* R-R */ 
#define NV04_PBUS_PCI_NV_2__ALIAS_1         NV_CONFIG_PCI_NV_2 /* */ 
#define NV04_CONFIG_PCI_NV_2                        0x00000008 /* R- */ 
#define NV04_CONFIG_PCI_NV_2__ALIAS_1         NV_PBUS_PCI_NV_2 /* */ 
#define NV04_PBUS_PCI_NV_2_REVISION_ID                     7:0 /* C-F */ 
#define NV04_PBUS_PCI_NV_2_REVISION_ID_A01          0x00000000 /* --V */ 
#define NV04_PBUS_PCI_NV_2_REVISION_ID_B01          0x00000010 /* C-V */ 
#define NV04_PBUS_PCI_NV_2_CLASS_CODE                     31:8 /* C-F */ 
#define NV04_PBUS_PCI_NV_2_CLASS_CODE_VGA           0x00030000 /* C-V */ 
#define NV04_PBUS_PCI_NV_2_CLASS_CODE_MULTIMEDIA    0x00048000 /* --V */ 

#define NV04_PBUS_PCI_NV_3                          0x0000180C /* RWR */ 
#define NV04_PBUS_PCI_NV_3__ALIAS_1         NV_CONFIG_PCI_NV_3 /* */ 
#define NV04_CONFIG_PCI_NV_3                        0x0000000C /* RW */ 
#define NV04_CONFIG_PCI_NV_3__ALIAS_1         NV_PBUS_PCI_NV_3 /* */ 
#define NV04_PBUS_PCI_NV_3_LATENCY_TIMER                 15:11 /* RWF */ 
#define NV04_PBUS_PCI_NV_3_LATENCY_TIMER_0_CLOCKS   0x00000000 /* RWV */ 
#define NV04_PBUS_PCI_NV_3_LATENCY_TIMER_8_CLOCKS   0x00000001 /* RWV */ 
#define NV04_PBUS_PCI_NV_3_LATENCY_TIMER_240_CLOCKS 0x0000001E /* RWV */ 
#define NV04_PBUS_PCI_NV_3_LATENCY_TIMER_248_CLOCKS 0x0000001F /* RWV */ 
#define NV04_PBUS_PCI_NV_3_HEADER_TYPE                   23:16 /* C-F */ 
#define NV04_PBUS_PCI_NV_3_HEADER_TYPE_SINGLEFUNC   0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_3_HEADER_TYPE_MULTIFUNC    0x00000080 /* --V */ 

#define NV04_PBUS_PCI_NV_4                          0x00001810 /* RWR */ 
#define NV04_PBUS_PCI_NV_4__ALIAS_1         NV_CONFIG_PCI_NV_4 /* */ 
#define NV04_CONFIG_PCI_NV_4                        0x00000010 /* RW */ 
#define NV04_CONFIG_PCI_NV_4__ALIAS_1         NV_PBUS_PCI_NV_4 /* */ 
#define NV04_PBUS_PCI_NV_4_SPACE_TYPE                      0:0 /* C-F */ 
#define NV04_PBUS_PCI_NV_4_SPACE_TYPE_MEMORY        0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_4_SPACE_TYPE_IO            0x00000001 /* --V */ 
#define NV04_PBUS_PCI_NV_4_ADDRESS_TYPE                    2:1 /* C-F */ 
#define NV04_PBUS_PCI_NV_4_ADDRESS_TYPE_32_BIT      0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_4_ADDRESS_TYPE_20_BIT      0x00000001 /* --V */ 
#define NV04_PBUS_PCI_NV_4_ADDRESS_TYPE_64_BIT      0x00000002 /* --V */ 
#define NV04_PBUS_PCI_NV_4_PREFETCHABLE                    3:3 /* C-F */ 
#define NV04_PBUS_PCI_NV_4_PREFETCHABLE_NOT         0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_4_PREFETCHABLE_MERGABLE    0x00000001 /* --V */ 
#define NV04_PBUS_PCI_NV_4_BASE_ADDRESS                  31:24 /* RWF */
 
#define NV04_PBUS_PCI_NV_5                          0x00001814 /* RWR */ 
#define NV04_PBUS_PCI_NV_5__ALIAS_1         NV_CONFIG_PCI_NV_5 /* */ 
#define NV04_CONFIG_PCI_NV_5                        0x00000014 /* RW */ 
#define NV04_CONFIG_PCI_NV_5__ALIAS_1         NV_PBUS_PCI_NV_5 /* */ 
#define NV04_PBUS_PCI_NV_5_SPACE_TYPE                      0:0 /* C-F */ 
#define NV04_PBUS_PCI_NV_5_SPACE_TYPE_MEMORY        0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_5_SPACE_TYPE_IO            0x00000001 /* --V */
#define NV04_PBUS_PCI_NV_5_ADDRESS_TYPE                    2:1 /* C-F */ 
#define NV04_PBUS_PCI_NV_5_ADDRESS_TYPE_32_BIT      0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_5_ADDRESS_TYPE_20_BIT      0x00000001 /* --V */ 
#define NV04_PBUS_PCI_NV_5_ADDRESS_TYPE_64_BIT      0x00000002 /* --V */ 
#define NV04_PBUS_PCI_NV_5_PREFETCHABLE                    3:3 /* C-F */ 
#define NV04_PBUS_PCI_NV_5_PREFETCHABLE_NOT         0x00000000 /* --V */ 
#define NV04_PBUS_PCI_NV_5_PREFETCHABLE_MERGABLE    0x00000001 /* C-V */ 
#define NV04_PBUS_PCI_NV_5_BASE_ADDRESS                  31:24 /* RWF */ 

#define NV04_PBUS_PCI_NV_6(i)               (0x00001818+(i)*4) /* R- */ 
#define NV04_PBUS_PCI_NV_6__SIZE_1                           5 /* */ 
#define NV04_PBUS_PCI_NV_6__ALIAS_1         NV_CONFIG_PCI_NV_6 /* */ 
#define NV04_CONFIG_PCI_NV_6(i)             (0x00000018+(i)*4) /* R- */ 
#define NV04_CONFIG_PCI_NV_6__SIZE_1                         5 /* */ 
#define NV04_CONFIG_PCI_NV_6__ALIAS_1         NV_PBUS_PCI_NV_6 /* */ 
#define NV04_PBUS_PCI_NV_6_RESERVED                       31:0 /* C- */ 
#define NV04_PBUS_PCI_NV_6_RESERVED_0               0x00000000 /* C- */ 

#define NV04_PBUS_PCI_NV_11                             0x0000182C /* R-R */ 
#define NV04_PBUS_PCI_NV_11__ALIAS_1           NV_CONFIG_PCI_NV_11 /* */ 
#define NV04_CONFIG_PCI_NV_11                           0x0000002C /* R- */ 
#define NV04_CONFIG_PCI_NV_11__ALIAS_1           NV_PBUS_PCI_NV_11 /* */ 
#define NV04_PBUS_PCI_NV_11_SUBSYSTEM_VENDOR_ID               15:0 /* R-F */ 
#define NV04_PBUS_PCI_NV_11_SUBSYSTEM_VENDOR_ID_NONE    0x00000000 /* R-V */ 
#define NV04_PBUS_PCI_NV_11_SUBSYSTEM_ID                     31:16 /* R-F */ 
#define NV04_PBUS_PCI_NV_11_SUBSYSTEM_ID_NONE           0x00000000 /* R-V */ 

#define NV04_PBUS_PCI_NV_12                             0x00001830 /* RWR */ 
#define NV04_PBUS_PCI_NV_12__ALIAS_1           NV_CONFIG_PCI_NV_12 /* */ 
#define NV04_CONFIG_PCI_NV_12                           0x00000030 /* RW */ 
#define NV04_CONFIG_PCI_NV_12__ALIAS_1           NV_PBUS_PCI_NV_12 /* */ 
#define NV04_PBUS_PCI_NV_12_ROM_DECODE                         0:0 /* RWF */ 
#define NV04_PBUS_PCI_NV_12_ROM_DECODE_DISABLED         0x00000000 /* RWV */ 
#define NV04_PBUS_PCI_NV_12_ROM_DECODE_ENABLED          0x00000001 /* RWV */ 
#define NV04_PBUS_PCI_NV_12_ROM_BASE                         31:16 /* RWF */ 

#define NV04_PBUS_PCI_NV_13                             0x00001834 /* RWR */ 
#define NV04_PBUS_PCI_NV_13__ALIAS_1           NV_CONFIG_PCI_NV_13 /* */ 
#define NV04_CONFIG_PCI_NV_13                           0x00000034 /* RW */ 
#define NV04_CONFIG_PCI_NV_13__ALIAS_1           NV_PBUS_PCI_NV_13 /* */ 
#define NV04_PBUS_PCI_NV_13_CAP_PTR                            7:0 /* C-F */ 
#define NV04_PBUS_PCI_NV_13_CAP_PTR_AGP                 0x00000044 /* --V */ 
#define NV04_PBUS_PCI_NV_13_CAP_PTR_POWER_MGMT          0x00000060 /* C-V */ 

#define NV04_PBUS_PCI_NV_14                             0x00001838 /* R-R */ 
#define NV04_PBUS_PCI_NV_14__ALIAS_1           NV_CONFIG_PCI_NV_14 /* */ 
#define NV04_CONFIG_PCI_NV_14                           0x00000038 /* R- */ 
#define NV04_CONFIG_PCI_NV_14__ALIAS_1           NV_PBUS_PCI_NV_14 /* */ 
#define NV04_PBUS_PCI_NV_14_RESERVED                          31:0 /* C-F */ 
#define NV04_PBUS_PCI_NV_14_RESERVED_0                  0x00000000 /* C-V */ 

#define NV04_PBUS_PCI_NV_15                             0x0000183C /* RWR */ 
#define NV04_PBUS_PCI_NV_15__ALIAS_1           NV_CONFIG_PCI_NV_15 /* */ 
#define NV04_CONFIG_PCI_NV_15                           0x0000003C /* RW */ 
#define NV04_CONFIG_PCI_NV_15__ALIAS_1           NV_PBUS_PCI_NV_15 /* */ 
#define NV04_PBUS_PCI_NV_15_INTR_LINE                          7:0 /* RWF */ 
#define NV04_PBUS_PCI_NV_15_INTR_LINE_IRQ0              0x00000000 /* RWV */ 
#define NV04_PBUS_PCI_NV_15_INTR_LINE_IRQ1              0x00000001 /* RWV */ 
#define NV04_PBUS_PCI_NV_15_INTR_LINE_IRQ15             0x0000000F /* RWV */ 
#define NV04_PBUS_PCI_NV_15_INTR_LINE_UNKNOWN           0x000000FF /* RWV */ 
#define NV04_PBUS_PCI_NV_15_INTR_PIN                          15:8 /* C-F */ 
#define NV04_PBUS_PCI_NV_15_INTR_PIN_INTA               0x00000001 /* C-V */ 
#define NV04_PBUS_PCI_NV_15_MIN_GNT                          23:16 /* C-F */ 
#define NV04_PBUS_PCI_NV_15_MIN_GNT_NO_REQUIREMENTS     0x00000000 /* --V */ 
#define NV04_PBUS_PCI_NV_15_MIN_GNT_750NS               0x00000003 /* --V */ 
#define NV04_PBUS_PCI_NV_15_MIN_GNT_1250NS              0x00000005 /* C-V */ 
#define NV04_PBUS_PCI_NV_15_MAX_LAT                          31:24 /* C-F */ 
#define NV04_PBUS_PCI_NV_15_MAX_LAT_NO_REQUIREMENTS     0x00000000 /* --V */ 
#define NV04_PBUS_PCI_NV_15_MAX_LAT_250NS               0x00000001 /* C-V */
 
#define NV04_PBUS_PCI_NV_16                             0x00001840 /* RWR */ 
#define NV04_PBUS_PCI_NV_16__ALIAS_1           NV_CONFIG_PCI_NV_16 /* */ 
#define NV04_CONFIG_PCI_NV_16                           0x00000040 /* RW */ 
#define NV04_CONFIG_PCI_NV_16__ALIAS_1           NV_PBUS_PCI_NV_16 /* */ 
#define NV04_PBUS_PCI_NV_16_SUBSYSTEM_VENDOR_ID               15:0 /* RWF */ 
#define NV04_PBUS_PCI_NV_16_SUBSYSTEM_VENDOR_ID_NONE    0x00000000 /* R-V */ 
#define NV04_PBUS_PCI_NV_16_SUBSYSTEM_ID                     31:16 /* RWF */ 
#define NV04_PBUS_PCI_NV_16_SUBSYSTEM_ID_NONE           0x00000000 /* R-V */
 
#define NV04_PBUS_PCI_NV_17                             0x00001844 /* RWR */ 
#define NV04_PBUS_PCI_NV_17__ALIAS_1           NV_CONFIG_PCI_NV_17 /* */ 
#define NV04_CONFIG_PCI_NV_17                           0x00000044 /* RW */ 
#define NV04_CONFIG_PCI_NV_17__ALIAS_1           NV_PBUS_PCI_NV_17 /* */ 
#define NV04_PBUS_PCI_NV_17_AGP_REV_MAJOR                    23:20 /* C-F */ 
#define NV04_PBUS_PCI_NV_17_AGP_REV_MAJOR_2             0x00000002 /* C-V */ 
#define NV04_PBUS_PCI_NV_17_AGP_REV_MINOR                    19:16 /* C-F */ 
#define NV04_PBUS_PCI_NV_17_AGP_REV_MINOR_0             0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_17_NEXT_PTR                          15:8 /* C-F */ 
#define NV04_PBUS_PCI_NV_17_NEXT_PTR_NULL               0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_17_CAP_ID                             7:0 /* C-F */ 
#define NV04_PBUS_PCI_NV_17_CAP_ID_AGP                  0x00000002 /* C-V */ 

#define NV04_PBUS_PCI_NV_18                             0x00001848 /* RWR */ 
#define NV04_PBUS_PCI_NV_18__ALIAS_1           NV_CONFIG_PCI_NV_18 /* */ 
#define NV04_CONFIG_PCI_NV_18                           0x00000048 /* RW */ 
#define NV04_CONFIG_PCI_NV_18__ALIAS_1           NV_PBUS_PCI_NV_18 /* */ 
#define NV04_PBUS_PCI_NV_18_AGP_STATUS_RQ                    31:24 /* C-F */ 
#define NV04_PBUS_PCI_NV_18_AGP_STATUS_RQ_32            0x0000001F /* C-V */ 
#define NV04_PBUS_PCI_NV_18_AGP_STATUS_SBA                     9:9 /* R-F */ 
#define NV04_PBUS_PCI_NV_18_AGP_STATUS_SBA_NONE         0x00000000 /* R-V */ 
#define NV04_PBUS_PCI_NV_18_AGP_STATUS_SBA_CAPABLE      0x00000001 /* R-V */ 
#define NV04_PBUS_PCI_NV_18_AGP_STATUS_RATE                    2:0 /* R-F */ 
#define NV04_PBUS_PCI_NV_18_AGP_STATUS_RATE_1X          0x00000001 /* R-V */ 
#define NV04_PBUS_PCI_NV_18_AGP_STATUS_RATE_2X          0x00000002 /* --V */ 
#define NV04_PBUS_PCI_NV_18_AGP_STATUS_RATE_1X_AND_2X   0x00000003 /* R-V */ 
#define NV04_PBUS_PCI_NV_18_AGP_STATUS_RATE_4X          0x00000004 /* R-V */ 
#define NV04_PBUS_PCI_NV_18_AGP_STATUS_RATE_1X_2X_4X    0x00000007 /* R-V */ 

#define NV04_PBUS_PCI_NV_19                                       0x0000184C /* RWR */ 
#define NV04_PBUS_PCI_NV_19__ALIAS_1                     NV_CONFIG_PCI_NV_19 /* */ 
#define NV04_CONFIG_PCI_NV_19                                     0x0000004C /* RW */ 
#define NV04_CONFIG_PCI_NV_19__ALIAS_1                     NV_PBUS_PCI_NV_19 /* */ 
#define NV04_PBUS_PCI_NV_19_AGP_COMMAND_RQ_DEPTH                       28:24 /* RWF */ 
#define NV04_PBUS_PCI_NV_19_AGP_COMMAND_RQ_DEPTH_0                0x00000000 /* RWV */ 
#define NV04_PBUS_PCI_NV_19_AGP_COMMAND_SBA_ENABLE                       9:9 /* RWF */ 
#define NV04_PBUS_PCI_NV_19_AGP_COMMAND_SBA_ENABLE_OFF            0x00000000 /* RWV */ 
#define NV04_PBUS_PCI_NV_19_AGP_COMMAND_SBA_ENABLE_ON             0x00000001 /* RWV */ 
#define NV04_PBUS_PCI_NV_19_AGP_COMMAND_AGP_ENABLE                       8:8 /* RWF */ 
#define NV04_PBUS_PCI_NV_19_AGP_COMMAND_AGP_ENABLE_OFF            0x00000000 /* RWV */ 
#define NV04_PBUS_PCI_NV_19_AGP_COMMAND_AGP_ENABLE_ON             0x00000001 /* RWV */ 
#define NV04_PBUS_PCI_NV_19_AGP_COMMAND_DATA_RATE                        2:0 /* RWF */ 
#define NV04_PBUS_PCI_NV_19_AGP_COMMAND_DATA_RATE_OFF             0x00000000 /* RWV */ 
#define NV04_PBUS_PCI_NV_19_AGP_COMMAND_DATA_RATE_1X              0x00000001 /* RWV */ 
#define NV04_PBUS_PCI_NV_19_AGP_COMMAND_DATA_RATE_2X              0x00000002 /* RWV */ 
#define NV04_PBUS_PCI_NV_19_AGP_COMMAND_DATA_RATE_4X              0x00000004 /* RWV */ 


#define NV04_PBUS_PCI_NV_20                                       0x00001850 /* RWR */ 
#define NV04_PBUS_PCI_NV_20_ROM_SHADOW                                   0:0 /* RWF */ 
#define NV04_PBUS_PCI_NV_20_ROM_SHADOW_DISABLED                   0x00000000 /* RWV */ 
#define NV04_PBUS_PCI_NV_20_ROM_SHADOW_ENABLED                    0x00000001 /* RWV */ 

#define NV04_PBUS_PCI_NV_21                           0x00001854   /* RWR */ 
#define NV04_PBUS_PCI_NV_21_VGA                              0:0 /* RWF */ 
#define NV04_PBUS_PCI_NV_21_VGA_DISABLED              0x00000000 /* RWV */ 
#define NV04_PBUS_PCI_NV_21_VGA_ENABLED               0x00000001 /* RWV */

 
#define NV04_PBUS_PCI_NV_22                           0x00001858 /* RWR */ 
#define NV04_PBUS_PCI_NV_22_SCRATCH                         23:0 /* RWF */ 
#define NV04_PBUS_PCI_NV_22_SCRATCH_DEFAULT           0x0023D6CE /* RWV */
 
#define NV04_PBUS_PCI_NV_23                           0x0000185C /* RWR */ 
#define NV04_PBUS_PCI_NV_23_DT_TIMEOUT                       3:0 /* RWF */ 
#define NV04_PBUS_PCI_NV_23_DT_TIMEOUT_16             0x0000000F /* RWV */ 

#define NV04_PBUS_PCI_NV_24                           0x00001860 /* RWR */
#define NV04_PBUS_PCI_NV_24_PME_D3_COLD                    31:31 /* C-F */ 
#define NV04_PBUS_PCI_NV_24_PME_D3_COLD_SUPPORTED     0x00000001 /* --V */ 
#define NV04_PBUS_PCI_NV_24_PME_D3_COLD_NOT_SUPPORTED 0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_24_PME_D3_HOT                     30:30 /* C-F */ 
#define NV04_PBUS_PCI_NV_24_PME_D3_HOT_SUPPORTED      0x00000001 /* --V */ 
#define NV04_PBUS_PCI_NV_24_PME_D3_HOT_NOT_SUPPORTED  0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_24_PME_D2                         29:29 /* C-F */ 
#define NV04_PBUS_PCI_NV_24_PME_D2_SUPPORTED          0x00000001 /* --V */ 
#define NV04_PBUS_PCI_NV_24_PME_D2_NOT_SUPPORTED      0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_24_PME_D1                         28:28 /* C-F */ 
#define NV04_PBUS_PCI_NV_24_PME_D1_SUPPORTED          0x00000001 /* --V */ 
#define NV04_PBUS_PCI_NV_24_PME_D1_NOT_SUPPORTED      0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_24_PME_D0                         27:27 /* C-F */ 
#define NV04_PBUS_PCI_NV_24_PME_D0_SUPPORTED          0x00000001 /* --V */ 
#define NV04_PBUS_PCI_NV_24_PME_D0_NOT_SUPPORTED      0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_24_D2                             26:26 /* C-F */ 
#define NV04_PBUS_PCI_NV_24_D2_SUPPORTED              0x00000001 /* --V */ 
#define NV04_PBUS_PCI_NV_24_D2_NOT_SUPPORTED          0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_24_D1                             25:25 /* C-F */ 
#define NV04_PBUS_PCI_NV_24_D1_SUPPORTED              0x00000001 /* --V */ 
#define NV04_PBUS_PCI_NV_24_D1_NOT_SUPPORTED          0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_24_DSI                            21:21 /* C-F */ 
#define NV04_PBUS_PCI_NV_24_DSI_NOT_REQUIRED          0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_24_PME_CLOCK                      19:19 /* C-F */ 
#define NV04_PBUS_PCI_NV_24_PME_CLOCK_NOT_REQUIRED    0x00000000 /* C-V */ 
#define NV04_PBUS_PCI_NV_24_VERSION                        18:16 /* C-F */ 
#define NV04_PBUS_PCI_NV_24_VERSION_1                 0x00000001 /* C-V */ 
#define NV04_PBUS_PCI_NV_24_NEXT_PTR                        15:8 /* R-F */ 
#define NV04_PBUS_PCI_NV_24_NEXT_PTR_NULL             0x00000000 /* --V */ 
#define NV04_PBUS_PCI_NV_24_NEXT_PTR_AGP              0x00000044 /* --V */ 
#define NV04_PBUS_PCI_NV_24_CAP_ID                           7:0 /* C-F */ 
#define NV04_PBUS_PCI_NV_24_CAP_ID_POWER_MGMT         0x00000001 /* C-V */
 
#define NV04_PBUS_PCI_NV_25                           0x00001864 /* RWR */ 
#define NV04_PBUS_PCI_NV_25_POWER_STATE                      1:0 /* RWF */ 
#define NV04_PBUS_PCI_NV_25_POWER_STATE_D3_HOT        0x00000003 /* RWV */ 
#define NV04_PBUS_PCI_NV_25_POWER_STATE_D2            0x00000002 /* RWV */ 
#define NV04_PBUS_PCI_NV_25_POWER_STATE_D1            0x00000001 /* RWV */ 
#define NV04_PBUS_PCI_NV_25_POWER_STATE_D0            0x00000000 /* RWV */ 


