
/* * RAMDAC */ 
#define NV04_PRAMDAC  0x00680FFF:0x00680300 /* RW */ 
#define NV04_USER_DAC 0x00681FFF:0x00681200 /* RW */ 
#define NV04_PDAC     0x00680FFF:0x00680000 /* RW */
#define NV04_PRMDIO   0x00681FFF:0x00681000 /* RW */ 
#define NV04_DIO           0x3C9:0x3C6      /* -- */ 

#define NV04_PRAMDAC_CU_START_POS                             0x00680300 /* RW */ 
#define NV04_PRAMDAC_CU_START_POS_X                     11:0             /* RW */ 
#define NV04_PRAMDAC_CU_START_POS_Y                     27:16            /* RW */
 
#define NV04_PRAMDAC_CURSOR_CNTRL                             0x00680320 /* RW */ 
#define NV04_PRAMDAC_CURSOR_CNTRL_ADDRESS                2:0             /* RW */ 
#define NV04_PRAMDAC_CURSOR_CNTRL_RAM                    8:8             /* RW */ 
#define NV04_PRAMDAC_CURSOR_CNTRL_TESTMODE              16:16            /* -W */ 
#define NV04_PRAMDAC_CURSOR_CNTRL_TESTMODE_READ         13:13            /* R- */ 
#define NV04_PRAMDAC_CURSOR_CNTRL_TESTMODE_ENABLE               1        /* RW */ 
#define NV04_PRAMDAC_CURSOR_CNTRL_TESTMODE_DISABLE              0        /* RW */ 

#define NV04_PRAMDAC_CURSOR_DATA                              0x00680324 /* RW */ 
#define NV04_PRAMDAC_CURSOR_DATA_VAL                    31:0             /* RW */
 

#define NV04_PRAMDAC_NVPLL_COEFF                              0x00680500 /* RW */ 
#define NV04_PRAMDAC_NVPLL_COEFF_MDIV                    7:0             /* RW */ 
#define NV04_PRAMDAC_NVPLL_COEFF_NDIV                   15:8             /* RW */ 
#define NV04_PRAMDAC_NVPLL_COEFF_PDIV                   18:16            /* RW */ 

#define NV04_PRAMDAC_MPLL_COEFF                               0x00680504 /* RW */ 
#define NV04_PRAMDAC_MPLL_COEFF_MDIV                     7:0             /* RW */ 
#define NV04_PRAMDAC_MPLL_COEFF_NDIV                    15:8             /* RW */ 
#define NV04_PRAMDAC_MPLL_COEFF_PDIV                    18:16            /* RW */ 

#define NV04_PRAMDAC_VPLL_COEFF                               0x00680508 /* RW */ 
#define NV04_PRAMDAC_VPLL_COEFF_MDIV                     7:0             /* RW */ 
#define NV04_PRAMDAC_VPLL_COEFF_NDIV                    15:8             /* RW */ 
#define NV04_PRAMDAC_VPLL_COEFF_PDIV                    18:16            /* RW */ 

#define NV04_PRAMDAC_PLL_COEFF_SELECT                         0x0068050C /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_VPLL_SOURCE        0:0             /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_VPLL_SOURCE_XTAL        0x00000000 /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_VPLL_SOURCE_VIP         0x00000001 /* RW */
#define NV04_PRAMDAC_PLL_COEFF_SELECT_SOURCE            10:8             /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_SOURCE_DEFAULT          0x00000000 /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_SOURCE_PROG_MPLL        0x00000001 /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_SOURCE_PROG_VPLL        0x00000002 /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_SOURCE_PROG_NVPLL       0x00000004 /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_SOURCE_PROG_ALL         0x00000007 /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_VS_PCLK_TV        17:16            /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_VS_PCLK_TV_NONE         0x00000000 /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_VS_PCLK_TV_VSCLK        0x00000001 /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_VS_PCLK_TV_PCLK         0x00000002 /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_VS_PCLK_TV_BOTH         0x00000003 /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_TVCLK_SOURCE      20:20            /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_TVCLK_SOURCE_EXT        0x00000000 /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_TVCLK_SOURCE_VIP        0x00000001 /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_TVCLK_RATIO       24:24            /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_TVCLK_RATIO_DB1         0x00000000 /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_TVCLK_RATIO_DB2         0x00000001 /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_VCLK_RATIO        28:28            /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_VCLK_RATIO_DB1          0x00000000 /* RW */ 
#define NV04_PRAMDAC_PLL_COEFF_SELECT_VCLK_RATIO_DB2          0x00000001 /* RW */ 


#define NV04_PRAMDAC_PLL_SETUP_CONTROL                        0x00680510 /* RW */ 
#define NV04_PRAMDAC_PLL_SETUP_CONTROL_VALUE            10:0             /* RW */ 
#define NV04_PRAMDAC_PLL_SETUP_CONTROL_VAL                    0x0000044E /* RW */ 
#define NV04_PRAMDAC_PLL_SETUP_CONTROL_PWRDWN           14:12            /* RW */ 
#define NV04_PRAMDAC_PLL_SETUP_CONTROL_PWRDWN_ON              0x00000000 /* RW */ 
#define NV04_PRAMDAC_PLL_SETUP_CONTROL_PWRDWN_MPLL            0x00000001 /* RW */ 
#define NV04_PRAMDAC_PLL_SETUP_CONTROL_PWRDWN_VPLL            0x00000002 /* RW */ 
#define NV04_PRAMDAC_PLL_SETUP_CONTROL_PWRDWN_NVPLL           0x00000004 /* RW */ 
#define NV04_PRAMDAC_PLL_SETUP_CONTROL_PWRDWN_OFF             0x00000007 /* RW */ 


#define NV04_PRAMDAC_PLL_TEST_COUNTER                         0x00680514 /* RW */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_NOOFIPCLKS         9:0             /* -W */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_VALUE             15:0             /* R- */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_ENABLE            16:16            /* RW */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_ENABLE_DEASSERTED       0x00000000 /* RW */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_ENABLE_ASSERTED         0x00000001 /* RW */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_RESET             20:20            /* RW */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_RESET_DEASSERTED        0x00000000 /* RW */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_RESET_ASSERTED          0x00000001 /* RW */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_SOURCE            25:24            /* RW */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_SOURCE_MCLK             0x00000002 /* RW */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_SOURCE_VCLK             0x00000001 /* RW */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_SOURCE_NVCLK            0x00000000 /* RW */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_PDIV_RST          28:28            /* RW */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_PDIVRST_DEASSERTED      0x00000000 /* RW */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_PDIVRST_ASSERTED        0x00000001 /* RW */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_NVPLL_LOCK        29:29            /* R- */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_NVPLL_NOTLOCKED         0x00000000 /* R- */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_NVPLL_LOCKED            0x00000001 /* R- */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_MPLL_LOCK         30:30            /* R- */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_MPLL_NOTLOCKED          0x00000000 /* R- */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_MPLL_LOCKED             0x00000001 /* R- */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_VPLL_LOCK         31:31            /* R- */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_VPLL_NOTLOCKED          0x00000000 /* R- */ 
#define NV04_PRAMDAC_PLL_TEST_COUNTER_VPLL_LOCKED             0x00000001 /* R- */ 

#define NV04_PRAMDAC_PALETTE_TEST                             0x00680518 /* RW */
#define NV04_PRAMDAC_PALETTE_TEST_BLUE_DATA              7:0             /* R- */ 
#define NV04_PRAMDAC_PALETTE_TEST_GREEN_DATA            15:8             /* R- */ 
#define NV04_PRAMDAC_PALETTE_TEST_RED_DATA              23:16            /* R- */ 
#define NV04_PRAMDAC_PALETTE_TEST_MODE                  24:24            /* RW */ 
#define NV04_PRAMDAC_PALETTE_TEST_MODE_8BIT                   0x00000000 /* RW */ 
#define NV04_PRAMDAC_PALETTE_TEST_MODE_24BIT                  0x00000001 /* RW */ 
#define NV04_PRAMDAC_PALETTE_TEST_ADDRINC               28:28            /* RW */ 
#define NV04_PRAMDAC_PALETTE_TEST_ADDRINC_READWRITE           0x00000000 /* RW */ 
#define NV04_PRAMDAC_PALETTE_TEST_ADDRINC_WRITEONLY           0x00000001 /* RW */ 


#define NV04_PRAMDAC_GENERAL_CONTROL                          0x00680600 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_PIXMIX32_BIT        0:0             /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_PIXMIX32_BIT_24          0x00000001 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_PIXMIX32_BIT_31          0x00000000 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_PIXMIX              5:4             /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_PIXMIX_OFF               0x00000000 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_PIXMIX_POS               0x00000001 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_PIXMIX_NEG               0x00000002 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_PIXMIX_ON                0x00000003 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_VGA_STATE           8:8             /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_VGA_STATE_NOTSEL         0x00000000 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_VGA_STATE_SEL            0x00000001 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_ALT_MODE           12:12            /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_ALT_MODE_NOTSEL          0x00000000 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_ALT_MODE_SEL             0x00000001 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_ALT_MODE_15              0x00000000 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_ALT_MODE_16              0x00000001 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_ALT_MODE_24              0x00000000 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_ALT_MODE_30              0x00000001 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_BLK_PEDSTL         16:16            /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_BLK_PEDSTL_OFF           0x00000000 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_BLK_PEDSTL_ON            0x00000001 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_TERMINATION        17:17            /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_TERMINATION_37OHM        0x00000000 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_TERMINATION_75OHM        0x00000001 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_BPC                20:20            /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_BPC_6BITS                0x00000000 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_BPC_8BITS                0x00000001 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_DAC_SLEEP          24:24            /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_DAC_SLEEP_DIS            0x00000000 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_DAC_SLEEP_EN             0x00000001 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_PALETTE_CLK        28:28            /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_PALETTE_CLK_EN           0x00000000 /* RW */ 
#define NV04_PRAMDAC_GENERAL_CONTROL_PALETTE_CLK_DIS          0x00000001 /* RW */ 


#define NV04_PRAMDAC_PALETTE_RECOVERY                         0x00680604 /* R- */ 
#define NV04_PRAMDAC_PALETTE_RECOVERY_ACTIVE_ADDRESS     7:0             /* R- */
#define NV04_PRAMDAC_PALETTE_RECOVERY_RGB_POINTER       10:8             /* R- */ 
#define NV04_PRAMDAC_PALETTE_RECOVERY_RGB_POINTER_RED         0x00000001 /* R- */ 
#define NV04_PRAMDAC_PALETTE_RECOVERY_RGB_POINTER_GREEN       0x00000002 /* R- */ 
#define NV04_PRAMDAC_PALETTE_RECOVERY_RGB_POINTER_BLUE        0x00000004 /* R- */ 
#define NV04_PRAMDAC_PALETTE_RECOVERY_DAC_STATE         13:12            /* R- */ 
#define NV04_PRAMDAC_PALETTE_RECOVERY_DAC_STATE_WRITE         0x00000000 /* R- */ 
#define NV04_PRAMDAC_PALETTE_RECOVERY_DAC_STATE_READ          0x00000003 /* R- */ 
#define NV04_PRAMDAC_PALETTE_RECOVERY_RED_DATA          23:16            /* R- */ 
#define NV04_PRAMDAC_PALETTE_RECOVERY_GREEN_DATA        31:24            /* R- */ 


#define NV04_PRAMDAC_TEST_CONTROL                             0x00680608 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_CRC_RESET              0:0             /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_CRC_RESET_DEASSERTED        0x00000000 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_CRC_RESET_ASSERTED          0x00000001 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_CRC_ENABLE             4:4             /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_CRC_ENABLE_DEASSERTED       0x00000000 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_CRC_ENABLE_ASSERTED         0x00000001 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_CRC_CHANNEL            9:8             /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_CRC_CHANNEL_BLUE            0x00000000 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_CRC_CHANNEL_GREEN           0x00000001 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_CRC_CHANNEL_RED             0x00000002 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_CRC_CAPTURE           10:10            /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_CRC_CAPTURE_ALWAYS          0x00000000 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_CRC_CAPTURE_ONE             0x00000001 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_TP_INS_EN             12:12            /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_TP_INS_EN_DEASSERTED        0x00000000 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_TP_INS_EN_ASSERTED          0x00000001 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_PWRDWN_DAC            16:16            /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_PWRDWN_DAC_ON               0x00000000 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_PWRDWN_DAC_OFF              0x00000001 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_DACTM                 20:20            /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_DACTM_NORMAL                0x00000000 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_DACTM_TEST                  0x00000001 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_TPATH1                24:24            /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_TPATH1_CLEAR                0x00000000 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_TPATH1_SET                  0x00000001 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_TPATH31               25:25            /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_TPATH31_CLEAR               0x00000000 /* RW */ 
#define NV04_PRAMDAC_TEST_CONTROL_TPATH31_SET                 0x00000001 /* RW */
#define NV04_PRAMDAC_TEST_CONTROL_SENSEB                28:28            /* R- */ 
#define NV04_PRAMDAC_TEST_CONTROL_SENSEB_SOMELO               0x00000000 /* R- */ 
#define NV04_PRAMDAC_TEST_CONTROL_SENSEB_ALLHI                0x00000001 /* R- */


#define NV04_PRAMDAC_CHECKSUM                                 0x0068060C /* R- */ 
#define NV04_PRAMDAC_CHECKSUM_STATUS                    24:24            /* R- */ 
#define NV04_PRAMDAC_CHECKSUM_STATUS_CAPTURED                 0x00000001 /* R- */ 
#define NV04_PRAMDAC_CHECKSUM_STATUS_WAITING                  0x00000000 /* R- */ 
#define NV04_PRAMDAC_CHECKSUM_VALUE                     23:0             /* R- */ 


#define NV04_PRAMDAC_TESTPOINT_DATA                           0x00680610 /* -W */ 
#define NV04_PRAMDAC_TESTPOINT_DATA_RED                  9:0             /* -W */ 
#define NV04_PRAMDAC_TESTPOINT_DATA_GREEN               19:10            /* -W */ 
#define NV04_PRAMDAC_TESTPOINT_DATA_BLUE                29:20            /* -W */ 
#define NV04_PRAMDAC_TESTPOINT_DATA_BLACK               30:30            /* -W */ 
#define NV04_PRAMDAC_TESTPOINT_DATA_NOTBLANK            31:31            /* -W */ 


#define NV04_PRAMDAC_TV_SETUP                                 0x00680700 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_DEV_TYPE                   1:0             /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_DEV_TYPE_SLAVE                  0x00000000 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_DEV_TYPE_MASTER                 0x00000001 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_DEV_TYPE_SLAVE_ALT              0x00000002 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_DEV_TYPE_MASTER_ALT             0x00000003 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_VS_PIXFMT                  6:4             /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_VS_PIXFMT_555                   0x00000000 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_VS_PIXFMT_565                   0x00000001 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_VS_PIXFMT_888                   0x00000002 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_VS_PIXFMT_101010                0x00000003 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_VS_PIXFMT_YUV                   0x00000004 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_DATA_SRC                   9:8             /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_DATA_SRC_COMP                   0x00000000 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_DATA_SRC_SCALER                 0x00000001 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_DATA_SRC_VIP                    0x00000002 /* RW */
#define NV04_PRAMDAC_TV_SETUP_DATA_SRC_NONE                   0x00000003 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_COMP_SRC                  12:12            /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_COMP_SRC_SCALER                 0x00000000 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_COMP_SRC_NO_SCALER              0x00000001 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_SYNC_POL                  17:16            /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_SYNC_POL_NEG_NONE               0x00000000 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_SYNC_POL_NEG_HSYNC              0x00000001 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_SYNC_POL_NEG_VSYNC              0x00000002 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_SYNC_POL_NEG_BOTH               0x00000003 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_VIP_VSYNC                 20:20            /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_VIP_VSYNC_LEAD                  0x00000000 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_VIP_VSYNC_TRAIL                 0x00000001 /* RW */
#define NV04_PRAMDAC_TV_SETUP_VIP_DATAPOS               24:24            /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_VIP_DATAPOS_7_0                 0x00000000 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_VIP_DATAPOS_11_4                0x00000001 /* RW */
#define NV04_PRAMDAC_TV_SETUP_VIP_FIELD                 28:28            /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_VIP_FIELD_0                     0x00000000 /* RW */ 
#define NV04_PRAMDAC_TV_SETUP_VIP_FIELD_1                     0x00000001 /* RW */ 

#define NV04_PRAMDAC_TV_VBLANK_START                          0x00680704 /* RW */ 
#define NV04_PRAMDAC_TV_VBLANK_START_VAL                10:0             /* RW */ 

#define NV04_PRAMDAC_TV_VBLANK_END                            0x00680708 /* RW */ 
#define NV04_PRAMDAC_TV_VBLANK_END_VAL                  10:0             /* RW */ 

#define NV04_PRAMDAC_TV_HBLANK_START                          0x0068070C /* RW */ 
#define NV04_PRAMDAC_TV_HBLANK_START_VAL                10:0             /* RW */ 

#define NV04_PRAMDAC_TV_HBLANK_END                            0x00680710 /* RW */ 
#define NV04_PRAMDAC_TV_HBLANK_END_VAL                  10:0             /* RW */ 

#define NV04_PRAMDAC_BLANK_COLOR                              0x00680714 /* RW */ 
#define NV04_PRAMDAC_BLANK_COLOR_VAL                    23:0             /* RW */ 

#define NV04_PRAMDAC_TV_CHECKSUM                              0x00680718 /* RW */ 
#define NV04_PRAMDAC_TV_CHECKSUM_VAL                    23:0             /* R- */ 
#define NV04_PRAMDAC_TV_CHECKSUM_STATUS                 24:24            /* R- */ 
#define NV04_PRAMDAC_TV_CHECKSUM_STATUS_CAPTURED              0x00000001 /* R- */ 
#define NV04_PRAMDAC_TV_CHECKSUM_STATUS_WAITING               0x00000000 /* R- */ 
#define NV04_PRAMDAC_TV_VSYNC                           28:28            /* R- */
#define NV04_PRAMDAC_TV_VSYNC_LOW                             0x00000000 /* R- */ 
#define NV04_PRAMDAC_TV_VSYNC_HIGH                            0x00000001 /* R- */ 

#define NV04_PRAMDAC_TV_TEST_CONTROL                          0x0068071c /* RW */ 
#define NV04_PRAMDAC_TV_TEST_CONTROL_CRC_RESET           0:0             /* RW */ 
#define NV04_PRAMDAC_TV_TEST_CONTROL_CRC_RESET_DEASSERTED     0x00000000 /* RW */ 
#define NV04_PRAMDAC_TV_TEST_CONTROL_CRC_RESET_ASSERTED       0x00000001 /* RW */ 
#define NV04_PRAMDAC_TV_TEST_CONTROL_CRC_ENABLE          4:4             /* RW */ 
#define NV04_PRAMDAC_TV_TEST_CONTROL_CRC_ENABLE_DEASSERTED    0x00000000 /* RW */ 
#define NV04_PRAMDAC_TV_TEST_CONTROL_CRC_ENABLE_ASSERTED      0x00000001 /* RW */ 
#define NV04_PRAMDAC_TV_TEST_CONTROL_CRC_CHANNEL         9:8 /* RW */ 
#define NV04_PRAMDAC_TV_TEST_CONTROL_CRC_CHANNEL_7_0          0x00000000 /* RW */ 
#define NV04_PRAMDAC_TV_TEST_CONTROL_CRC_CHANNEL_15_8         0x00000001 /* RW */ 
#define NV04_PRAMDAC_TV_TEST_CONTROL_CRC_CHANNEL_23_16        0x00000002 /* RW */ 
#define NV04_PRAMDAC_TV_TEST_CONTROL_CRC_CAPTURE        10:10            /* RW */ 
#define NV04_PRAMDAC_TV_TEST_CONTROL_CRC_CAPTURE_ALWAYS       0x00000000 /* RW */ 
#define NV04_PRAMDAC_TV_TEST_CONTROL_CRC_CAPTURE_ONE          0x00000001 /* RW */ 


#define NV04_PRAMDAC_FP_VDISPLAY_END                          0x00680800 /* RW */ 
#define NV04_PRAMDAC_FP_VDISPLAY_END_VAL                10:0 /* RW */ 
#define NV04_PRAMDAC_FP_VTOTAL                                0x00680804 /* RW */ 
#define NV04_PRAMDAC_FP_VTOTAL_VAL                      10:0 /* RW */ 
#define NV04_PRAMDAC_FP_VCRTC                                 0x00680808 /* RW */ 
#define NV04_PRAMDAC_FP_VCRTC_VAL                       10:0 /* RW */

#define NV04_PRAMDAC_FP_VSYNC_START                           0x0068080c /* RW */ 
#define NV04_PRAMDAC_FP_VSYNC_START_VAL                 10:0 /* RW */ 

#define NV04_PRAMDAC_FP_VSYNC_END                             0x00680810 /* RW */ 
#define NV04_PRAMDAC_FP_VSYNC_END_VAL                   10:0 /* RW */ 

#define NV04_PRAMDAC_FP_VVALID_START                          0x00680814 /* RW */ 
#define NV04_PRAMDAC_FP_VVALID_START_VAL                10:0 /* RW */ 

#define NV04_PRAMDAC_FP_VVALID_END                            0x00680818 /* RW */ 
#define NV04_PRAMDAC_FP_VVALID_END_VAL                  10:0 /* RW */ 

#define NV04_PRAMDAC_FP_HDISPLAY_END                          0x00680820 /* RW */ 
#define NV04_PRAMDAC_FP_HDISPLAY_END_VAL                10:0 /* RW */ 

#define NV04_PRAMDAC_FP_HTOTAL                                0x00680824 /* RW */ 
#define NV04_PRAMDAC_FP_HTOTAL_VAL                      10:0 /* RW */ 

#define NV04_PRAMDAC_FP_HCRTC                                 0x00680828 /* RW */ 
#define NV04_PRAMDAC_FP_HCRTC_VAL                       10:0 /* RW */

#define NV04_PRAMDAC_FP_HSYNC_START                           0x0068082c /* RW */ 
#define NV04_PRAMDAC_FP_HSYNC_START_VAL                 10:0 /* RW */ 

#define NV04_PRAMDAC_FP_HSYNC_END                            0x00680830 /* RW */ 
#define NV04_PRAMDAC_FP_HSYNC_END_VAL                   10:0 /* RW */ 

#define NV04_PRAMDAC_FP_HVALID_START                         0x00680834 /* RW */ 
#define NV04_PRAMDAC_FP_HVALID_START_VAL                10:0 /* RW */ 

#define NV04_PRAMDAC_FP_HVALID_END                           0x00680838 /* RW */ 
#define NV04_PRAMDAC_FP_HVALID_END_VAL                  10:0 /* RW */ 

#define NV04_PRAMDAC_FP_CHECKSUM                             0x00680840 /* RW */ 
#define NV04_PRAMDAC_FP_CHECKSUM_VAL                    23:0 /* R- */ 
#define NV04_PRAMDAC_FP_CHECKSUM_STATUS                 24:24 /* R- */ 
#define NV04_PRAMDAC_FP_CHECKSUM_STATUS_CAPTURED             0x00000001 /* R- */ 
#define NV04_PRAMDAC_FP_CHECKSUM_STATUS_WAITING              0x00000000 /* R- */ 
#define NV04_PRAMDAC_FP_VSYNC                           28:28 /* R- */ 
#define NV04_PRAMDAC_FP_VSYNC_LOW                            0x00000000 /* R- */ 
#define NV04_PRAMDAC_FP_VSYNC_HIGH                           0x00000001 /* R- */ 

#define NV04_PRAMDAC_FP_TEST_CONTROL                         0x00680844 /* RW */ 
#define NV04_PRAMDAC_FP_TEST_CONTROL_CRC_RESET           0:0            /* RW */ 
#define NV04_PRAMDAC_FP_TEST_CONTROL_CRC_RESET_DEASSERTED    0x00000000 /* RW */ 
#define NV04_PRAMDAC_FP_TEST_CONTROL_CRC_RESET_ASSERTED      0x00000001 /* RW */ 
#define NV04_PRAMDAC_FP_TEST_CONTROL_CRC_ENABLE          4:4            /* RW */ 
#define NV04_PRAMDAC_FP_TEST_CONTROL_CRC_ENABLE_DEASSERTED   0x00000000 /* RW */ 
#define NV04_PRAMDAC_FP_TEST_CONTROL_CRC_ENABLE_ASSERTED     0x00000001 /* RW */ 
#define NV04_PRAMDAC_FP_TEST_CONTROL_CRC_CHANNEL         9:8            /* RW */ 
#define NV04_PRAMDAC_FP_TEST_CONTROL_CRC_CHANNEL_7_0         0x00000000 /* RW */ 
#define NV04_PRAMDAC_FP_TEST_CONTROL_CRC_CHANNEL_15_8        0x00000001 /* RW */ 
#define NV04_PRAMDAC_FP_TEST_CONTROL_CRC_CHANNEL_23_16       0x00000002 /* RW */ 
#define NV04_PRAMDAC_FP_TEST_CONTROL_CRC_CAPTURE        10:10            /* RW */ 
#define NV04_PRAMDAC_FP_TEST_CONTROL_CRC_CAPTURE_ALWAYS      0x00000000 /* RW */ 
#define NV04_PRAMDAC_FP_TEST_CONTROL_CRC_CAPTURE_ONE         0x00000001 /* RW */ 

#define NV04_PRAMDAC_FP_TG_CONTROL                           0x00680848 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_VSYNC                1:0             /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_VSYNC_NEG                 0x00000000 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_VSYNC_POS                 0x00000001 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_VSYNC_DISABLE             0x00000002 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_VSYNC_RSVD                0x00000003 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_HSYNC                5:4             /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_HSYNC_NEG                 0x00000000 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_HSYNC_POS                 0x00000001 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_HSYNC_DISABLE             0x00000002 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_HSYNC_RSVD                0x00000003 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_MODE                 9:8             /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_MODE_SCALE                0x00000000 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_MODE_CENTER               0x00000001 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_MODE_NATIVE               0x00000002 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_CENTER              13:12            /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_CENTER_NONE               0x00000000 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_CENTER_HORIZ              0x00000001 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_CENTER_VERT               0x00000002 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_CENTER_BOTH               0x00000003 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_NATIVE              17:16            /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_NATIVE_NONE               0x00000000 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_NATIVE_HORIZ              0x00000001 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_NATIVE_VERT               0x00000002 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_NATIVE_BOTH               0x00000003 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_READ                20:20            /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_READ_ACTUAL               0x00000000 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_READ_PROG                 0x00000001 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_WIDTH               24:24            /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_WIDTH_24                  0x00000000 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_WIDTH_12                  0x00000001 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_DISPEN              29:28            /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_DISPEN_NEG                0x00000000 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_DISPEN_POS                0x00000001 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_DISPEN_DISABLE            0x00000002 /* RW */ 
#define NV04_PRAMDAC_FP_TG_CONTROL_DISPEN_RSVD               0x00000003 /* RW */ 

#define NV04_PRAMDAC_FP_DEBUG_0                              0x00680880 /* RW */ 
#define NV04_PRAMDAC_FP_DEBUG_1                              0x00680884 /* RW */ 
#define NV04_PRAMDAC_FP_DEBUG_2                              0x00680888 /* RW */ 
#define NV04_PRAMDAC_FP_DEBUG_3                              0x0068088c /* R- */ 

#define NV04_PRAMDAC_FP_RAM_CONTROL                          0x006808A0 /* RW */ 
#define NV04_PRAMDAC_FP_RAM_CONTROL_ADDRESS             8:0             /* RW */ 
#define NV04_PRAMDAC_FP_RAM_CONTROL_TESTMODE           16:16            /* RW */ 
#define NV04_PRAMDAC_FP_RAM_CONTROL_TESTMODE_DISABLE         0x00000000 /* RW */
#define NV04_PRAMDAC_FP_RAM_CONTROL_TESTMODE_ENABLE          0x00000001 /* RW */ 

#define NV04_PRAMDAC_FP_RAM_DATA_0                           0x006808A4 /* RW */ 
#define NV04_PRAMDAC_FP_RAM_DATA_0_VAL                 31:0             /* RW */ 

#define NV04_PRAMDAC_FP_RAM_DATA_1                           0x006808A8 /* RW */ 
#define NV04_PRAMDAC_FP_RAM_DATA_1_VAL                 31:0             /* RW */ 

#define NV04_PRAMDAC_FP_RAM_DATA_2                           0x006808AC /* RW */ 
#define NV04_PRAMDAC_FP_RAM_DATA_2_VAL                  7:0             /* RW */ 

#define NV04_USER_DAC_PIXEL_MASK                             0x006813C6 /* RW */ 
#define NV04_USER_DAC_PIXEL_MASK_VALUE                  7:0             /* RW */ 
#define NV04_USER_DAC_PIXEL_MASK_MASK                        0x000000FF /* RW */ 

#define NV04_USER_DAC_READ_MODE_ADDRESS                      0x006813C7 /* RW */ 
#define NV04_USER_DAC_READ_MODE_ADDRESS_VALUE           7:0             /* RW */ 
#define NV04_USER_DAC_READ_MODE_ADDRESS_WO_VALUE        7:0             /* -W */ 
#define NV04_USER_DAC_READ_MODE_ADDRESS_RW_STATE        1:0             /* R- */ 
#define NV04_USER_DAC_READ_MODE_ADDRESS_RW_STATE_WRITE       0x00000000 /* R- */ 
#define NV04_USER_DAC_READ_MODE_ADDRESS_RW_STATE_READ        0x00000003 /* R- */ 

#define NV04_USER_DAC_WRITE_MODE_ADDRESS                     0x006813C8 /* RW */ 
#define NV04_USER_DAC_WRITE_MODE_ADDRESS_VALUE          7:0             /* RW */

#define NV04_USER_DAC_PALETTE_DATA                           0x006813C9 /* RW */ 
#define NV04_USER_DAC_PALETTE_DATA_VALUE                7:0             /* RW */ 

