_Nv04_VideoUser * Nv04_NewUser(_Nv04Device * nv , char *UserName )
{
  _Nv04_VideoUser * newuser = 0 ;

  newuser = os->NewCildObjn( nv->Users , sizeof(_Nv04_VideoUser) , UserName ) ;
  return(newuser) ;
}

void Nv04_SwitchUser(_Nv04Device * nv , _Nv04_VideoUser * user )
{

}

#define Nv04_BUFFER_2D_DEST    0x00000000
#define Nv04_BUFFER_2D_SRC     0x00000001
#define Nv04_BUFFER_3D_COLOR   0x00000002
#define Nv04_BUFFER_3D_ZETA    0x00000003

void Nv04_SetupSurface(_Nv04Device *nv , unsigned long buffer , unsigned long base , unsigned long limit , unsigned long pitch , unsigned long depth )
{
  unsigned long data ;
  printf("Nv04: SetupSurface [%ld] base = 0x%8.8lX limit = 0x%8.8lX pitch = 0x%8.8lX depth = 0x%8.8lX\n",buffer,base,limit,pitch,depth) ;  

  setreg( NV_PGRAPH_BBASE(buffer)   , 0x00000000 ) ;
  setreg( NV_PGRAPH_BOFFSET(buffer) , base       ) ;
  setreg( NV_PGRAPH_BPITCH(buffer)  , pitch      ) ;
  setreg( NV_PGRAPH_BLIMIT(buffer)  , limit      ) ;

  data  =  getreg( NV_PGRAPH_BPIXEL ) & ~( 0x0000000f << ( buffer * 4)) ;
  data |= (depth << ( buffer * 4)) ;
  setreg( NV_PGRAPH_BPIXEL , data ) ;

  setreg( NV_PGRAPH_SURFACE   , NV_PGRAPH_SURFACE_TYPE_NON_SWIZZLE << (0 ? NV_PGRAPH_SURFACE_TYPE) ) ; 
  setreg( NV_PGRAPH_BSWIZZLE2 , 0x00000000 ) ;
  setreg( NV_PGRAPH_BSWIZZLE5 , 0x00000000 ) ;

  setreg( NV_PGRAPH_STATE , getreg( NV_PGRAPH_STATE   ) | ( 0x00000101 << buffer )) ;


}

void Nv04_SetupUserClip(_Nv04Device *nv , unsigned long x , unsigned long y , unsigned long sizex , unsigned long sizey )
{
  setreg( NV_PGRAPH_ABS_UCLIP_XMIN  , x ) ;
  setreg( NV_PGRAPH_ABS_UCLIP_YMIN  , y ) ;
  setreg( NV_PGRAPH_ABS_UCLIP_XMAX  , x + sizex ) ;
  setreg( NV_PGRAPH_ABS_UCLIP_YMAX  , x + sizey ) ;

  setreg( NV_PGRAPH_ABS_UCLIPA_XMIN , x ) ;
  setreg( NV_PGRAPH_ABS_UCLIPA_YMIN , y ) ;
  setreg( NV_PGRAPH_ABS_UCLIPA_XMAX , x + sizex ) ;
  setreg( NV_PGRAPH_ABS_UCLIPA_YMAX , x + sizey ) ;

  setreg( NV_PGRAPH_VALID1          , getreg( NV_PGRAPH_VALID1 ) & 0x0fffffff ) ;  
					
}

void Nv04_InitUser(_Nv04Device * nv , _Nv04_VideoUser * user )
{
  unsigned long * screen , i , ScreenSize , ZBufferSize , TexturCacheSize , BandWidthPeekBPS , depth ; 
  switch ( user->ColourDepth )
    {
    case 15: user->BytesPerPixel = 2 ; break ;
    case 16: user->BytesPerPixel = 2 ; break ; 
    case 24: user->BytesPerPixel = 4 ; break ;
    default: user->BytesPerPixel = 4 ; break ;
    }

  for ( i = 0x00010000 ; i < 0x00100000 ; i = i + 4 ) 
    {
      setreg((0 ? NV04_PRAMIN) + i , 0x00000000) ;
      if( getreg((0 ? NV04_PRAMIN) + i) != 0x00000000 ) printf("Nv04: BAD PRAMIN at offset 0x%8.8lX\n",i) ;
    }
  
  user->LocalRamTotal = nv->info.Fb->MemSize ;

  user->DmaCmd.mem.Base     =  Nv04_DMA_COMMAND_RING_BASE ;
  user->DmaCmd.mem.Limit    =  Nv04_DMA_COMMAND_RING_SIZE - 1 ; 
  user->DmaCmd.mem.PhysAddr = user->DmaCmd.mem.Base ;
  
  user->DmaCmd.mem.UserAddr = os->MapPhys( user->DmaCmd.mem.PhysAddr , (user->DmaCmd.mem.Limit + 1)) ;
  
  user->DmaCmd.Buffer        =  (void *) user->DmaCmd.mem.UserAddr ;
  user->DmaCmd.BufferMask    =  user->DmaCmd.mem.Limit >> 2    ;
  user->DmaCmd.Put           = 0x00000000 ;
  user->DmaCmd.Get           = 0x00000000 ;

  user->DmaCmd.PtCount       = ( user->DmaCmd.mem.Limit + 1 ) / 0x1000 ;

  user->DmaCmd.DmaInst       = Nv04_MakeDmaInstance(nv ,user->DmaCmd.mem.PhysAddr , user->DmaCmd.mem.Limit) ; 

  if(Nv04_DMA_COMMAND_RING_TEST)
    {
      for ( i = 0 ; i <= user->DmaCmd.BufferMask ; i++ ) user->DmaCmd.Buffer[i] = i ;
      for ( i = 0 ; i <= user->DmaCmd.BufferMask ; i++ ) if ( user->DmaCmd.Buffer[i] != i ) break ;
      
      if ( i > user->DmaCmd.BufferMask ) 
	printf("Nv04: DmaRingBuffer test = ok\n") ;
      else
	{ printf("Nv04: DmaRingBuffer test = !FLUAT at offset 0x%8.8lX  0x%8.8lX != 0x%8.8lX\n",( i << 2) , user->DmaCmd.Buffer[i]  , i )   ; return ; }
    }

  printf( "Nv04: DmaRingBuffer phys = 0x%8.8lX virt = 0x%8.8lX  DmaInst = 0x%8.8lX PtCount = 0x%8.8lX\n",
	  user->DmaCmd.mem.PhysAddr,
	  (unsigned long) user->DmaCmd.mem.UserAddr,
	  user->DmaCmd.DmaInst->base,
	  user->DmaCmd.PtCount
	  ) ; 
  


  /* AllocBuffers */
  user->BytesPerLine  = user->X                  * user->BytesPerPixel  ;
  ScreenSize          = user->Y                  * user->BytesPerLine   ;
  ZBufferSize         = ScreenSize ;
  TexturCacheSize     = user->LocalRamTotal - ( ( ScreenSize * 2) + ZBufferSize + 0x1000 ) ;     

  BandWidthPeekBPS    = user->Timing.PixelClock  * user->BytesPerPixel ;  

  user->Screen        = Nv04_AllocLocalMem( nv->info.Fb , ScreenSize      , 0x1000 , 0x0000 , "MainScreen" ) ;
  user->BackBuffer    = Nv04_AllocLocalMem( nv->info.Fb , ScreenSize      , 0x1000 , 0x0000 , "BackOrFlipScreen" ) ;
  user->ZBuffer       = Nv04_AllocLocalMem( nv->info.Fb , ZBufferSize     , 0x1000 , 0x0000 , "ZBuffer" ) ;
  user->TexturCache   = Nv04_AllocLocalMem( nv->info.Fb , TexturCacheSize , 0x1000 , 0x0000 , "TexturCache" ) ; 


  user->CtxDmaTexturCache  = Nv04_MakeCtxDmaInstance(nv , 0x00000000 , user->TexturCache->size - 1 , Nv04_CtxDma_NVM ) ;


  user->TexturBuffer.PhysAddr = Nv04_DMA_TEXTURE_BUFFER_BASE     ;
  user->TexturBuffer.Limit    = Nv04_DMA_TEXTURE_BUFFER_SIZE - 1 ;
  
  user->TexturBuffer.UserAddr = os->MapPhys( user->TexturBuffer.PhysAddr , (user->TexturBuffer.Limit + 1)) ;

  user->CtxDmaTexturBuffer  = Nv04_MakeCtxDmaInstance(nv , 0x00000000 , user->TexturBuffer.Limit , Nv04_CtxDma_System ) ;

  /* init dac and screen */ 

  Nv04_dacSetPixelClock( nv , user->Timing.PixelClock ) ;
  Nv04_dacInitDac(nv ) ;
  Nv04_dacStartDac(nv   , user ) ;
  Nv04_dacStartImage(nv , user ) ;
  Nv04_dacImageOnOff(nv , 1) ;


    Nv04_grInit(nv) ;

  /* setup surfaces */

  depth = NV_PGRAPH_BPIXEL_DEPTH0_X8R8G8B8_Z8R8G8B8 ;
  
  Nv04_SetupSurface(nv , Nv04_BUFFER_2D_DEST  , user->Screen->base , user->Screen->size  - 1 , user->BytesPerLine , depth ) ; 
  Nv04_SetupSurface(nv , Nv04_BUFFER_2D_SRC   , user->Screen->base , user->Screen->size  - 1 , user->BytesPerLine , depth ) ; 
  Nv04_SetupSurface(nv , Nv04_BUFFER_3D_COLOR , user->Screen->base , user->Screen->size  - 1 , user->BytesPerLine , depth ) ; /* will be back buffer */ 
  Nv04_SetupSurface(nv , Nv04_BUFFER_3D_ZETA  , user->Screen->base , user->ZBuffer->size - 1 , user->BytesPerLine , depth ) ; 

  /* setup user clip */

  Nv04_SetupUserClip(nv , 0 , 0 , user->Y , user->Y ) ;  


  /* load acc functions */

  Nv04_SetGrObjects( nv , user ) ;
  PrintHash( nv ) ;


  /* set up palette for gamer RGB */
  for ( i = 0 ; i <= 0xff ; i++ ) { user->Palette[i] = ( i << 16 ) | ( i << 8 ) | i ; }
  Nv04_dacLoadPalette(nv , user->Palette) ;


  /* a simple test patten */
  screen = nv->info.Fb->mem.UserAddr + user->Screen->base ;
  for ( i = 0 ; i < ((ScreenSize >> 2) / 2) ; i++ ) { screen[i] = (i << 8) ; }

  /* set cr user */
  nv->CrUser = user ;
  
}

void TestUser(_Nv04Device * nv)
{
  unsigned long i ;
  _Nv04_VideoUser * user1 ;

  user1 = Nv04_NewUser(nv , "user1" ) ;
  if (!user1) { printf("new user faild\n") ; return ; }
  
  i = Nv04_TEST_VIDEO_RES ;
  
  user1->Timing.PixelClock = td[i].PixelClock ;
  
  user1->Timing.HSync      = td[i].HSync      ;
  user1->Timing.HSyncStart = td[i].HSyncStart /  100 ;
  user1->Timing.HSyncTime  = td[i].HSyncTime  / 1000  ;
  
  user1->Timing.VSync      = td[i].VSync      ;
  user1->Timing.VSyncStart = td[i].VSyncStart /  100 ;
  user1->Timing.VSyncTime  = td[i].VSyncTime  / 1000 ;
  
  user1->X = td[i].DisplayX ;
  user1->Y = td[i].DisplayY ;
  
  user1->ViewX = user1->X ;
  user1->ViewY = user1->Y ;
      
  user1->ColourDepth = Nv04_TEST_VIDEO_DEPTH ;

  Nv04_InitUser( nv , user1 ) ;

  for ( i = 0 ; i < 5 ; i ++ ) printf("Nv04: [%ld] base = 0x%8.8lX offset = 0x%8.8lX limit = 0x%8.8lX pitch = 0x%8.8lX\n",
				      i,
				      getreg(NV_PGRAPH_BBASE(i)   ) , 
				      getreg(NV_PGRAPH_BOFFSET(i) ) , 
				      getreg(NV_PGRAPH_BLIMIT(i)  ) , 
				      getreg(NV_PGRAPH_BPITCH(i)  )
				      ) ;

  Nv04_PrintReg( NV_PGRAPH_BPIXEL  ,    getreg( NV_PGRAPH_BPIXEL  ) , 0 , "Nv04: ") ;
  Nv04_PrintReg( NV_PGRAPH_STATE   ,    getreg( NV_PGRAPH_STATE   ) , 0 , "Nv04: ") ;

  if(0) 
    Nv04_fifoSetupNv03ChannelPio(nv , 0 , 0x0200 ) ;
  else
    Nv04_fifoSetupNv04ChannelDma(nv , user1 , 0 ) ; 
  TestDma(nv , nv->CrUser) ;

}
