

	BITS 32
	GLOBAL GetCpuTime
	GLOBAL OutPB
	GLOBAL OutPW
	GLOBAL OutPL
	GLOBAL OutIPB
	GLOBAL InPB
	GLOBAL InPW
	GLOBAL InPL
	GLOBAL InIPB
	GLOBAL FPU_test
	GLOBAL FPU_round
	GLOBAL FPU_sin
	GLOBAL FPU_pi	
	GLOBAL testre
	GLOBAL SerialInit
	GLOBAL SerialTxByte
	GLOBAL SerialTxString

;	SECTION .data

Serial:
	dd 0x000002f8  ; [0] port
	dd 0x00000003  ; [1] IrqHW
	dd 0x00000000  ; [2] IrqVector
	dd    1843200  ; [3] RefClock

	dd     115200  ; [4] BaudRate 
	
	dd 0x00000000  ; [5] divisor 

;	SECTION .text
SerialInit:
	mov  eax  , 0x0003 
	mov  eax  , [ Serial + eax * 4] 
	xor  edx  , edx
	mov  ebx  , 0x0004 
	mov  ebx  , [ Serial + ebx * 4]
	shl  ebx  , 0x0004
	div  ebx
	mov  ebx  , 0x0005 
;	mov  [ ds: Serial + ebx * 4] , eax
	push eax

	mov  edx , [ Serial ]
	add  edx ,  0x0003
	in    al ,  dx
	or    al ,  0x0080
	out   dx ,  al 


	mov  edx , [ Serial ]
	
;	mov  ebx ,  Serial
;	mov  ecx ,  0x0005
;	mov   al , [ ebx + 0x0000 + ecx * 4 ]
	
	pop  eax
 	
	out   dx ,   al
	inc   dx

	shr  eax ,  8
	
;	mov  ebx ,  Serial
;	mov  ecx ,  0x0005
;	mov   al , [ ebx + 0x0001 + ecx * 4 ]


	out   dx ,   al

	mov  edx , [ Serial ]
	add  edx ,  0x0003
	in    al ,  dx
	and   al ,  0x007f
	out   dx ,  al 

	mov  edx , [ Serial ]
	add  edx ,  0x0001
	mov   al ,  0x0000       ; No interrupts
	out   dx ,  al 

	mov  edx , [ Serial ]
	add  edx ,  0x0002
	mov   al ,  0x0000       ; fifo trigger level 1 byte
	out   dx ,  al 

	mov  edx , [ Serial ]
	add  edx ,  0x0003
	mov   al ,  0x0003      ; N81
	out   dx ,  al 


	mov  edx , [ Serial ]
	add  edx ,  0x0004
	mov   al ,  0x0003
	out   dx ,  al          
	
	ret

SerialTxByte:
	mov   bl ,  al

	mov  edx , [  Serial ]
	add  edx ,  0x0006
SerialLoop1:
	in    al ,  dx
	and   al , 0x10
	cmp   al , 0x00
	je  SerialLoop1
	mov   al ,  bl

	mov  edx , [  Serial ]
	add  edx ,  0x0005

SerialLoop2:
	in    al ,  dx
	and   al , 0x60
	cmp   al , 0x00
	je  SerialLoop2

	mov   al ,  bl
	mov  edx , [  Serial ]
	out   dx ,  al 
	ret

; SerialTxString( unsigned long  * ptr)

SerialTxString:
	push ebp
	mov  ebp , esp
	mov  esi , [ ebp + 8 ]
	cld
SerialN2:
	lodsb
	cmp    al , 0x00
	je   SerialN1
	cmp    al , 0x0a
	je   SerialNL
SerialN5:
	call SerialTxByte
	jmp  SerialN2 

SerialNL:
	call SerialTxByte
	mov    al , 0x0d	
	jmp SerialN5

SerialN1:
	pop  ebp
	ret


;  GetCpuClock(long long * count) 

GetCpuTime:
	rdtsc
	ret

;  void OutPB(long port , unsigned char data)
OutPB:
	push  ebp
	mov   ebp ,  esp
	mov    al , [ebp + 12]
	mov   edx , [ebp +  8]
	out    dx ,   al
	pop   ebp
	ret

;  void OutPB(long port , unsigned char data)
OutPW:
	push  ebp
	mov   ebp ,  esp
	mov    ax , [ebp + 12]
	mov   edx , [ebp +  8]
	out    dx ,   ax
	pop   ebp
	ret

;  void OutPB(long port , unsigned char data)
OutPL:
	push  ebp
	push  eax
	push  edx
	mov   ebp ,  esp
	mov   eax , [ebp + 0x14]
	mov   edx , [ebp + 0x10]
	out    dx ,  eax
	pop   edx
	pop   eax
	pop   ebp
	ret



;	unsigned char InPB(unsigned long port)
InPB:
	push  ebp
	push  edx
	mov   ebp ,  esp
	mov   edx , [ebp +  0x0c]
	in     al ,   dx
	pop   edx
	pop   ebp
	ret


;	unsigned short InPW(unsigned long port)
InPW:
	push  ebp
	push  edx
	mov   ebp ,  esp
	mov   edx , [ebp +  0x0c]
	in     ax ,   dx
	pop   edx
	pop   ebp
	ret


;	unsigned  long  InPL(unsigned long port)
InPL:
	push  ebp
	push  edx
	mov   ebp ,  esp
	mov   edx , [ebp +  0x0c]
	in    eax ,   dx
	pop   edx
	pop   ebp
	ret

;      void OutIPB(unsigned long IndexPort , unsigned char index , unsigned char data)

OutIPB:
	push  ebp
	push  edx
	mov   ebp ,  esp
	mov    al , [ebp + 12]
	mov   edx , [ebp +  8]
	out    dx ,   al
	mov    al , [ebp + 13]
	inc   edx
	out    dx ,   al
	pop   edx
	pop   ebp
	ret

;      unsigned char InIPB(unsigned long IndexPort , unsigned char index )

InIPB:
	push  ebp
	push  edx
	mov   ebp ,  esp
	mov    al , [ebp + 12]
	mov   edx , [ebp +  8]
	out    dx ,   al
	mov    al , [ebp + 13]
	inc   edx
	in     al ,   dx
	pop   edx
	pop   ebp
	ret


FPU_test:
	push  ebp
	mov   ebp ,  esp
	mov   edx , [ebp +  8]

	fninit
	fldpi
	fldpi
	fmul st0 ,st1
	fldpi
	fldz
	fld1
	fcos
	fldl2e 
	fnsave [edx]
	fwhat
	pop   ebp
	ret

FPU_round:
	fld tword [esp + 4]
	frndint
	ret


FPU_sin:
	fld  tword [ esp + 4]
	fsin
	ret

FPU_cos:
	fld  tword [ esp + 4]
	fcos
	ret

FPU_tan:
	fld  tword [ esp + 4]
	ftan
	ret

FPU_pi:
	fldpi
	ret

testre:
	mov eax , 0x01234567
	mov ebx , 0x76543210 
	mov ecx , 0x12341234
	mov edx , 0x22222222
	fninit
	fldpi
	ret




;-----------serial---------------------------------------------------------------------------










