#include "obj.h"

#define printl printf
#define LEXOS_ENABLE_SMP_LOCK(a) ;
#define LEXOS_FREE_SMP_LOCK(a) ;

typedef struct
{
  unsigned long  VendorId ;
  unsigned long  DeviceId ;
  unsigned long  note     ;
} _pcidev ;

typedef struct
{
  _pcidev       *dev     ;
  void          *driver   ;
  void          *prev     ;
  void          *next     ;
} _pcilist ;






typedef struct
{
  void * (* calloc )      (unsigned long ) ;
  void * (* MapPhys)      (unsigned long , unsigned long ) ;
  void * (* NewCildObj)   ( void * , unsigned long ) ;
  void * (* NewCildObjn)  ( void * , unsigned long , unsigned char * ) ;
  void   (* RemoveObj)    ( void * ) ;
  void   (* dumpobjlist)  ( void * ) ;

} _OsCalls ;


#define LEXOS_COMMAND_DRIVER_INIT_PCI_DEVICES   0x00000100
#define LEXOS_COMMAND_DRIVER_CLOSE_ALL_DEVICES  0x00000110 

#define LEXOS_COMMAND_STATUS_ALL_OK             0x00000200
#define LEXOS_COMMAND_STATUS_FAULT              0x00000201
#define LEXOS_COMMAND_STATUS_NEW                0x00000202


#define LEXOS_COMMAND_KERNEL_ALLOC_MEM          0x00000300

#define LEXOS_COMMAND_KERNEL_MAP_PHYS           0x00000320




typedef struct
{
  unsigned long Command         ; 
  unsigned long Pir             ;
  unsigned long status          ;
  long long MaxTime             ;
  long long BaseTime            ;
  long long CompleshionTime     ;
  void * dependint              ;
  void * initPrams              ;
  void          * results                ;
  void          * DriverId               ;
  void          * pervCommand            ;
  void          * nextCommand            ;
  unsigned long   size            ;

} _CommandChannelData ;





typedef struct
{
  _OsCalls  *OsCall ;
  void  (* DriverToKernelChannel ) ( _CommandChannelData  *) ; 
  void  (* KernelToDriverChannel ) ( _CommandChannelData  *) ;

} _CommandChannel ;

#define DriverClass_Old_VGA     0x00000000 
#define DriverClass_Video3D     0x00000002 

#define LEXOS_DRIVER_STATUS_NOT_LOADED 0x00000000 

typedef struct
{
  unsigned long    DriverClass    ;
  unsigned char   *DriverNameVer  ;
  unsigned char   *UserInfo       ;    
  long long        time           ;
  unsigned long    status         ;
  _CommandChannel  cmdch          ;
  _pcidev         *devs           ;
  _ObjHeader      *root           ;
} _DriverInfo ;


#define NVK_LOCAL_MEM  0x00000000 

#define LEXOS_MEM_INSTANCE_FREE  0x00000000 
#define LEXOS_MEM_INSTANCE_INUSE 0x00000001

typedef struct
{
  _ObjHeader     obj   ;
  unsigned long  Base     ;
  unsigned long  Limit    ;
  unsigned long  PhysAddr ;
  unsigned long *KernAddr ;
  unsigned long *UserAddr ;
  unsigned long  KernelId ;
  unsigned long  UserId   ;
  unsigned long  MemType  ;  
} _MemObj ;

typedef struct
{
  _ObjHeader    obj   ;
  unsigned long base  ;
  unsigned long size  ;
  unsigned long flags ;
} _MemInstance ;

typedef struct
{
  _ObjHeader  obj ;
  _MemObj     mem ;
  unsigned long MemSize ;
  unsigned long Free    ; 
} _MemHeader ;



typedef struct
{
  


  void * localmem ;

  void * CrUser   ;
  void * UserList ;

} Nv04_DevObj ; 
